type token =
  | TUnknown of (Ast_c.info)
  | TCommentSpace of (Ast_c.info)
  | TCommentNewline of (Ast_c.info)
  | TComment of (Ast_c.info)
  | TInt of ((string * (Ast_c.sign * Ast_c.base)) * Ast_c.info)
  | TFloat of ((string * Ast_c.floatType) * Ast_c.info)
  | TChar of ((string * Ast_c.isWchar) * Ast_c.info)
  | TString of ((string * Ast_c.isWchar) * Ast_c.info)
  | TQuote of ((string * Ast_c.isWchar) * Ast_c.info)
  | TPct of (Ast_c.info)
  | TFormat of (string * Ast_c.info)
  | TSubString of (string * Ast_c.info)
  | TDecimal of ((string * string (*n*) * string (*p*)) * Ast_c.info)
  | TIdent of (string * Ast_c.info)
  | TKRParam of (string * Ast_c.info)
  | Tconstructorname of (string * Ast_c.info)
  | TypedefIdent of (string * Ast_c.info)
  | TOPar of (Ast_c.info)
  | TCPar of (Ast_c.info)
  | TOBrace of (Ast_c.info)
  | TCBrace of (Ast_c.info)
  | TOCro of (Ast_c.info)
  | TCCro of (Ast_c.info)
  | TDot of (Ast_c.info)
  | TComma of (Ast_c.info)
  | TPtrOp of (Ast_c.info)
  | TInc of (Ast_c.info)
  | TDec of (Ast_c.info)
  | TAssign of (Ast_c.assignOp)
  | TEq of (Ast_c.info)
  | TWhy of (Ast_c.info)
  | TTilde of (Ast_c.info)
  | TBang of (Ast_c.info)
  | TEllipsis of (Ast_c.info)
  | TDotDot of (Ast_c.info)
  | TPtVirg of (Ast_c.info)
  | TOrLog of (Ast_c.info)
  | TAndLog of (Ast_c.info)
  | TOr of (Ast_c.info)
  | TXor of (Ast_c.info)
  | TAnd of (Ast_c.info)
  | TEqEq of (Ast_c.info)
  | TNotEq of (Ast_c.info)
  | TInf of (Ast_c.info)
  | TSup of (Ast_c.info)
  | TInfEq of (Ast_c.info)
  | TSupEq of (Ast_c.info)
  | TShl of (Ast_c.info)
  | TShr of (Ast_c.info)
  | TPlus of (Ast_c.info)
  | TMinus of (Ast_c.info)
  | TMul of (Ast_c.info)
  | TDiv of (Ast_c.info)
  | TMod of (Ast_c.info)
  | TMax of (Ast_c.info)
  | TMin of (Ast_c.info)
  | Tchar of (Ast_c.info)
  | Tshort of (Ast_c.info)
  | Tint of (Ast_c.info)
  | Tdouble of (Ast_c.info)
  | Tfloat of (Ast_c.info)
  | Tcomplex of (Ast_c.info)
  | Tlong of (Ast_c.info)
  | Tunsigned of (Ast_c.info)
  | Tsigned of (Ast_c.info)
  | Tvoid of (Ast_c.info)
  | Tsize_t of (Ast_c.info)
  | Tssize_t of (Ast_c.info)
  | Tptrdiff_t of (Ast_c.info)
  | Tauto of (Ast_c.info)
  | Tregister of (Ast_c.info)
  | Textern of (Ast_c.info)
  | Tstatic of (Ast_c.info)
  | Ttypedef of (Ast_c.info)
  | Tconst of (Ast_c.info)
  | Tvolatile of (Ast_c.info)
  | Tstruct of (Ast_c.info)
  | Tunion of (Ast_c.info)
  | Tenum of (Ast_c.info)
  | Tdecimal of (Ast_c.info)
  | Texec of (Ast_c.info)
  | Tbreak of (Ast_c.info)
  | Telse of (Ast_c.info)
  | Tswitch of (Ast_c.info)
  | Tcase of (Ast_c.info)
  | Tcontinue of (Ast_c.info)
  | Tfor of (Ast_c.info)
  | Tdo of (Ast_c.info)
  | Tif of (Ast_c.info)
  | Twhile of (Ast_c.info)
  | Treturn of (Ast_c.info)
  | Tgoto of (Ast_c.info)
  | Tdefault of (Ast_c.info)
  | Tsizeof of (Ast_c.info)
  | Tnew of (Ast_c.info)
  | Tdelete of (Ast_c.info)
  | Tdefined of (Ast_c.info)
  | TOParCplusplusInit of (Ast_c.info)
  | Tnamespace of (Ast_c.info)
  | Trestrict of (Ast_c.info)
  | Tasm of (Ast_c.info)
  | Tattribute of (Ast_c.info)
  | TattributeNoarg of (Ast_c.info)
  | Tinline of (Ast_c.info)
  | Ttypeof of (Ast_c.info)
  | TDefine of (Ast_c.info)
  | TDefParamVariadic of ((string * Ast_c.info))
  | TCppEscapedNewline of (Ast_c.info)
  | TCppConcatOp of (Ast_c.info)
  | TOParDefine of (Ast_c.info)
  | TOBraceDefineInit of (Ast_c.info)
  | TIdentDefine of ((string * Ast_c.info))
  | TDefEOL of (Ast_c.info)
  | TInclude of ((string * string * bool ref * Ast_c.info))
  | TIncludeStart of ((Ast_c.info * bool ref))
  | TIncludeFilename of ((string * Ast_c.info))
  | TIfdef of ((Ast_c.ifdef_guard * (int * int) option ref * Ast_c.info))
  | TIfdefelif of ((Ast_c.ifdef_guard * (int * int) option ref * Ast_c.info))
  | TIfdefelse of (((int * int) option ref * Ast_c.info))
  | TEndif of (((int * int) option ref * Ast_c.info))
  | TIfdefBool of ((bool * (int * int) option ref * Ast_c.info))
  | TIfdefMisc of ((bool * (int * int) option ref * Ast_c.info))
  | TIfdefVersion of ((bool * (int * int) option ref * Ast_c.info))
  | TUifdef of (Ast_c.info)
  | TUelseif of (Ast_c.info)
  | TUendif of (Ast_c.info)
  | TUndef of (Ast_c.info)
  | TPrePragma of (Ast_c.info*Ast_c.info*string*Ast_c.info*Ast_c.info*(string*Ast_c.info)list)
  | TPragma of (Ast_c.info)
  | TPragmaString of (string * Ast_c.info)
  | TCppDirectiveOther of (Ast_c.info)
  | TMacroAttr of ((string * Ast_c.info))
  | TMacroEndAttr of ((string * Ast_c.info))
  | TMacroStmt of ((string * Ast_c.info))
  | TMacroIdentBuilder of ((string * Ast_c.info))
  | TMacroString of ((string * Ast_c.info))
  | TMacroDecl of ((string * Ast_c.info))
  | TMacroDeclConst of (Ast_c.info)
  | TMacroIterator of ((string * Ast_c.info))
  | TCommentSkipTagStart of (Ast_c.info)
  | TCommentSkipTagEnd of (Ast_c.info)
  | TCParEOL of (Ast_c.info)
  | TAction of (Ast_c.info)
  | TCommentMisc of (Ast_c.info)
  | TCommentCpp of ((Token_c.cppcommentkind * Ast_c.info))
  | EOF of (Ast_c.info)
  | TTODO of (Ast_c.info)

open Parsing;;
let _ = parse_error;;
# 2 "parsing_c/parser_c.mly"
(* Yoann Padioleau
 *
 * Copyright (C) 2002, 2006, 2007, 2008, 2009 Yoann Padioleau
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License (GPL)
 * version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * file license.txt for more details.
 *)

(**
 * This grammar has been inspired by:
 * http://www.lysator.liu.se/c/ANSI-C-grammar-y.html
 *)

open Common

open Ast_c

module LP = Lexer_parser
open Lexer_parser (* for the fields *)

open Semantic_c (* Semantic exn *)
module T = Token_c

(*****************************************************************************)
(* Wrappers *)
(*****************************************************************************)
let warning s v =
  if !Flag_parsing_c.verbose_parsing
  then Common.warning ("PARSING: " ^ s) v
  else v

let computed_warning s v = (*do not construct string unless it will be shown*)
  if !Flag_parsing_c.verbose_parsing
  then Common.warning ("PARSING: " ^ (s())) v
  else v

let pr2, pr2_once = Common.mk_pr2_wrappers Flag_parsing_c.verbose_parsing

(*****************************************************************************)
(* Parse helpers functions *)
(*****************************************************************************)

(*-------------------------------------------------------------------------- *)
(* Type related *)
(*-------------------------------------------------------------------------- *)

type shortLong      = Short  | Long | LongLong

type decl = {
  storageD: storagebis wrap;
  typeD: ((sign option) * (shortLong option) * (typeCbis option)) wrap;
  qualifD: typeQualifierbis wrap;
  inlineD: bool             wrap;
  (* note: have a full_info: parse_info list; to remember ordering
   * between storage, qualifier, type ? well this info is already in
   * the Ast_c.info, just have to sort them to get good order *)
}

let nullDecl = {
  storageD = NoSto, [];
  typeD = (None, None, None), [];
  qualifD = nullQualif;
  inlineD = false, [];
}
let fake_pi = Common.fake_parse_info

let addStorageD  = function
  | ((x,ii), ({storageD = (NoSto,[])} as v)) -> { v with storageD = (x, [ii]) }
  | ((x,ii), ({storageD = (y, ii2)} as v)) ->
      if x = y then warning "duplicate storage classes" v
      else warning "multiple storage classes, keeping the second" v

let addInlineD  = function
  | ((true,ii), ({inlineD = (false,[])} as v)) -> { v with inlineD=(true,[ii])}
  | ((true,ii), ({inlineD = (true, ii2)} as v)) -> warning "duplicate inline" v
  | _ -> raise (Impossible 86)


let addTypeD     = function
  | ((Left3 Signed,ii)   ,({typeD = ((Some Signed,  b,c),ii2)} as v)) ->
      warning "duplicate 'signed'"   v
  | ((Left3 UnSigned,ii) ,({typeD = ((Some UnSigned,b,c),ii2)} as v)) ->
      warning "duplicate 'unsigned'" v
  | ((Left3 _,ii),        ({typeD = ((Some _,b,c),ii2)} as _v)) ->
      raise (Semantic ("both signed and unsigned specified", fake_pi))
  | ((Left3 x,ii),        ({typeD = ((None,b,c),ii2)} as v))   ->
      {v with typeD = (Some x,b,c),ii @ ii2}

  | ((Middle3 Short,ii),  ({typeD = ((a,Some Short,c),ii2)} as v)) ->
      warning "duplicate 'short'" v


  (* gccext: long long allowed *)
  | ((Middle3 Long,ii),   ({typeD = ((a,Some Long ,c),ii2)} as v)) ->
      { v with typeD = (a, Some LongLong, c),ii @ ii2 }
  | ((Middle3 Long,ii),   ({typeD = ((a,Some LongLong ,c),ii2)} as v)) ->
      warning "triplicate 'long'" v


  | ((Middle3 _,ii),      ({typeD = ((a,Some _,c),ii2)} as _v)) ->
      raise (Semantic ("both long and short specified", fake_pi))
  | ((Middle3 x,ii),      ({typeD = ((a,None,c),ii2)} as v))  ->
      {v with typeD = (a, Some x,c),ii @ ii2}

  | ((Right3 t,ii),       ({typeD = ((a,b,Some x),ii2)} as v)) ->
      let mktype t ii = (({const=false;volatile=false;},[]),(t,ii)) in
      computed_warning
	(fun _ ->
	  Printf.sprintf
	    "two or more data types: dropping %s, keeping typeD %s\n"
	    (Pretty_print_c.string_of_fullType (mktype t ii))
	    (Pretty_print_c.string_of_fullType (mktype x ii2)))
	v
  | ((Right3 t,ii),       ({typeD = ((a,b,None),ii2)} as v))   ->
      {v with typeD = (a,b, Some t),ii @ ii2}


let addQualif = function
  | ({const=true},   ({const=true} as x)) ->   warning "duplicate 'const'" x
  | ({volatile=true},({volatile=true} as x))-> warning "duplicate 'volatile'" x
  | ({const=true},    v) -> {v with const=true}
  | ({volatile=true}, v) -> {v with volatile=true}
  | _ ->
      internal_error "there is no noconst or novolatile keyword"

let addQualifD ((qu,ii), ({qualifD = (v,ii2)} as x)) =
  { x with qualifD = (addQualif (qu, v),ii::ii2) }


(*-------------------------------------------------------------------------- *)
(* Declaration/Function related *)
(*-------------------------------------------------------------------------- *)


(* stdC: type section, basic integer types (and ritchie)
 * To understand the code, just look at the result (right part of the PM)
 * and go back.
 *)
let (fixDeclSpecForDecl: decl -> (fullType * (storage wrap)))  = function
 {storageD = (st,iist);
  qualifD = (qu,iiq);
  typeD = (ty,iit);
  inlineD = (inline,iinl);
  } ->
   let ty',iit' =
   (match ty with
 | (None,None,None)       ->
     (* generate fake_info, otherwise type_annotater can crash in
      * offset.
      *)
     warning "type defaults to 'int'" (defaultInt, [fakeInfo fake_pi])
 | (None, None, Some t)   -> (t, iit)

 | (Some sign,   None, (None| Some (BaseType (IntType (Si (_,CInt))))))  ->
     BaseType(IntType (Si (sign, CInt))), iit
 | ((None|Some Signed),Some x,(None|Some(BaseType(IntType (Si (_,CInt)))))) ->
     BaseType(IntType (Si (Signed, [Short,CShort; Long, CLong; LongLong, CLongLong] +> List.assoc x))), iit
 | (Some UnSigned, Some x, (None| Some (BaseType (IntType (Si (_,CInt))))))->
     BaseType(IntType (Si (UnSigned, [Short,CShort; Long, CLong; LongLong, CLongLong] +> List.assoc x))), iit
 | (Some sign,   None, (Some (BaseType (IntType CChar))))   ->
     BaseType(IntType (Si (sign, CChar2))), iit
 | (None, Some Long,(Some(BaseType(FloatType CDouble))))    ->
     BaseType (FloatType (CLongDouble)), iit
 | (None, Some Long,(Some(BaseType(FloatType CDoubleComplex))))    ->
     BaseType (FloatType (CLongDoubleComplex)), iit

 | (Some _,_, Some _) ->
     (*mine*)
     raise (Semantic ("signed, unsigned valid only for char and int", fake_pi))
 | (_,Some _,(Some(BaseType(FloatType (CFloat))))) ->
     raise (Semantic ("long or short specified with floating type", fake_pi))
 | (_,Some Short,(Some(BaseType(FloatType CDouble)))) ->
     raise (Semantic ("the only valid combination is long double", fake_pi))
 | (_,Some Short,(Some(BaseType(FloatType CDoubleComplex)))) ->
     raise (Semantic ("the only valid combination is long double complex", fake_pi))

 | (_, Some _, Some _) ->
     (* mine *)
     raise (Semantic ("long, short valid only for int or float", fake_pi))

     (* if do short uint i, then gcc say parse error, strange ? it is
      * not a parse error, it is just that we don't allow with typedef
      * either short/long or signed/unsigned. In fact, with
      * parse_typedef_fix2 (with et() and dt()) now I say too parse
      * error so this code is executed only when do short struct
      * {....} and never with a typedef cos now we parse short uint i
      * as short ident ident => parse error (cos after first short i
      * pass in dt() mode) *)

   )
   in
   ((qu, iiq),
   (ty', iit'))
     ,((st, inline),iist @ iinl)


let fixDeclSpecForParam = function ({storageD = (st,iist)} as r) ->
  let ((qu,ty) as v,_st) = fixDeclSpecForDecl r in
  match st with
  | (Sto Register) -> (v, true), iist
  | NoSto -> (v, false), iist
  | _ ->
      raise
        (Semantic ("storage class specified for parameter of function",
                  fake_pi))

let fixDeclSpecForMacro = function ({storageD = (st,iist)} as r) ->
  let ((qu,ty) as v,_st) = fixDeclSpecForDecl r in
  match st with
  | NoSto -> v
  | _ ->
      raise
        (Semantic ("storage class specified for macro type decl",
                  fake_pi))


let fixDeclSpecForFuncDef x =
  let (returnType,storage) = fixDeclSpecForDecl x in
  (match fst (unwrap storage) with
  | StoTypedef ->
      raise (Semantic ("function definition declared 'typedef'", fake_pi))
  | _ -> (returnType, storage)
  )


(* parameter: (this is the context where we give parameter only when
 * in func DEFINITION not in funct DECLARATION) We must have a name.
 * This function ensure that we give only parameterTypeDecl with well
 * formed Classic constructor todo?: do we accept other declaration
 * in ? so I must add them to the compound of the deffunc. I don't
 * have to handle typedef pb here cos C forbid to do VF f { ... }
 * with VF a typedef of func cos here we don't see the name of the
 * argument (in the typedef)
 *)
let (fixOldCDecl: fullType -> fullType) = fun ty ->
  match Ast_c.unwrap_typeC ty with
  | FunctionType (fullt, (params, (b, iib))) ->

      (* stdC: If the prototype declaration declares a parameter for a
       * function that you are defining (it is part of a function
       * definition), then you must write a name within the declarator.
       * Otherwise, you can omit the name. *)
      (match params with
      | [{p_namei = None; p_type = ty2},_] ->
          (match Ast_c.unwrap_typeC ty2 with
          | BaseType Void ->
              ty
          | _ ->
              pr2_once ("SEMANTIC:parameter name omitted, but I continue");
              ty
          )

      | params ->
          (params +> List.iter (fun (param,_) ->
            match param with
            | {p_namei = None} ->
              (* if majuscule, then certainly macro-parameter *)
                pr2_once ("SEMANTIC:parameter name omitted, but I continue");
	    | _ -> ()
          ));
          ty
      )

        (* todo? can we declare prototype in the decl or structdef,
           ... => length <> but good kan meme *)
  | _ ->
      (* gcc say parse error but don't see why *)
      raise (Semantic ("seems this is not a function", fake_pi))


let fixFunc (typ, compound, old_style_opt) =
  let (cp,iicp) = compound in

  let (name, ty,   (st,iist),  attrs) = typ in

  let (qu, tybis) = ty in

  match Ast_c.unwrap_typeC ty with
  | FunctionType (fullt, (params,abool)) ->
      let iifunc = Ast_c.get_ii_typeC_take_care tybis in

      let iistart = Ast_c.fakeInfo () in
      assert (qu = nullQualif);

      (match params with
      | [{p_namei= None; p_type = ty2}, _] ->
          (match Ast_c.unwrap_typeC ty2 with
          | BaseType Void ->  ()
          | _ ->
                (* failwith "internal error: fixOldCDecl not good" *)
              ()
          )
      | params ->
          params +> List.iter (function
          | ({p_namei = Some s}, _) -> ()
	  | _ -> ()
                (* failwith "internal error: fixOldCDecl not good" *)
          )
      );
      (* bugfix: cf tests_c/function_pointer4.c.
       * Apparemment en C on peut syntaxiquement ecrire ca:
       *
       *   void a(int)(int x);
       * mais apres gcc gueule au niveau semantique avec:
       *   xxx.c:1: error: 'a' declared as function returning a function
       * Je ne faisais pas cette verif. Sur du code comme
       *   void METH(foo)(int x) { ...} , le parser croit (a tort) que foo
       * est un typedef, et donc c'est parsé comme l'exemple precedent,
       * ce qui ensuite confuse l'unparser qui n'est pas habitué
       * a avoir dans le returnType un FunctionType et qui donc
       * pr_elem les ii dans le mauvais sens ce qui genere au final
       * une exception. Hence this fix to at least detect the error
       * at parsing time (not unparsing time).
       *)
      (match Ast_c.unwrap_typeC fullt with
      | FunctionType _ ->
          let s = Ast_c.str_of_name name in
          let iis = Ast_c.info_of_name name in
          pr2 (spf "WEIRD: %s declared as function returning a function." s);
          pr2 (spf "This is probably because of a macro. Extend standard.h");
          raise (Semantic (spf "error: %s " s, Ast_c.parse_info_of_info iis))
      | _ -> ()
      );

      (* it must be nullQualif,cos parser construct only this*)
      {f_name = name;
       f_type = (fullt, (params, abool));
       f_storage = st;
       f_body =
	if !Flag_parsing_c.parsing_header_for_types
	then []
	else cp;
       f_attr = attrs;
       f_old_c_style = old_style_opt;
      },
      (iifunc @ iicp @ [iistart] @ iist)
  | _ ->
      raise
        (Semantic
            ("you are trying to do a function definition but you don't give " ^
             "any parameter", fake_pi))


(*-------------------------------------------------------------------------- *)
(* parse_typedef_fix2 *)
(*-------------------------------------------------------------------------- *)

let dt s () =
  if !Flag_parsing_c.debug_etdt then pr2 ("<" ^ s);
  LP.disable_typedef ()

let et s () =
  if !Flag_parsing_c.debug_etdt then pr2 (">" ^ s);
  LP.enable_typedef ()


let fix_add_params_ident x =
  let (s, ty, st, _attrs) = x in
  match Ast_c.unwrap_typeC ty with
  | FunctionType (fullt, (params, bool)) ->

      (match params with
      | [{p_namei=None; p_type=ty2}, _] ->
          (match Ast_c.unwrap_typeC ty2 with
          | BaseType Void -> ()
          | _ ->
              (* failwith "internal error: fixOldCDecl not good" *)
              ()
          )
      | params ->
          params +> List.iter (function
          | ({p_namei= Some name}, _) ->
              LP.add_ident (Ast_c.str_of_name s)
	  | _ ->
              ()
                (* failwith "internal error: fixOldCDecl not good" *)
          )
      )
  | _ -> ()

(*-------------------------------------------------------------------------- *)
(* shortcuts *)
(*-------------------------------------------------------------------------- *)

let mk_e e ii = Ast_c.mk_e e ii

let mk_string_wrap (s,info) = (s, [info])

(*-------------------------------------------------------------------------- *)
(* support for functions with no return type *)
(*-------------------------------------------------------------------------- *)

let args_are_params l =
  match l with
    [Right (ArgAction(ActMisc [x])), ii] when Ast_c.is_fake x -> true
  | _ -> List.for_all (function Right (ArgType x), ii -> true | _ -> false) l
let args_to_params l pb =
  let pi =
    match pb with Some pb -> Ast_c.parse_info_of_info pb | None -> fake_pi in
  match l with
    [(Right (ArgAction(ActMisc [x])), ii)] when Ast_c.is_fake x -> []
  | l ->
      List.map
	(function
	    Right (ArgType x), ii -> x, ii
	  | x ->
	      raise
		(Semantic
		   ("function with no return type must have types in param list",
		    pi)))
	l

(* For fake info added at the end of a conditional or iteration, to have the
correct position information *)
let postfakeInfo pii  =
  let (max,min) =  Lib_parsing_c.max_min_ii_by_pos pii in
  let max_pi = Ast_c.get_info (fun x -> x) max in
  let vp = ({str="";charpos=max_pi.Common.charpos;line=max_pi.Common.line;
	      column=max_pi.Common.column;file=max_pi.Common.file},
	    String.length max_pi.Common.str) in
  { pinfo = FakeTok ("",vp);
    cocci_tag = ref Ast_c.emptyAnnot;
    annots_tag = Token_annot.empty;
    comments_tag = ref Ast_c.emptyComments;
    danger = ref Ast_c.NoDanger;
  }

# 587 "parsing_c/parser_c.ml"
let yytransl_const = [|
    0|]

let yytransl_block = [|
  257 (* TUnknown *);
  258 (* TCommentSpace *);
  259 (* TCommentNewline *);
  260 (* TComment *);
  261 (* TInt *);
  262 (* TFloat *);
  263 (* TChar *);
  264 (* TString *);
  265 (* TQuote *);
  266 (* TPct *);
  267 (* TFormat *);
  268 (* TSubString *);
  269 (* TDecimal *);
  270 (* TIdent *);
  271 (* TKRParam *);
  272 (* Tconstructorname *);
  273 (* TypedefIdent *);
  274 (* TOPar *);
  275 (* TCPar *);
  276 (* TOBrace *);
  277 (* TCBrace *);
  278 (* TOCro *);
  279 (* TCCro *);
  280 (* TDot *);
  281 (* TComma *);
  282 (* TPtrOp *);
  283 (* TInc *);
  284 (* TDec *);
  285 (* TAssign *);
  286 (* TEq *);
  287 (* TWhy *);
  288 (* TTilde *);
  289 (* TBang *);
  290 (* TEllipsis *);
  291 (* TDotDot *);
  292 (* TPtVirg *);
  293 (* TOrLog *);
  294 (* TAndLog *);
  295 (* TOr *);
  296 (* TXor *);
  297 (* TAnd *);
  298 (* TEqEq *);
  299 (* TNotEq *);
  300 (* TInf *);
  301 (* TSup *);
  302 (* TInfEq *);
  303 (* TSupEq *);
  304 (* TShl *);
  305 (* TShr *);
  306 (* TPlus *);
  307 (* TMinus *);
  308 (* TMul *);
  309 (* TDiv *);
  310 (* TMod *);
  311 (* TMax *);
  312 (* TMin *);
  313 (* Tchar *);
  314 (* Tshort *);
  315 (* Tint *);
  316 (* Tdouble *);
  317 (* Tfloat *);
  318 (* Tcomplex *);
  319 (* Tlong *);
  320 (* Tunsigned *);
  321 (* Tsigned *);
  322 (* Tvoid *);
  323 (* Tsize_t *);
  324 (* Tssize_t *);
  325 (* Tptrdiff_t *);
  326 (* Tauto *);
  327 (* Tregister *);
  328 (* Textern *);
  329 (* Tstatic *);
  330 (* Ttypedef *);
  331 (* Tconst *);
  332 (* Tvolatile *);
  333 (* Tstruct *);
  334 (* Tunion *);
  335 (* Tenum *);
  336 (* Tdecimal *);
  337 (* Texec *);
  338 (* Tbreak *);
  339 (* Telse *);
  340 (* Tswitch *);
  341 (* Tcase *);
  342 (* Tcontinue *);
  343 (* Tfor *);
  344 (* Tdo *);
  345 (* Tif *);
  346 (* Twhile *);
  347 (* Treturn *);
  348 (* Tgoto *);
  349 (* Tdefault *);
  350 (* Tsizeof *);
  351 (* Tnew *);
  352 (* Tdelete *);
  353 (* Tdefined *);
  354 (* TOParCplusplusInit *);
  355 (* Tnamespace *);
  356 (* Trestrict *);
  357 (* Tasm *);
  358 (* Tattribute *);
  359 (* TattributeNoarg *);
  360 (* Tinline *);
  361 (* Ttypeof *);
  362 (* TDefine *);
  363 (* TDefParamVariadic *);
  364 (* TCppEscapedNewline *);
  365 (* TCppConcatOp *);
  366 (* TOParDefine *);
  367 (* TOBraceDefineInit *);
  368 (* TIdentDefine *);
  369 (* TDefEOL *);
  370 (* TInclude *);
  371 (* TIncludeStart *);
  372 (* TIncludeFilename *);
  373 (* TIfdef *);
  374 (* TIfdefelif *);
  375 (* TIfdefelse *);
  376 (* TEndif *);
  377 (* TIfdefBool *);
  378 (* TIfdefMisc *);
  379 (* TIfdefVersion *);
  380 (* TUifdef *);
  381 (* TUelseif *);
  382 (* TUendif *);
  383 (* TUndef *);
  384 (* TPrePragma *);
  385 (* TPragma *);
  386 (* TPragmaString *);
  387 (* TCppDirectiveOther *);
  388 (* TMacroAttr *);
  389 (* TMacroEndAttr *);
  390 (* TMacroStmt *);
  391 (* TMacroIdentBuilder *);
  392 (* TMacroString *);
  393 (* TMacroDecl *);
  394 (* TMacroDeclConst *);
  395 (* TMacroIterator *);
  396 (* TCommentSkipTagStart *);
  397 (* TCommentSkipTagEnd *);
  398 (* TCParEOL *);
  399 (* TAction *);
  400 (* TCommentMisc *);
  401 (* TCommentCpp *);
    0 (* EOF *);
  402 (* TTODO *);
    0|]

let yylhs = "\255\255\
\001\000\006\000\006\000\006\000\008\000\008\000\008\000\009\000\
\009\000\010\000\010\000\012\000\012\000\012\000\012\000\011\000\
\011\000\011\000\013\000\013\000\004\000\004\000\015\000\015\000\
\015\000\016\000\016\000\018\000\018\000\018\000\018\000\018\000\
\018\000\018\000\018\000\018\000\018\000\018\000\018\000\018\000\
\018\000\018\000\018\000\018\000\018\000\018\000\018\000\018\000\
\017\000\017\000\020\000\020\000\020\000\020\000\020\000\020\000\
\020\000\020\000\020\000\020\000\020\000\020\000\025\000\025\000\
\025\000\025\000\025\000\025\000\024\000\024\000\024\000\024\000\
\024\000\024\000\024\000\023\000\023\000\023\000\023\000\023\000\
\023\000\023\000\023\000\023\000\023\000\028\000\028\000\028\000\
\028\000\028\000\028\000\028\000\028\000\028\000\028\000\028\000\
\031\000\031\000\035\000\035\000\036\000\037\000\037\000\037\000\
\040\000\040\000\040\000\039\000\041\000\044\000\021\000\022\000\
\003\000\045\000\045\000\045\000\045\000\045\000\045\000\045\000\
\045\000\045\000\045\000\046\000\046\000\046\000\046\000\053\000\
\053\000\055\000\055\000\055\000\034\000\057\000\057\000\059\000\
\059\000\059\000\060\000\060\000\060\000\060\000\060\000\047\000\
\047\000\048\000\048\000\048\000\048\000\048\000\049\000\049\000\
\049\000\049\000\049\000\049\000\049\000\049\000\050\000\050\000\
\050\000\050\000\050\000\050\000\032\000\032\000\051\000\051\000\
\066\000\068\000\068\000\068\000\068\000\068\000\052\000\052\000\
\052\000\052\000\070\000\070\000\070\000\070\000\071\000\071\000\
\069\000\072\000\072\000\072\000\072\000\072\000\072\000\072\000\
\072\000\072\000\072\000\072\000\072\000\072\000\072\000\072\000\
\072\000\072\000\072\000\072\000\072\000\072\000\072\000\072\000\
\072\000\072\000\072\000\072\000\072\000\072\000\072\000\072\000\
\072\000\072\000\072\000\072\000\072\000\072\000\072\000\073\000\
\073\000\073\000\073\000\073\000\073\000\073\000\073\000\073\000\
\073\000\073\000\073\000\073\000\073\000\073\000\073\000\073\000\
\073\000\073\000\073\000\073\000\027\000\076\000\076\000\076\000\
\077\000\077\000\078\000\078\000\079\000\079\000\079\000\079\000\
\081\000\081\000\080\000\080\000\080\000\080\000\080\000\080\000\
\083\000\084\000\088\000\088\000\088\000\089\000\089\000\089\000\
\089\000\089\000\089\000\089\000\089\000\089\000\087\000\087\000\
\091\000\091\000\091\000\091\000\038\000\093\000\093\000\094\000\
\096\000\096\000\096\000\096\000\097\000\082\000\082\000\082\000\
\082\000\005\000\005\000\098\000\099\000\099\000\099\000\099\000\
\101\000\101\000\101\000\106\000\106\000\106\000\106\000\106\000\
\106\000\106\000\106\000\106\000\106\000\105\000\105\000\105\000\
\105\000\107\000\107\000\054\000\092\000\108\000\108\000\108\000\
\103\000\110\000\109\000\109\000\109\000\111\000\111\000\104\000\
\104\000\104\000\029\000\029\000\115\000\115\000\115\000\115\000\
\115\000\117\000\117\000\117\000\030\000\030\000\118\000\118\000\
\118\000\123\000\123\000\123\000\123\000\124\000\124\000\124\000\
\124\000\124\000\124\000\125\000\125\000\127\000\127\000\127\000\
\128\000\128\000\074\000\119\000\131\000\129\000\130\000\121\000\
\121\000\075\000\075\000\075\000\136\000\136\000\137\000\061\000\
\139\000\139\000\140\000\140\000\138\000\138\000\138\000\141\000\
\142\000\142\000\144\000\144\000\143\000\143\000\062\000\062\000\
\062\000\062\000\062\000\062\000\146\000\146\000\145\000\145\000\
\145\000\145\000\145\000\145\000\145\000\145\000\145\000\145\000\
\145\000\145\000\148\000\148\000\148\000\148\000\148\000\064\000\
\064\000\150\000\150\000\149\000\151\000\153\000\152\000\063\000\
\063\000\063\000\063\000\063\000\063\000\063\000\154\000\154\000\
\154\000\154\000\007\000\007\000\002\000\002\000\002\000\002\000\
\002\000\002\000\002\000\002\000\056\000\058\000\133\000\135\000\
\113\000\114\000\120\000\122\000\085\000\086\000\033\000\033\000\
\065\000\065\000\067\000\067\000\026\000\026\000\102\000\102\000\
\132\000\132\000\126\000\126\000\126\000\134\000\134\000\134\000\
\100\000\100\000\100\000\090\000\090\000\042\000\042\000\043\000\
\043\000\014\000\014\000\014\000\116\000\116\000\155\000\155\000\
\095\000\112\000\147\000\147\000\019\000\019\000\000\000\000\000\
\000\000\000\000\000\000"

let yylen = "\002\000\
\002\000\000\000\002\000\006\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\003\000\
\002\000\004\000\001\000\003\000\001\000\003\000\001\000\003\000\
\003\000\001\000\005\000\001\000\003\000\003\000\003\000\003\000\
\003\000\003\000\003\000\003\000\003\000\003\000\003\000\003\000\
\003\000\003\000\003\000\003\000\003\000\003\000\003\000\003\000\
\001\000\004\000\001\000\002\000\002\000\002\000\002\000\004\000\
\002\000\005\000\002\000\004\000\002\000\004\000\004\000\003\000\
\004\000\003\000\001\000\004\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\004\000\004\000\003\000\003\000\
\003\000\002\000\002\000\005\000\007\000\001\000\001\000\001\000\
\001\000\003\000\001\000\001\000\003\000\001\000\002\000\003\000\
\000\000\002\000\002\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\002\000\005\000\
\006\000\001\000\004\000\003\000\004\000\006\000\003\000\001\000\
\001\000\002\000\003\000\002\000\003\000\000\000\001\000\001\000\
\001\000\002\000\001\000\001\000\001\000\001\000\001\000\001\000\
\002\000\005\000\007\000\005\000\009\000\011\000\005\000\007\000\
\006\000\007\000\006\000\007\000\005\000\004\000\002\000\001\000\
\001\000\001\000\002\000\003\000\001\000\001\000\002\000\001\000\
\002\000\001\000\004\000\007\000\001\000\000\000\000\000\004\000\
\003\000\002\000\000\000\003\000\003\000\004\000\000\000\003\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\002\000\002\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\006\000\
\004\000\001\000\004\000\004\000\001\000\001\000\001\000\001\000\
\003\000\001\000\002\000\001\000\001\000\002\000\002\000\003\000\
\001\000\001\000\001\000\003\000\003\000\004\000\003\000\004\000\
\001\000\001\000\001\000\001\000\002\000\003\000\002\000\003\000\
\003\000\004\000\002\000\003\000\003\000\004\000\001\000\003\000\
\001\000\002\000\002\000\001\000\001\000\001\000\002\000\001\000\
\001\000\001\000\002\000\002\000\001\000\001\000\001\000\002\000\
\002\000\001\000\002\000\001\000\002\000\003\000\006\000\008\000\
\002\000\001\000\000\000\001\000\001\000\001\000\001\000\001\000\
\002\000\002\000\002\000\002\000\002\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\003\000\004\000\
\001\000\001\000\001\000\002\000\002\000\004\000\005\000\001\000\
\004\000\002\000\001\000\003\000\001\000\004\000\002\000\003\000\
\003\000\002\000\003\000\005\000\001\000\000\000\005\000\004\000\
\002\000\001\000\001\000\002\000\002\000\001\000\001\000\005\000\
\005\000\001\000\001\000\003\000\002\000\001\000\002\000\003\000\
\001\000\002\000\001\000\001\000\001\000\001\000\001\000\001\000\
\000\000\005\000\006\000\002\000\001\000\003\000\001\000\001\000\
\001\000\002\000\001\000\002\000\002\000\003\000\003\000\001\000\
\002\000\001\000\003\000\004\000\001\000\002\000\002\000\004\000\
\007\000\003\000\004\000\001\000\001\000\002\000\001\000\001\000\
\001\000\001\000\002\000\002\000\001\000\005\000\006\000\004\000\
\005\000\000\000\001\000\001\000\001\000\001\000\001\000\003\000\
\001\000\003\000\003\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\005\000\005\000\
\004\000\002\000\001\000\001\000\005\000\001\000\001\000\001\000\
\001\000\005\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\002\000\
\001\000\002\000\001\000\003\000\001\000\003\000\001\000\003\000\
\001\000\002\000\001\000\004\000\003\000\001\000\004\000\003\000\
\001\000\004\000\003\000\001\000\003\000\001\000\002\000\000\000\
\002\000\000\000\001\000\003\000\001\000\002\000\001\000\002\000\
\001\000\001\000\001\000\000\000\001\000\000\000\002\000\002\000\
\002\000\002\000\002\000"

let yydefred = "\000\000\
\002\000\000\000\000\000\000\000\000\000\000\000\247\001\000\000\
\008\000\000\000\242\000\195\001\225\000\234\000\226\000\000\000\
\000\000\009\000\235\000\237\000\236\000\224\000\231\000\232\000\
\233\000\064\001\065\001\063\001\062\001\067\001\246\000\247\000\
\000\000\000\000\000\000\000\000\000\000\248\000\000\000\000\000\
\000\000\000\000\000\000\000\000\172\001\174\001\173\001\175\001\
\180\001\181\001\182\001\000\000\000\000\148\001\250\000\196\001\
\248\001\190\001\000\000\000\000\188\001\187\001\191\001\193\001\
\245\000\238\000\239\000\000\000\000\000\000\000\068\001\000\000\
\000\000\069\001\000\000\115\001\000\000\116\001\128\001\000\000\
\136\001\138\001\176\001\177\001\179\001\178\001\192\001\087\000\
\088\000\091\000\000\000\000\000\092\000\000\000\013\000\000\000\
\197\001\000\000\000\000\073\000\074\000\144\000\075\000\069\000\
\071\000\072\000\070\000\015\000\000\000\161\000\000\000\000\000\
\160\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\122\000\
\000\000\000\000\000\000\249\001\000\000\086\000\000\000\000\000\
\021\000\023\000\000\000\000\000\049\000\000\000\000\000\000\000\
\076\000\000\000\115\000\113\000\114\000\116\000\117\000\118\000\
\000\000\000\000\000\000\000\000\011\000\251\001\000\000\000\000\
\037\001\000\000\000\000\001\000\003\000\205\001\000\000\230\000\
\229\000\239\001\100\001\000\000\101\001\005\000\006\000\199\001\
\007\000\000\000\000\000\000\000\000\000\000\000\000\000\066\001\
\060\001\000\000\000\000\143\001\000\000\000\000\000\000\186\001\
\058\001\059\001\061\001\000\000\045\001\002\001\001\001\003\001\
\000\000\000\000\000\000\000\000\000\000\074\001\000\000\225\001\
\137\001\000\000\049\001\057\001\203\001\000\000\000\000\133\001\
\129\001\131\001\000\000\000\000\000\000\000\000\100\000\000\000\
\000\000\000\000\000\000\000\000\052\000\000\000\053\000\000\000\
\000\000\110\000\028\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\014\000\159\000\000\000\055\000\000\000\
\000\000\000\000\000\000\000\000\067\000\000\000\059\000\000\000\
\061\000\000\000\000\000\017\000\000\000\000\000\000\000\000\000\
\145\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\082\000\083\000\
\054\000\165\000\166\000\207\001\000\000\119\000\000\000\000\000\
\000\000\140\000\000\000\139\000\137\000\000\000\135\000\000\000\
\141\000\142\000\143\000\035\001\036\001\000\000\000\000\000\000\
\000\000\044\001\000\000\043\001\000\000\025\001\206\001\228\001\
\139\001\000\000\000\000\029\001\000\000\240\001\000\000\127\001\
\000\000\222\001\000\000\000\000\002\000\000\000\000\000\249\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\146\001\000\000\000\000\
\000\000\105\000\106\000\215\001\107\000\109\000\000\000\000\000\
\000\000\242\001\076\001\000\000\000\000\009\001\000\000\000\000\
\038\001\039\001\254\000\000\000\000\000\046\001\073\001\000\000\
\000\000\000\000\000\000\103\001\000\000\000\000\106\001\107\001\
\000\000\000\000\117\001\102\001\217\001\000\000\000\000\135\001\
\130\001\134\001\132\001\101\000\099\000\090\000\098\000\019\000\
\000\000\093\000\096\000\000\000\220\000\221\000\223\000\222\000\
\000\000\217\000\212\000\213\000\210\000\211\000\216\000\193\000\
\194\000\196\000\195\000\214\000\215\000\000\000\204\000\203\000\
\208\000\209\000\207\000\197\000\198\000\202\000\201\000\200\000\
\199\000\206\000\205\000\186\000\187\000\188\000\189\000\190\000\
\192\000\191\000\219\000\218\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\129\000\
\127\000\128\000\000\000\000\000\000\000\000\000\102\000\000\000\
\213\001\103\000\104\000\108\000\000\000\000\000\000\000\000\000\
\000\000\000\000\163\001\164\001\166\001\167\001\165\001\000\000\
\235\001\000\000\000\000\022\000\124\000\024\000\025\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\029\000\030\000\033\000\032\000\031\000\112\000\000\000\079\000\
\000\000\000\000\080\000\081\000\208\001\000\000\000\000\000\000\
\198\001\133\000\138\000\019\001\000\000\015\001\000\000\000\000\
\000\000\000\000\000\000\002\000\140\001\000\000\000\000\000\000\
\000\000\032\001\026\001\027\001\000\000\000\000\000\000\000\000\
\241\000\000\000\000\000\000\000\000\000\209\001\000\000\244\000\
\243\000\000\000\000\000\000\000\000\000\000\000\201\001\000\000\
\000\000\000\000\085\001\000\000\000\000\083\001\000\000\237\001\
\156\001\155\001\144\001\150\001\147\001\233\001\000\000\000\000\
\185\001\004\001\000\000\000\000\010\001\000\000\005\001\007\001\
\000\000\040\001\041\001\000\001\227\001\000\000\000\000\080\001\
\071\001\000\000\000\000\000\000\000\000\000\000\118\001\109\001\
\000\000\000\000\219\001\000\000\000\000\204\001\096\001\218\001\
\077\001\000\000\000\000\000\000\000\000\000\000\123\000\178\000\
\000\000\000\000\125\000\000\000\000\000\000\000\000\000\000\000\
\000\000\064\000\000\000\066\000\000\000\231\001\000\000\000\000\
\000\000\060\000\062\000\000\000\000\000\000\000\018\000\000\000\
\169\001\158\000\000\000\000\000\000\000\000\000\050\000\078\000\
\077\000\000\000\014\001\016\001\020\001\017\001\000\000\021\001\
\000\000\000\000\024\001\229\001\031\001\000\000\224\001\000\000\
\200\001\122\001\126\001\000\000\189\001\000\000\000\000\173\000\
\000\000\211\001\210\001\194\001\000\000\000\000\000\000\000\000\
\000\000\090\001\000\000\000\000\000\000\202\001\000\000\087\001\
\000\000\238\001\183\001\184\001\216\001\000\000\000\000\006\001\
\008\001\226\001\072\001\000\000\082\001\000\000\095\001\000\000\
\000\000\114\001\000\000\108\001\000\000\119\001\111\001\020\000\
\000\000\177\000\000\000\000\000\000\000\000\000\148\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\151\000\063\000\
\065\000\000\000\214\001\068\000\120\000\000\000\000\000\236\001\
\000\000\157\000\027\000\084\000\000\000\018\001\022\001\004\000\
\123\001\223\001\240\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\091\001\000\000\089\001\084\001\000\000\000\000\
\088\001\078\001\000\000\000\000\047\001\000\000\000\000\000\000\
\221\001\000\000\112\001\184\000\000\000\000\000\000\000\176\000\
\126\000\153\000\000\000\155\000\000\000\000\000\000\000\121\000\
\000\000\168\001\000\000\000\000\000\000\185\000\000\000\000\000\
\212\001\000\000\000\000\145\001\000\000\243\001\158\001\086\001\
\079\001\081\001\000\000\105\001\104\001\220\001\000\000\180\000\
\181\000\154\000\156\000\152\000\147\000\000\000\000\000\000\000\
\085\000\171\000\000\000\000\000\092\001\048\001\182\000\000\000\
\000\000\170\001\171\001\000\000\000\000\149\000\000\000\000\000\
\172\000\150\000"

let yydgoto = "\006\000\
\007\000\057\000\137\002\133\000\158\000\008\000\165\000\058\002\
\134\001\134\000\157\000\136\000\153\001\232\001\137\000\138\000\
\139\000\140\000\241\001\141\000\142\000\007\002\143\000\144\000\
\252\000\216\001\060\000\145\000\060\002\039\002\224\000\146\000\
\086\001\147\000\225\000\149\001\217\001\107\001\219\001\108\001\
\109\001\220\001\110\001\206\002\148\000\149\000\150\000\151\000\
\152\000\153\000\087\001\197\001\209\001\210\001\053\001\154\000\
\054\001\018\002\055\001\056\001\062\000\058\001\059\001\138\002\
\045\002\046\002\169\002\170\002\031\003\214\002\109\002\198\001\
\065\000\066\000\067\000\068\000\069\000\143\001\202\000\203\000\
\204\000\124\001\119\001\079\002\065\001\073\001\074\001\021\002\
\067\001\075\001\076\001\077\001\035\002\036\002\171\000\161\000\
\162\000\068\001\071\000\205\000\072\000\111\001\129\001\089\002\
\184\000\074\000\075\000\206\000\207\000\208\000\115\001\116\001\
\061\002\184\002\062\002\063\002\064\002\076\000\077\000\215\000\
\138\001\103\002\078\000\139\001\140\001\098\002\099\002\100\002\
\101\002\207\002\141\001\142\001\179\000\081\001\162\002\082\001\
\083\001\079\000\220\000\221\000\080\000\081\000\209\000\082\000\
\101\001\104\001\039\003\233\001\139\002\026\003\084\000\085\000\
\086\000\087\000\172\000"

let yysindex = "\172\003\
\000\000\253\010\026\018\254\021\187\027\000\000\000\000\075\011\
\000\000\016\255\000\000\000\000\000\000\000\000\000\000\007\255\
\096\255\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\036\255\036\255\107\000\149\255\103\255\000\000\171\255\178\255\
\239\026\210\255\158\255\145\255\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\168\255\025\000\000\000\000\000\000\000\
\000\000\000\000\221\255\239\026\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\239\026\239\026\090\001\000\000\173\255\
\220\255\000\000\239\026\000\000\185\000\000\000\000\000\093\026\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\095\255\000\000\006\000\000\000\246\019\
\000\000\254\021\254\021\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\044\255\000\000\094\000\254\021\
\000\000\128\000\026\018\131\000\144\000\254\021\040\255\132\000\
\254\021\094\023\039\020\045\255\072\255\199\000\162\000\000\000\
\230\000\000\000\240\000\000\000\111\000\000\000\000\000\232\000\
\000\000\000\000\099\000\153\006\000\000\187\027\237\001\254\021\
\000\000\029\255\000\000\000\000\000\000\000\000\000\000\000\000\
\236\000\185\016\006\000\001\001\000\000\000\000\187\027\187\027\
\000\000\042\001\048\001\000\000\000\000\000\000\179\024\000\000\
\000\000\000\000\000\000\036\255\000\000\000\000\000\000\000\000\
\000\000\047\001\074\255\254\021\085\001\029\255\100\001\000\000\
\000\000\237\018\022\014\000\000\252\000\247\000\066\013\000\000\
\000\000\000\000\000\000\063\002\000\000\000\000\000\000\000\000\
\254\254\239\000\208\255\168\001\191\000\000\000\054\255\000\000\
\000\000\117\001\000\000\000\000\000\000\124\001\064\023\000\000\
\000\000\000\000\090\001\169\026\095\001\136\001\000\000\143\001\
\095\255\142\001\090\255\148\001\000\000\187\027\000\000\187\028\
\254\021\000\000\000\000\013\002\131\018\087\001\254\021\254\021\
\001\001\006\000\254\021\000\000\000\000\064\017\000\000\187\027\
\170\001\172\001\172\013\197\001\000\000\185\001\000\000\034\255\
\000\000\029\255\205\001\000\000\248\001\235\001\154\011\254\021\
\000\000\064\017\254\021\254\021\254\021\254\021\254\021\254\021\
\254\021\254\021\254\021\254\021\254\021\254\021\254\021\254\021\
\254\021\254\021\254\021\254\021\254\021\254\021\254\021\254\021\
\254\021\212\001\004\012\254\021\074\255\074\255\000\000\000\000\
\000\000\000\000\000\000\000\000\029\255\000\000\000\000\254\021\
\223\001\000\000\243\001\000\000\000\000\006\002\000\000\185\016\
\000\000\000\000\000\000\000\000\000\000\219\001\089\020\061\000\
\069\025\000\000\011\001\000\000\255\001\000\000\000\000\000\000\
\000\000\017\002\035\002\000\000\039\006\000\000\074\255\000\000\
\040\002\000\000\038\002\185\255\000\000\038\255\051\002\000\000\
\054\002\056\002\026\018\105\255\235\001\196\019\000\000\111\000\
\000\000\185\016\000\000\175\004\249\001\000\000\247\000\055\002\
\221\001\000\000\000\000\000\000\000\000\000\000\055\255\097\002\
\112\255\000\000\000\000\000\000\208\255\000\000\138\020\179\024\
\000\000\000\000\000\000\168\001\161\009\000\000\000\000\066\013\
\188\020\066\013\064\023\000\000\149\002\151\002\000\000\000\000\
\000\006\163\002\000\000\000\000\000\000\064\023\254\254\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\061\002\000\000\000\000\212\001\000\000\000\000\000\000\000\000\
\161\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\034\255\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\150\002\187\028\073\000\254\021\
\064\017\006\021\006\021\169\002\189\000\210\000\001\001\000\000\
\000\000\000\000\212\001\110\012\216\012\045\002\000\000\005\001\
\000\000\000\000\000\000\000\000\254\021\254\021\171\002\172\002\
\029\255\254\021\000\000\000\000\000\000\000\000\000\000\070\001\
\000\000\177\017\088\001\000\000\000\000\000\000\000\000\001\001\
\157\002\125\007\201\017\049\018\207\020\058\009\109\002\109\002\
\003\002\003\002\003\002\003\002\095\002\095\002\127\002\127\002\
\000\000\000\000\000\000\000\000\000\000\000\000\056\021\000\000\
\113\001\041\000\000\000\000\000\000\000\048\002\064\017\064\017\
\000\000\000\000\000\000\000\000\174\002\000\000\173\002\011\001\
\017\002\105\021\179\024\000\000\000\000\255\024\041\005\036\255\
\117\000\000\000\000\000\000\000\040\002\049\001\176\002\254\021\
\000\000\254\021\209\025\103\000\159\002\000\000\164\002\000\000\
\000\000\112\002\029\255\181\002\129\001\006\000\000\000\254\021\
\079\000\168\002\000\000\179\002\086\019\000\000\052\001\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\071\000\066\013\
\000\000\000\000\029\255\187\002\000\000\183\002\000\000\000\000\
\017\002\000\000\000\000\000\000\000\000\161\009\141\001\000\000\
\000\000\086\019\149\001\163\002\066\013\066\013\000\000\000\000\
\036\255\029\001\000\000\177\002\254\021\000\000\000\000\000\000\
\000\000\193\002\188\002\195\002\187\028\169\001\000\000\000\000\
\026\018\178\002\000\000\155\021\204\021\254\021\177\017\177\017\
\188\002\000\000\186\001\000\000\215\001\000\000\163\027\066\013\
\061\001\000\000\000\000\175\002\196\002\217\001\000\000\235\001\
\000\000\000\000\177\017\177\017\254\021\136\019\000\000\000\000\
\000\000\064\017\000\000\000\000\000\000\000\000\191\002\000\000\
\017\002\023\026\000\000\000\000\000\000\176\002\000\000\049\001\
\000\000\000\000\000\000\197\002\000\000\200\002\044\255\000\000\
\194\002\000\000\000\000\000\000\202\002\204\002\029\255\050\016\
\035\001\000\000\196\019\196\019\206\002\000\000\179\002\000\000\
\196\019\000\000\000\000\000\000\000\000\210\002\029\255\000\000\
\000\000\000\000\000\000\179\002\000\000\084\001\000\000\220\001\
\228\001\000\000\169\005\000\000\254\021\000\000\000\000\000\000\
\161\002\000\000\254\021\207\002\211\002\187\028\000\000\064\017\
\177\017\231\001\177\017\254\001\007\002\148\002\000\000\000\000\
\000\000\197\001\000\000\000\000\000\000\208\002\026\018\000\000\
\240\001\000\000\000\000\000\000\179\002\000\000\000\000\000\000\
\000\000\000\000\000\000\254\021\209\002\103\000\254\021\175\002\
\214\002\123\002\000\000\254\021\000\000\000\000\220\002\225\002\
\000\000\000\000\228\002\225\002\000\000\188\020\212\002\215\002\
\000\000\169\005\000\000\000\000\073\001\169\001\169\001\000\000\
\000\000\000\000\177\017\000\000\177\017\231\002\177\017\000\000\
\167\002\000\000\177\017\177\017\040\003\000\000\044\003\056\003\
\000\000\009\002\208\002\000\000\042\003\000\000\000\000\000\000\
\000\000\000\000\030\003\000\000\000\000\000\000\169\001\000\000\
\000\000\000\000\000\000\000\000\000\000\251\001\205\002\240\001\
\000\000\000\000\049\003\231\002\000\000\000\000\000\000\026\018\
\026\018\000\000\000\000\254\021\201\002\000\000\051\003\026\018\
\000\000\000\000"

let yyrindex = "\000\000\
\000\000\192\002\000\000\000\000\000\000\000\000\000\000\192\002\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\234\003\
\100\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\008\001\023\001\000\000\000\000\000\000\000\000\000\000\000\000\
\159\005\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\097\008\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\130\010\165\010\000\000\000\000\000\000\
\239\022\000\000\227\010\000\000\000\000\000\000\000\000\192\002\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\210\005\063\003\000\000\081\027\000\000\240\027\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\038\003\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\076\006\000\000\000\000\000\000\000\000\120\027\000\000\
\000\000\000\000\214\007\203\002\000\000\000\000\011\007\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\023\255\235\002\075\004\000\000\000\000\167\010\174\010\
\000\000\027\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\051\255\000\000\000\000\000\000\000\000\
\000\000\222\004\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\203\255\000\000\000\000\000\000\070\255\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\005\024\000\000\045\022\220\000\000\000\000\000\043\001\000\000\
\000\000\000\000\000\000\000\000\000\000\088\005\055\003\000\000\
\000\000\000\000\000\000\192\002\000\000\000\000\000\000\000\000\
\063\003\000\000\000\000\000\000\000\000\000\000\000\000\046\003\
\000\000\000\000\000\000\000\000\192\002\000\000\000\000\000\000\
\050\003\115\006\000\000\000\000\000\000\192\002\000\000\000\000\
\000\000\088\002\000\000\049\007\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\016\002\000\000\000\000\
\000\000\192\002\000\000\000\000\043\003\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\224\006\000\000\180\023\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\058\255\
\000\000\000\000\000\000\000\000\000\000\139\025\000\000\029\000\
\000\000\000\000\050\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\068\003\000\000\085\255\000\000\000\000\000\000\
\067\003\000\000\072\001\000\000\000\000\071\003\000\000\000\000\
\000\000\000\000\000\000\000\000\016\002\000\000\157\014\234\002\
\036\015\192\002\171\015\236\002\000\000\000\000\238\002\000\000\
\070\255\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\097\024\145\022\000\000\000\000\000\000\
\000\000\000\000\000\000\210\003\000\000\000\000\000\000\021\002\
\000\000\021\002\055\003\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\075\003\110\255\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\112\003\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\073\028\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\046\003\000\000\000\000\
\192\002\000\000\000\000\000\000\000\000\000\000\061\003\000\000\
\000\000\000\000\000\000\000\000\000\000\024\002\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\064\003\
\000\000\208\009\180\009\119\000\147\009\124\009\056\009\096\009\
\053\002\182\008\232\008\015\009\120\008\151\008\000\008\039\008\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\100\255\190\255\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\141\000\
\000\000\000\000\000\000\000\000\000\000\000\000\139\025\099\255\
\024\255\000\000\000\000\000\000\067\003\077\003\000\000\000\000\
\000\000\000\000\192\002\172\000\082\003\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\240\028\000\000\000\000\
\000\000\000\000\000\000\067\003\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\070\255\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\021\002\021\002\000\000\000\000\
\084\000\000\000\000\000\055\001\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\046\003\130\028\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\092\007\000\000\000\000\000\000\000\000\000\000\000\000\021\002\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\200\255\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\192\002\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\224\000\000\000\000\000\
\254\255\000\000\000\000\000\000\000\000\000\000\000\000\203\255\
\000\000\000\000\000\000\077\003\000\000\000\000\067\003\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\067\003\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\073\028\000\000\000\000\000\000\000\000\046\003\000\000\192\002\
\000\000\000\000\000\000\000\000\000\000\041\010\000\000\000\000\
\000\000\173\007\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\067\003\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\172\000\000\000\245\002\
\000\000\000\000\000\000\000\000\000\000\000\000\246\002\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\130\028\130\028\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\247\002\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\130\028\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\248\002\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000"

let yygindex = "\000\000\
\000\000\000\000\255\255\007\000\026\001\207\254\105\004\235\255\
\002\000\187\255\253\255\177\255\000\000\016\003\229\000\204\255\
\156\000\020\025\000\000\243\000\213\001\244\254\000\000\000\000\
\242\001\094\255\159\000\000\000\248\253\125\254\145\003\252\255\
\225\003\191\255\000\000\000\000\000\000\166\255\000\000\011\254\
\000\000\165\002\017\003\169\255\000\000\000\000\091\255\000\000\
\000\000\000\000\019\255\091\254\006\255\018\000\000\000\000\000\
\000\000\000\000\126\255\079\255\121\255\001\000\059\000\010\000\
\000\000\079\002\000\000\135\001\059\001\063\254\175\001\000\000\
\000\000\000\000\000\000\047\002\231\255\192\255\172\255\071\255\
\000\000\000\000\000\000\066\002\020\000\233\254\002\255\129\255\
\215\254\000\000\000\000\005\000\000\000\000\000\234\255\000\000\
\135\255\000\000\000\000\000\000\000\000\190\254\232\001\187\001\
\016\000\238\001\000\000\000\000\000\000\173\254\000\000\053\003\
\155\254\198\253\217\255\000\000\131\002\000\000\000\000\239\003\
\069\003\106\002\000\000\000\000\000\000\000\000\098\253\000\000\
\099\002\253\001\062\003\000\000\025\004\126\003\049\002\003\254\
\000\000\000\000\000\000\153\254\000\000\000\000\000\000\000\000\
\030\002\105\003\000\000\073\002\003\000\155\001\070\253\160\001\
\089\253\000\000\000\000"

let yytablesize = 7720
let yytable = "\135\000\
\200\000\132\000\063\000\059\000\083\000\201\000\070\000\170\000\
\170\000\098\001\156\000\173\000\070\000\178\000\216\000\237\001\
\117\001\073\000\057\001\061\000\224\001\086\002\024\002\073\000\
\236\000\061\000\042\001\090\002\011\001\167\000\228\000\197\002\
\112\002\166\000\066\001\043\002\042\001\060\001\061\001\245\000\
\159\002\085\002\011\001\134\000\009\003\042\001\027\003\155\000\
\011\001\012\001\029\002\099\001\183\002\242\000\001\001\214\000\
\095\000\009\000\155\000\234\000\064\000\087\002\000\001\091\002\
\241\001\028\003\025\002\241\001\168\000\241\001\241\001\202\001\
\044\002\071\002\051\001\241\001\072\001\064\001\136\000\072\002\
\218\000\196\002\189\002\127\001\219\000\241\001\241\001\242\000\
\232\001\002\001\095\000\243\000\084\001\137\001\232\001\073\000\
\080\002\217\000\113\001\080\001\235\001\108\000\227\000\028\001\
\222\000\018\000\223\000\046\003\154\001\028\001\232\000\135\000\
\241\001\238\000\008\001\244\000\181\000\030\001\045\000\123\001\
\132\000\081\002\051\002\030\001\241\000\027\003\200\000\234\000\
\009\002\075\002\114\001\112\001\200\000\237\002\075\001\108\000\
\011\001\040\000\227\002\075\001\013\001\044\001\126\000\107\002\
\028\003\075\001\078\001\003\001\126\000\200\000\135\000\128\001\
\050\001\126\000\144\001\146\001\083\000\169\000\070\000\051\001\
\218\001\158\002\242\002\159\000\043\001\011\001\180\000\055\000\
\129\000\073\000\136\000\052\001\218\001\043\001\129\000\244\000\
\057\001\044\001\122\001\129\000\052\002\019\002\126\000\135\000\
\181\002\095\001\223\001\076\002\182\000\083\000\160\002\100\001\
\241\001\096\001\051\001\183\000\073\002\040\003\121\002\210\002\
\218\001\042\003\073\000\041\002\097\001\034\002\115\002\075\001\
\129\000\042\002\130\000\232\001\132\000\011\002\012\002\135\001\
\014\002\083\000\057\001\253\000\131\000\147\001\120\001\065\002\
\219\000\166\000\028\001\186\000\066\002\118\001\072\001\023\002\
\051\001\064\001\154\002\073\000\051\001\145\001\191\000\199\001\
\030\001\219\000\135\000\133\002\208\001\205\001\206\001\024\002\
\033\002\207\001\219\000\234\000\073\000\044\001\203\001\080\001\
\192\000\149\002\194\002\152\002\188\000\073\000\135\000\200\000\
\208\001\137\001\234\000\235\000\032\002\187\000\219\000\033\002\
\169\000\136\001\051\001\240\001\137\001\237\001\255\000\189\000\
\253\000\073\000\200\002\201\002\153\002\072\001\200\000\078\002\
\169\000\244\000\244\000\201\000\116\002\117\002\190\000\084\002\
\013\002\059\002\010\002\041\001\159\000\042\001\130\000\011\001\
\016\003\123\002\125\002\000\003\135\000\210\000\050\001\200\000\
\131\000\193\002\083\000\162\001\070\000\159\000\159\000\145\002\
\004\003\008\001\234\000\200\000\012\001\174\002\051\001\073\000\
\097\002\052\001\012\001\244\000\048\003\049\003\062\001\235\000\
\051\001\013\002\063\001\051\001\229\000\231\000\027\002\135\000\
\159\000\050\002\097\000\113\002\174\000\190\002\135\000\175\000\
\050\001\008\001\083\002\010\003\083\000\211\000\070\000\117\001\
\110\002\029\003\187\002\247\000\113\001\063\003\166\002\233\000\
\114\002\073\000\226\000\052\001\009\000\159\000\113\001\113\001\
\174\000\218\001\218\001\175\000\167\002\218\000\176\000\011\001\
\012\001\239\002\155\000\135\001\159\000\083\000\031\002\008\001\
\120\001\045\000\063\001\045\000\177\000\045\000\135\001\045\000\
\083\000\237\000\009\001\234\000\239\000\045\000\159\000\115\002\
\045\000\045\000\045\000\045\000\045\000\045\000\090\001\013\001\
\090\002\240\000\012\001\106\001\018\000\013\001\246\000\034\001\
\177\000\235\000\235\000\235\000\235\000\235\000\235\000\235\000\
\235\000\235\000\235\000\235\000\235\000\235\000\235\000\235\000\
\235\000\235\000\235\000\235\000\235\000\136\001\174\000\012\001\
\072\001\249\002\151\002\156\002\174\000\135\000\174\000\208\001\
\136\001\175\000\033\002\235\000\213\000\219\000\174\000\119\002\
\163\002\003\003\164\002\089\001\004\001\008\001\080\001\125\001\
\073\000\200\000\235\000\200\000\044\001\017\003\112\001\215\001\
\177\002\126\000\126\001\129\002\120\002\234\000\135\000\045\000\
\134\002\253\000\008\001\215\001\236\001\253\000\253\000\238\001\
\239\001\253\000\170\000\234\000\253\000\234\000\177\000\006\001\
\170\000\235\000\005\001\129\000\155\000\013\001\098\001\156\001\
\196\000\007\001\170\000\234\000\045\000\188\002\170\000\215\001\
\059\002\157\002\010\001\135\000\135\000\208\001\208\001\046\001\
\200\000\211\001\235\000\219\000\219\000\098\001\185\000\127\002\
\098\001\008\001\013\001\098\001\166\000\128\002\073\000\073\000\
\026\002\159\000\244\000\178\002\099\001\059\002\218\000\099\001\
\099\001\193\000\099\001\027\002\159\000\168\002\044\001\070\000\
\234\000\194\000\195\000\160\000\038\000\203\002\230\000\230\000\
\212\000\251\002\073\000\062\001\061\000\069\001\242\000\063\001\
\204\002\095\000\176\000\070\001\252\002\098\001\044\001\170\000\
\253\000\056\002\202\002\057\002\253\000\248\000\070\001\110\001\
\080\001\185\002\198\000\228\002\099\001\008\001\147\001\242\000\
\135\002\059\002\110\001\126\000\125\001\199\000\136\002\047\003\
\125\001\008\001\253\000\235\000\106\001\088\002\106\001\155\000\
\085\001\253\000\140\002\196\000\102\001\135\000\108\000\215\002\
\128\002\127\001\097\000\135\000\135\000\129\000\088\001\005\003\
\103\001\130\002\218\002\220\002\221\002\197\000\059\002\059\002\
\222\002\223\002\198\000\144\002\059\002\200\000\130\001\135\000\
\135\000\128\002\097\002\253\002\254\002\199\000\135\000\213\000\
\208\001\001\003\148\001\176\002\233\002\234\002\219\000\150\001\
\234\000\136\002\043\000\152\001\244\000\126\000\070\000\195\002\
\147\001\073\000\143\002\044\000\037\003\072\002\155\001\198\002\
\245\002\073\000\044\001\061\000\135\000\072\002\095\001\052\000\
\204\001\053\000\083\000\054\000\100\001\235\000\096\001\129\000\
\215\001\215\001\044\001\212\001\160\000\213\001\211\002\073\000\
\212\002\097\001\213\002\235\000\200\000\235\000\126\000\234\000\
\043\000\097\002\026\000\218\000\224\002\160\000\160\000\222\001\
\198\000\044\000\128\002\235\000\135\000\135\000\208\001\135\000\
\235\000\013\003\221\001\199\000\219\000\052\000\225\001\053\000\
\129\000\054\000\018\003\135\000\020\003\025\003\006\002\073\000\
\160\000\225\002\010\000\231\002\062\001\020\002\007\003\128\002\
\063\001\008\001\031\000\032\000\072\002\235\000\008\003\168\002\
\227\001\019\003\121\001\228\001\072\002\034\003\035\001\008\001\
\235\000\015\002\036\001\198\000\037\001\160\000\038\001\039\001\
\040\001\226\001\147\001\038\000\229\001\040\000\199\000\135\000\
\021\003\135\000\028\002\135\000\160\000\016\002\008\001\135\000\
\135\000\022\003\017\002\060\003\050\003\253\000\051\003\008\001\
\053\003\008\001\234\001\071\001\055\003\056\003\160\000\232\001\
\234\001\235\000\230\001\055\000\106\001\232\001\200\001\201\001\
\230\001\230\001\025\001\026\001\027\001\028\001\029\001\030\001\
\031\001\032\001\033\001\030\002\135\000\135\000\069\003\070\003\
\038\002\106\001\106\001\040\002\135\000\047\002\074\003\038\000\
\048\002\038\000\049\002\038\000\155\000\038\000\235\000\235\000\
\196\000\200\001\146\002\038\000\235\000\231\001\038\000\038\000\
\038\000\038\000\038\000\038\000\038\000\038\000\038\000\038\000\
\038\000\038\000\038\000\038\000\106\001\046\000\047\000\198\000\
\235\000\067\002\242\000\105\001\242\000\242\000\242\000\016\000\
\242\000\235\002\199\000\074\002\242\000\242\000\242\000\064\003\
\065\003\242\000\242\000\242\000\242\000\242\000\242\000\242\000\
\242\000\242\000\242\000\242\000\242\000\242\000\242\000\242\000\
\242\000\242\000\242\000\242\000\242\000\242\000\242\000\242\000\
\027\001\028\001\029\001\030\001\031\001\032\001\033\001\235\000\
\021\001\022\001\023\001\024\001\025\001\026\001\027\001\028\001\
\029\001\030\001\031\001\032\001\033\001\038\000\093\002\069\002\
\094\002\106\002\082\002\126\000\001\000\002\000\003\000\004\000\
\005\000\160\000\029\001\030\001\031\001\032\001\033\001\102\002\
\108\002\111\002\118\002\214\001\160\000\131\002\132\002\141\002\
\147\002\044\002\038\000\148\002\161\002\129\000\175\002\172\002\
\242\000\173\002\179\002\180\002\191\002\077\002\208\002\142\002\
\209\002\255\000\229\002\095\002\216\002\238\002\230\002\243\002\
\030\003\244\002\246\002\247\002\014\003\026\000\248\002\026\000\
\015\003\026\000\255\002\026\000\002\003\242\000\023\003\032\003\
\035\003\228\000\088\002\036\003\026\000\026\000\026\000\010\000\
\010\000\010\000\010\000\024\003\038\003\182\002\041\003\044\003\
\010\000\054\003\045\003\010\000\010\000\010\000\010\000\010\000\
\010\000\010\000\010\000\010\000\010\000\010\000\010\000\010\000\
\010\000\010\000\052\003\010\000\010\000\010\000\010\000\010\000\
\010\000\010\000\010\000\010\000\010\000\010\000\010\000\010\000\
\010\000\010\000\010\000\010\000\010\000\010\000\010\000\010\000\
\010\000\010\000\010\000\010\000\010\000\010\000\010\000\010\000\
\030\003\010\000\010\000\010\000\010\000\010\000\010\000\010\000\
\010\000\010\000\010\000\010\000\010\000\010\000\010\000\010\000\
\010\000\010\000\010\000\026\000\057\003\010\000\058\003\059\003\
\061\003\062\003\068\003\010\000\048\000\073\003\072\003\097\000\
\051\001\162\000\250\001\121\001\010\000\246\001\010\000\010\000\
\010\000\175\000\010\000\010\000\010\000\163\000\023\001\094\001\
\026\000\168\000\151\001\010\000\154\001\010\000\149\001\120\001\
\164\000\093\001\245\001\227\000\167\000\160\001\244\001\161\001\
\159\001\010\000\058\000\010\000\053\002\010\000\010\000\010\000\
\226\002\151\001\045\001\010\000\016\000\016\000\016\000\016\000\
\010\000\070\002\126\002\171\002\033\003\016\000\071\003\012\003\
\016\000\016\000\016\000\016\000\016\000\016\000\016\000\016\000\
\016\000\016\000\016\000\016\000\016\000\016\000\016\000\192\002\
\016\000\016\000\016\000\016\000\016\000\016\000\016\000\016\000\
\016\000\016\000\016\000\016\000\016\000\016\000\016\000\016\000\
\016\000\016\000\016\000\016\000\016\000\016\000\016\000\016\000\
\016\000\016\000\016\000\016\000\016\000\006\003\016\000\016\000\
\016\000\016\000\016\000\016\000\016\000\016\000\016\000\016\000\
\016\000\016\000\016\000\016\000\016\000\016\000\016\000\016\000\
\043\003\186\002\016\000\105\002\131\001\199\002\205\002\092\002\
\016\000\011\003\079\001\104\002\037\002\250\002\241\002\068\002\
\232\002\016\000\067\003\016\000\016\000\016\000\066\003\016\000\
\016\000\016\000\000\000\000\000\000\000\124\001\000\000\255\000\
\016\000\000\000\016\000\255\000\255\000\000\000\000\000\255\000\
\000\000\000\000\255\000\000\000\000\000\000\000\016\000\000\000\
\016\000\000\000\016\000\016\000\016\000\000\000\000\000\228\000\
\016\000\000\000\228\000\228\000\228\000\016\000\228\000\228\000\
\228\000\000\000\228\000\000\000\000\000\000\000\228\000\228\000\
\228\000\000\000\000\000\228\000\228\000\228\000\228\000\228\000\
\228\000\228\000\228\000\228\000\228\000\228\000\228\000\228\000\
\228\000\228\000\228\000\228\000\228\000\228\000\228\000\228\000\
\228\000\228\000\228\000\228\000\228\000\228\000\228\000\000\000\
\228\000\228\000\228\000\228\000\228\000\228\000\228\000\228\000\
\228\000\228\000\228\000\228\000\228\000\228\000\228\000\228\000\
\228\000\228\000\000\000\000\000\000\000\000\000\255\000\000\000\
\000\000\000\000\255\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\228\000\000\000\228\000\
\000\000\228\000\228\000\000\000\000\000\000\000\228\000\097\001\
\255\000\000\000\228\000\000\000\000\000\000\000\000\000\255\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\228\000\000\000\000\000\
\228\000\227\000\000\000\000\000\227\000\227\000\227\000\228\000\
\227\000\227\000\227\000\000\000\227\000\000\000\000\000\000\000\
\227\000\227\000\227\000\000\000\000\000\227\000\227\000\227\000\
\227\000\227\000\227\000\227\000\227\000\227\000\227\000\227\000\
\227\000\227\000\227\000\227\000\227\000\227\000\227\000\227\000\
\227\000\227\000\227\000\227\000\227\000\227\000\227\000\227\000\
\227\000\000\000\227\000\227\000\227\000\227\000\227\000\227\000\
\227\000\227\000\227\000\227\000\227\000\227\000\227\000\227\000\
\227\000\227\000\227\000\227\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\155\000\000\000\000\000\000\000\
\031\002\000\000\000\000\000\000\063\001\000\000\000\000\227\000\
\000\000\227\000\000\000\227\000\227\000\000\000\000\000\000\000\
\227\000\089\000\197\000\000\000\227\000\000\000\000\000\198\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\199\000\000\000\000\000\000\000\000\000\227\000\
\000\000\000\000\227\000\124\001\000\000\000\000\124\001\124\001\
\124\001\227\000\124\001\124\001\124\001\000\000\124\001\000\000\
\000\000\000\000\124\001\124\001\124\001\000\000\000\000\124\001\
\124\001\124\001\124\001\124\001\124\001\124\001\124\001\124\001\
\124\001\124\001\124\001\124\001\124\001\124\001\124\001\124\001\
\124\001\124\001\124\001\124\001\124\001\124\001\124\001\124\001\
\124\001\124\001\124\001\126\000\124\001\124\001\124\001\124\001\
\124\001\124\001\124\001\124\001\124\001\124\001\124\001\124\001\
\124\001\124\001\124\001\124\001\124\001\124\001\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\129\000\155\000\000\000\
\000\000\000\000\031\002\020\002\000\000\000\000\063\001\000\000\
\000\000\124\001\000\000\124\001\000\000\124\001\124\001\000\000\
\000\000\000\000\124\001\094\000\000\000\000\000\124\001\000\000\
\000\000\198\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\199\000\000\000\000\000\000\000\
\000\000\124\001\000\000\000\000\124\001\097\001\000\000\000\000\
\097\001\097\001\097\001\124\001\097\001\097\001\097\001\000\000\
\097\001\000\000\012\000\000\000\097\001\097\001\097\001\000\000\
\000\000\097\001\097\001\097\001\097\001\097\001\097\001\097\001\
\097\001\097\001\097\001\097\001\097\001\097\001\097\001\097\001\
\097\001\097\001\097\001\097\001\097\001\097\001\097\001\097\001\
\097\001\097\001\097\001\097\001\097\001\126\000\097\001\097\001\
\097\001\097\001\097\001\097\001\097\001\097\001\097\001\097\001\
\097\001\097\001\097\001\097\001\097\001\097\001\097\001\097\001\
\000\000\000\000\000\000\000\000\055\001\000\000\000\000\129\000\
\055\001\055\001\000\000\000\000\055\001\000\000\155\000\055\001\
\000\000\000\000\196\000\097\001\000\000\097\001\000\000\097\001\
\097\001\000\000\055\001\000\000\097\001\000\000\000\000\055\001\
\097\001\000\000\000\000\095\002\000\000\000\000\000\000\000\000\
\000\000\198\000\055\001\000\000\000\000\000\000\000\000\000\000\
\000\000\165\000\000\000\097\001\199\000\000\000\097\001\095\000\
\000\000\000\000\000\000\089\000\089\000\097\001\089\000\089\000\
\089\000\089\000\089\000\089\000\089\000\089\000\089\000\089\000\
\089\000\000\000\000\000\089\000\089\000\089\000\089\000\089\000\
\089\000\089\000\089\000\089\000\089\000\089\000\089\000\089\000\
\089\000\089\000\089\000\089\000\089\000\089\000\089\000\089\000\
\089\000\089\000\051\000\055\001\000\000\155\000\000\000\055\001\
\000\000\196\000\043\000\000\000\000\000\126\000\000\000\000\000\
\000\000\000\000\000\000\044\000\000\000\000\000\000\000\000\000\
\000\000\000\000\095\002\096\002\000\000\055\001\000\000\052\000\
\198\000\053\000\000\000\054\000\055\001\000\000\000\000\129\000\
\057\000\000\000\000\000\199\000\155\000\000\000\000\000\000\000\
\031\002\000\000\000\000\000\000\063\001\000\000\000\000\000\000\
\000\000\000\000\089\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\198\000\
\000\000\000\000\000\000\166\000\000\000\000\000\000\000\000\000\
\000\000\165\000\199\000\056\000\000\000\094\000\094\000\089\000\
\094\000\094\000\094\000\094\000\094\000\094\000\094\000\094\000\
\094\000\094\000\094\000\000\000\126\000\094\000\094\000\094\000\
\094\000\094\000\094\000\094\000\094\000\094\000\094\000\094\000\
\094\000\094\000\094\000\094\000\094\000\094\000\094\000\094\000\
\094\000\094\000\094\000\094\000\012\000\012\000\129\000\012\000\
\012\000\012\000\012\000\012\000\012\000\012\000\012\000\012\000\
\012\000\012\000\000\000\126\000\012\000\012\000\012\000\012\000\
\012\000\012\000\012\000\012\000\012\000\012\000\012\000\012\000\
\012\000\012\000\012\000\012\000\012\000\012\000\012\000\012\000\
\012\000\012\000\012\000\000\000\058\000\129\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\013\001\
\000\000\000\000\000\000\000\000\094\000\014\001\015\001\016\001\
\017\001\018\001\019\001\020\001\021\001\022\001\023\001\024\001\
\025\001\026\001\027\001\028\001\029\001\030\001\031\001\032\001\
\033\001\000\000\000\000\166\000\000\000\028\000\000\000\000\000\
\000\000\094\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\012\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\095\000\095\000\000\000\095\000\095\000\095\000\095\000\
\095\000\095\000\095\000\095\000\095\000\095\000\095\000\034\000\
\012\000\095\000\095\000\095\000\095\000\095\000\095\000\095\000\
\095\000\095\000\095\000\095\000\095\000\095\000\095\000\095\000\
\095\000\095\000\095\000\095\000\095\000\095\000\095\000\095\000\
\000\000\000\000\000\000\000\000\000\000\051\000\000\000\051\000\
\000\000\051\000\000\000\051\000\000\000\000\000\035\000\051\000\
\051\000\051\000\000\000\000\000\051\000\051\000\051\000\051\000\
\051\000\051\000\051\000\051\000\051\000\051\000\051\000\051\000\
\051\000\051\000\051\000\051\000\051\000\051\000\051\000\051\000\
\051\000\051\000\051\000\057\000\000\000\057\000\000\000\057\000\
\000\000\057\000\000\000\000\000\000\000\057\000\057\000\057\000\
\095\000\000\000\057\000\057\000\057\000\057\000\057\000\057\000\
\057\000\057\000\057\000\057\000\057\000\057\000\057\000\057\000\
\057\000\057\000\057\000\057\000\057\000\057\000\057\000\057\000\
\057\000\000\000\000\000\000\000\000\000\095\000\056\000\000\000\
\056\000\000\000\056\000\000\000\056\000\000\000\000\000\036\000\
\056\000\056\000\056\000\051\000\000\000\056\000\056\000\056\000\
\056\000\056\000\056\000\056\000\056\000\056\000\056\000\056\000\
\056\000\056\000\056\000\056\000\056\000\056\000\056\000\056\000\
\056\000\056\000\056\000\056\000\000\000\000\000\037\000\000\000\
\051\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\057\000\015\001\016\001\017\001\018\001\019\001\020\001\
\021\001\022\001\023\001\024\001\025\001\026\001\027\001\028\001\
\029\001\030\001\031\001\032\001\033\001\039\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\057\000\058\000\
\000\000\058\000\000\000\058\000\000\000\058\000\000\000\000\000\
\000\000\058\000\058\000\058\000\056\000\000\000\058\000\058\000\
\058\000\058\000\058\000\058\000\058\000\058\000\058\000\058\000\
\058\000\058\000\058\000\058\000\058\000\058\000\058\000\058\000\
\058\000\058\000\058\000\058\000\058\000\000\000\000\000\040\000\
\028\000\056\000\028\000\000\000\028\000\000\000\028\000\000\000\
\000\000\000\000\000\000\000\000\028\000\000\000\000\000\028\000\
\028\000\028\000\028\000\028\000\028\000\028\000\028\000\028\000\
\028\000\028\000\028\000\028\000\028\000\028\000\028\000\028\000\
\028\000\028\000\028\000\028\000\028\000\028\000\041\000\000\000\
\000\000\000\000\034\000\000\000\034\000\000\000\034\000\000\000\
\034\000\000\000\000\000\000\000\000\000\058\000\034\000\000\000\
\000\000\034\000\034\000\034\000\034\000\034\000\034\000\034\000\
\034\000\034\000\034\000\034\000\034\000\034\000\034\000\034\000\
\034\000\034\000\034\000\000\000\000\000\000\000\000\000\042\000\
\000\000\035\000\058\000\035\000\000\000\035\000\000\000\035\000\
\000\000\000\000\000\000\000\000\000\000\035\000\028\000\000\000\
\035\000\035\000\035\000\035\000\035\000\035\000\035\000\035\000\
\035\000\035\000\035\000\035\000\035\000\035\000\035\000\035\000\
\035\000\035\000\000\000\000\000\000\000\000\000\000\000\043\000\
\000\000\000\000\000\000\028\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\053\001\000\000\
\034\000\000\000\053\001\053\001\000\000\000\000\053\001\000\000\
\000\000\053\001\000\000\044\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\053\001\000\000\000\000\000\000\
\000\000\053\001\036\000\000\000\036\000\034\000\036\000\000\000\
\036\000\000\000\046\000\000\000\053\001\000\000\036\000\035\000\
\000\000\036\000\036\000\036\000\036\000\036\000\036\000\036\000\
\036\000\036\000\036\000\036\000\036\000\036\000\036\000\036\000\
\036\000\037\000\000\000\037\000\000\000\037\000\000\000\037\000\
\000\000\000\000\000\000\047\000\035\000\037\000\000\000\000\000\
\037\000\037\000\037\000\037\000\037\000\037\000\037\000\037\000\
\037\000\037\000\037\000\037\000\037\000\037\000\037\000\037\000\
\039\000\000\000\039\000\000\000\039\000\053\001\039\000\048\000\
\000\000\053\001\000\000\000\000\039\000\000\000\000\000\039\000\
\039\000\039\000\039\000\039\000\039\000\039\000\039\000\039\000\
\039\000\039\000\039\000\039\000\039\000\000\000\000\000\053\001\
\036\000\000\000\000\000\000\000\000\000\000\000\053\001\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\040\000\000\000\040\000\000\000\040\000\000\000\
\040\000\000\000\000\000\000\000\000\000\036\000\040\000\037\000\
\000\000\040\000\040\000\040\000\040\000\040\000\040\000\040\000\
\040\000\040\000\040\000\040\000\040\000\040\000\040\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\041\000\000\000\041\000\037\000\041\000\039\000\041\000\
\146\000\000\000\000\000\000\000\000\000\041\000\000\000\000\000\
\041\000\041\000\041\000\041\000\041\000\041\000\041\000\041\000\
\041\000\041\000\041\000\041\000\041\000\041\000\000\000\000\000\
\000\000\000\000\000\000\039\000\000\000\000\000\000\000\000\000\
\000\000\000\000\042\000\000\000\042\000\000\000\042\000\000\000\
\042\000\000\000\000\000\000\000\000\000\000\000\042\000\000\000\
\040\000\042\000\042\000\042\000\042\000\042\000\042\000\042\000\
\042\000\042\000\042\000\019\001\020\001\021\001\022\001\023\001\
\024\001\025\001\026\001\027\001\028\001\029\001\030\001\031\001\
\032\001\033\001\043\000\000\000\043\000\040\000\043\000\000\000\
\043\000\000\000\000\000\000\000\000\000\000\000\043\000\041\000\
\000\000\043\000\043\000\043\000\043\000\043\000\043\000\043\000\
\043\000\043\000\043\000\000\000\000\000\000\000\044\000\000\000\
\044\000\000\000\044\000\000\000\044\000\000\000\000\000\000\000\
\000\000\000\000\044\000\000\000\041\000\044\000\044\000\044\000\
\044\000\044\000\044\000\044\000\044\000\046\000\033\001\046\000\
\042\000\046\000\000\000\046\000\000\000\034\001\155\000\000\000\
\000\000\046\000\196\000\000\000\046\000\046\000\046\000\046\000\
\046\000\046\000\046\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\042\000\047\000\000\000\
\047\000\198\000\047\000\000\000\047\000\000\000\000\000\000\000\
\043\000\000\000\047\000\000\000\199\000\047\000\047\000\047\000\
\047\000\047\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\048\000\000\000\048\000\000\000\048\000\000\000\
\048\000\000\000\000\000\000\000\044\000\043\000\048\000\000\000\
\000\000\048\000\048\000\048\000\048\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\056\000\000\000\000\000\000\000\
\000\000\000\000\000\000\046\000\000\000\000\000\000\000\000\000\
\000\000\044\000\043\000\000\000\000\000\126\000\000\000\000\000\
\000\000\000\000\000\000\044\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\052\000\
\046\000\053\000\000\000\054\000\047\000\000\000\000\000\129\000\
\000\000\000\000\000\000\000\000\000\000\146\000\146\000\146\000\
\146\000\146\000\000\000\000\000\000\000\146\000\146\000\000\000\
\146\000\146\000\146\000\000\000\146\000\146\000\000\000\000\000\
\048\000\047\000\000\000\146\000\146\000\000\000\000\000\000\000\
\146\000\146\000\164\000\000\000\146\000\000\000\146\000\000\000\
\000\000\146\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\146\000\146\000\146\000\048\000\000\000\000\000\
\000\000\146\000\146\000\146\000\146\000\146\000\146\000\146\000\
\146\000\146\000\146\000\146\000\146\000\146\000\146\000\146\000\
\146\000\146\000\146\000\146\000\146\000\146\000\146\000\146\000\
\146\000\146\000\146\000\000\000\146\000\146\000\146\000\146\000\
\146\000\146\000\146\000\146\000\146\000\146\000\146\000\146\000\
\146\000\146\000\000\000\000\000\146\000\146\000\146\000\054\001\
\146\000\146\000\146\000\054\001\054\001\146\000\000\000\054\001\
\000\000\146\000\054\001\146\000\000\000\146\000\146\000\146\000\
\146\000\146\000\146\000\146\000\146\000\054\001\146\000\146\000\
\000\000\146\000\054\001\146\000\146\000\000\000\146\000\146\000\
\146\000\146\000\056\001\146\000\033\001\054\001\056\001\056\001\
\033\001\033\001\056\001\034\001\033\001\056\001\000\000\034\001\
\034\001\000\000\000\000\034\001\000\000\000\000\000\000\000\000\
\056\001\033\001\033\001\000\000\000\000\056\001\000\000\033\001\
\034\001\034\001\000\000\000\000\000\000\000\000\034\001\000\000\
\056\001\000\000\033\001\000\000\000\000\000\000\000\000\000\000\
\000\000\034\001\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\054\001\000\000\
\052\001\000\000\054\001\000\000\052\001\052\001\000\000\000\000\
\052\001\000\000\000\000\052\001\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\052\001\000\000\
\054\001\000\000\009\000\052\001\010\000\011\000\000\000\054\001\
\000\000\056\001\000\000\033\001\000\000\056\001\052\001\000\000\
\000\000\000\000\034\001\000\000\000\000\000\000\000\000\000\000\
\012\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\056\001\000\000\033\001\000\000\000\000\
\000\000\000\000\056\001\000\000\034\001\013\000\014\000\015\000\
\016\000\017\000\018\000\019\000\020\000\021\000\022\000\023\000\
\024\000\025\000\026\000\027\000\028\000\029\000\030\000\031\000\
\032\000\033\000\034\000\035\000\036\000\000\000\000\000\052\001\
\000\000\000\000\000\000\052\001\000\000\000\000\000\000\000\000\
\000\000\000\000\010\000\011\000\000\000\000\000\000\000\037\000\
\038\000\039\000\040\000\000\000\041\000\042\000\043\000\000\000\
\000\000\052\001\000\000\000\000\000\000\000\000\000\000\044\000\
\052\001\045\000\046\000\047\000\048\000\049\000\050\000\051\000\
\000\000\000\000\000\000\052\000\000\000\053\000\000\000\054\000\
\055\000\000\000\000\000\013\000\014\000\015\000\016\000\017\000\
\000\000\019\000\020\000\021\000\022\000\023\000\024\000\025\000\
\026\000\027\000\028\000\029\000\030\000\031\000\032\000\033\000\
\034\000\035\000\036\000\000\000\000\000\000\000\088\000\089\000\
\090\000\091\000\092\000\000\000\000\000\000\000\093\000\155\000\
\070\001\000\000\011\000\096\000\234\001\163\000\038\000\000\000\
\040\000\000\000\041\000\042\000\098\000\099\000\000\000\000\000\
\000\000\100\000\101\000\000\000\000\000\000\000\000\000\103\000\
\000\000\000\000\104\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\105\000\106\000\107\000\055\000\000\000\
\000\000\000\000\013\000\014\000\015\000\016\000\017\000\000\000\
\019\000\020\000\021\000\022\000\023\000\024\000\025\000\026\000\
\027\000\028\000\029\000\030\000\031\000\032\000\033\000\034\000\
\035\000\036\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\121\000\
\122\000\123\000\124\000\000\000\000\000\038\000\000\000\040\000\
\000\000\041\000\042\000\000\000\000\000\000\000\126\000\000\000\
\088\000\089\000\090\000\091\000\092\000\000\000\000\000\000\000\
\093\000\155\000\070\001\000\000\011\000\096\000\008\002\000\000\
\000\000\000\000\000\000\000\000\000\000\055\000\098\000\099\000\
\129\000\130\000\000\000\100\000\101\000\000\000\000\000\000\000\
\214\001\103\000\000\000\000\000\104\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\105\000\106\000\107\000\
\000\000\000\000\000\000\000\000\013\000\014\000\015\000\016\000\
\017\000\000\000\019\000\020\000\021\000\022\000\023\000\024\000\
\025\000\026\000\027\000\028\000\029\000\030\000\031\000\032\000\
\033\000\034\000\035\000\036\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\121\000\122\000\123\000\124\000\000\000\000\000\038\000\
\000\000\040\000\000\000\041\000\042\000\000\000\000\000\000\000\
\126\000\000\000\088\000\089\000\090\000\091\000\092\000\000\000\
\000\000\000\000\093\000\155\000\070\001\000\000\011\000\096\000\
\122\002\000\000\000\000\000\000\000\000\000\000\000\000\055\000\
\098\000\099\000\129\000\130\000\000\000\100\000\101\000\000\000\
\000\000\000\000\214\001\103\000\000\000\000\000\104\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\105\000\
\106\000\107\000\000\000\000\000\000\000\000\000\013\000\014\000\
\015\000\016\000\017\000\000\000\019\000\020\000\021\000\022\000\
\023\000\024\000\025\000\026\000\027\000\028\000\029\000\030\000\
\031\000\032\000\033\000\034\000\035\000\036\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\121\000\122\000\123\000\124\000\000\000\
\000\000\038\000\000\000\040\000\000\000\041\000\042\000\000\000\
\000\000\000\000\126\000\000\000\088\000\089\000\090\000\091\000\
\092\000\000\000\000\000\000\000\093\000\155\000\070\001\000\000\
\011\000\096\000\124\002\000\000\000\000\000\000\000\000\000\000\
\000\000\055\000\098\000\099\000\129\000\130\000\000\000\100\000\
\101\000\000\000\000\000\000\000\214\001\103\000\000\000\000\000\
\104\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\105\000\106\000\107\000\000\000\000\000\000\000\000\000\
\013\000\014\000\015\000\016\000\017\000\000\000\019\000\020\000\
\021\000\022\000\023\000\024\000\025\000\026\000\027\000\028\000\
\029\000\030\000\031\000\032\000\033\000\034\000\035\000\036\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\121\000\122\000\123\000\
\124\000\000\000\000\000\038\000\000\000\040\000\000\000\041\000\
\042\000\000\000\000\000\000\000\126\000\000\000\088\000\089\000\
\090\000\091\000\092\000\000\000\000\000\000\000\093\000\155\000\
\070\001\000\000\011\000\096\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\055\000\098\000\099\000\129\000\130\000\
\000\000\100\000\101\000\000\000\000\000\000\000\214\001\103\000\
\000\000\000\000\104\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\105\000\106\000\107\000\000\000\000\000\
\000\000\000\000\013\000\014\000\015\000\016\000\017\000\000\000\
\019\000\020\000\021\000\022\000\023\000\024\000\025\000\026\000\
\027\000\028\000\029\000\030\000\031\000\032\000\033\000\034\000\
\035\000\036\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\121\000\
\122\000\123\000\124\000\000\000\000\000\038\000\000\000\040\000\
\000\000\041\000\042\000\000\000\000\000\000\000\126\000\000\000\
\088\000\089\000\090\000\091\000\092\000\000\000\000\000\000\000\
\093\000\155\000\070\001\000\000\011\000\096\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\055\000\098\000\099\000\
\129\000\130\000\000\000\100\000\101\000\000\000\000\000\000\000\
\105\001\103\000\000\000\000\000\104\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\105\000\106\000\107\000\
\000\000\000\000\000\000\000\000\013\000\014\000\015\000\016\000\
\017\000\000\000\019\000\020\000\021\000\022\000\023\000\024\000\
\025\000\026\000\027\000\028\000\029\000\030\000\031\000\032\000\
\033\000\034\000\035\000\036\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\121\000\122\000\123\000\124\000\000\000\000\000\038\000\
\000\000\040\000\000\000\041\000\042\000\000\000\000\000\000\000\
\126\000\000\000\088\000\089\000\090\000\091\000\092\000\000\000\
\000\000\000\000\093\000\094\000\000\000\010\000\047\001\096\000\
\000\000\097\000\000\000\000\000\000\000\000\000\000\000\055\000\
\098\000\099\000\129\000\130\000\000\000\100\000\101\000\000\000\
\000\000\102\000\214\001\103\000\000\000\000\000\104\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\105\000\
\106\000\107\000\000\000\000\000\000\000\000\000\013\000\014\000\
\015\000\016\000\017\000\108\000\019\000\020\000\021\000\022\000\
\023\000\024\000\025\000\026\000\027\000\028\000\029\000\030\000\
\031\000\032\000\033\000\034\000\035\000\036\000\109\000\110\000\
\000\000\111\000\112\000\113\000\114\000\091\001\116\000\117\000\
\118\000\119\000\120\000\121\000\122\000\123\000\124\000\000\000\
\000\000\038\000\092\001\040\000\000\000\041\000\042\000\043\000\
\000\000\000\000\126\000\093\001\094\001\000\000\000\000\000\000\
\044\000\000\000\045\000\046\000\047\000\048\000\049\000\050\000\
\051\000\127\000\000\000\000\000\052\000\000\000\053\000\000\000\
\054\000\055\000\000\000\128\000\129\000\130\000\000\000\000\000\
\131\000\140\000\140\000\140\000\140\000\140\000\000\000\000\000\
\000\000\140\000\140\000\000\000\140\000\140\000\140\000\000\000\
\140\000\000\000\000\000\000\000\000\000\000\000\000\000\140\000\
\140\000\000\000\000\000\000\000\140\000\140\000\000\000\000\000\
\140\000\000\000\140\000\000\000\000\000\140\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\140\000\140\000\
\140\000\000\000\000\000\000\000\000\000\140\000\140\000\140\000\
\140\000\140\000\140\000\140\000\140\000\140\000\140\000\140\000\
\140\000\140\000\140\000\140\000\140\000\140\000\140\000\140\000\
\140\000\140\000\140\000\140\000\140\000\140\000\140\000\000\000\
\140\000\140\000\140\000\140\000\140\000\140\000\140\000\140\000\
\140\000\140\000\140\000\140\000\140\000\140\000\000\000\000\000\
\140\000\140\000\140\000\000\000\140\000\140\000\140\000\000\000\
\000\000\140\000\000\000\000\000\000\000\152\001\000\000\140\000\
\000\000\140\000\140\000\140\000\140\000\140\000\140\000\140\000\
\140\000\000\000\000\000\140\000\000\000\140\000\000\000\140\000\
\140\000\000\000\140\000\140\000\140\000\140\000\000\000\140\000\
\139\000\139\000\139\000\139\000\139\000\000\000\000\000\000\000\
\139\000\139\000\000\000\139\000\139\000\139\000\000\000\139\000\
\000\000\000\000\000\000\000\000\000\000\000\000\139\000\139\000\
\000\000\000\000\000\000\139\000\139\000\000\000\000\000\139\000\
\000\000\139\000\000\000\000\000\139\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\139\000\139\000\139\000\
\000\000\000\000\000\000\000\000\139\000\139\000\139\000\139\000\
\139\000\139\000\139\000\139\000\139\000\139\000\139\000\139\000\
\139\000\139\000\139\000\139\000\139\000\139\000\139\000\139\000\
\139\000\139\000\139\000\139\000\139\000\139\000\000\000\139\000\
\139\000\139\000\139\000\139\000\139\000\139\000\139\000\139\000\
\139\000\139\000\139\000\139\000\139\000\000\000\000\000\139\000\
\139\000\139\000\000\000\139\000\139\000\139\000\000\000\000\000\
\139\000\000\000\000\000\000\000\153\001\000\000\139\000\000\000\
\139\000\139\000\139\000\139\000\139\000\139\000\139\000\139\000\
\000\000\000\000\139\000\000\000\139\000\000\000\139\000\139\000\
\000\000\139\000\139\000\139\000\139\000\000\000\139\000\141\000\
\141\000\141\000\141\000\141\000\000\000\000\000\000\000\141\000\
\141\000\000\000\141\000\141\000\141\000\000\000\141\000\000\000\
\000\000\000\000\000\000\000\000\000\000\141\000\141\000\000\000\
\000\000\000\000\141\000\141\000\000\000\000\000\141\000\000\000\
\141\000\000\000\000\000\141\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\141\000\141\000\141\000\000\000\
\000\000\000\000\000\000\141\000\141\000\141\000\141\000\141\000\
\141\000\141\000\141\000\141\000\141\000\141\000\141\000\141\000\
\141\000\141\000\141\000\141\000\141\000\141\000\141\000\141\000\
\141\000\141\000\141\000\141\000\141\000\000\000\141\000\141\000\
\141\000\141\000\141\000\141\000\141\000\141\000\141\000\141\000\
\141\000\141\000\141\000\141\000\000\000\000\000\141\000\141\000\
\141\000\000\000\141\000\141\000\141\000\000\000\000\000\141\000\
\000\000\000\000\000\000\157\001\000\000\141\000\000\000\141\000\
\141\000\141\000\141\000\141\000\141\000\141\000\141\000\000\000\
\000\000\141\000\000\000\141\000\000\000\141\000\141\000\000\000\
\141\000\141\000\141\000\141\000\000\000\141\000\088\000\089\000\
\090\000\091\000\092\000\000\000\000\000\000\000\093\000\094\000\
\000\000\010\000\047\001\096\000\000\000\097\000\000\000\000\000\
\000\000\000\000\000\000\000\000\098\000\099\000\000\000\000\000\
\000\000\100\000\101\000\000\000\000\000\102\000\000\000\103\000\
\000\000\000\000\104\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\105\000\106\000\107\000\000\000\000\000\
\000\000\000\000\013\000\014\000\015\000\016\000\017\000\108\000\
\019\000\020\000\021\000\022\000\023\000\024\000\025\000\026\000\
\027\000\028\000\029\000\030\000\031\000\032\000\033\000\034\000\
\035\000\036\000\109\000\110\000\000\000\111\000\112\000\113\000\
\114\000\091\001\116\000\117\000\118\000\119\000\120\000\121\000\
\122\000\123\000\124\000\000\000\000\000\038\000\092\001\040\000\
\000\000\041\000\042\000\043\000\000\000\000\000\126\000\000\000\
\094\001\000\000\000\000\000\000\044\000\000\000\045\000\046\000\
\047\000\048\000\049\000\050\000\051\000\127\000\000\000\000\000\
\052\000\000\000\053\000\000\000\054\000\055\000\000\000\128\000\
\129\000\130\000\000\000\000\000\131\000\088\000\089\000\090\000\
\091\000\092\000\000\000\000\000\000\000\093\000\094\000\000\000\
\010\000\047\001\096\000\000\000\097\000\000\000\000\000\000\000\
\000\000\000\000\000\000\098\000\099\000\000\000\000\000\000\000\
\100\000\101\000\000\000\000\000\102\000\000\000\103\000\000\000\
\000\000\104\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\105\000\106\000\107\000\000\000\000\000\000\000\
\000\000\013\000\014\000\015\000\016\000\017\000\108\000\019\000\
\020\000\021\000\022\000\023\000\024\000\025\000\026\000\027\000\
\028\000\029\000\030\000\031\000\032\000\033\000\034\000\035\000\
\036\000\109\000\110\000\000\000\111\000\048\001\113\000\114\000\
\115\000\116\000\117\000\118\000\119\000\049\001\121\000\122\000\
\123\000\124\000\000\000\000\000\038\000\125\000\040\000\000\000\
\041\000\042\000\043\000\000\000\000\000\126\000\000\000\000\000\
\000\000\000\000\000\000\044\000\000\000\045\000\046\000\047\000\
\048\000\049\000\050\000\051\000\127\000\000\000\000\000\052\000\
\000\000\053\000\000\000\054\000\055\000\000\000\128\000\129\000\
\130\000\000\000\000\000\131\000\088\000\089\000\090\000\091\000\
\092\000\000\000\000\000\000\000\093\000\094\000\000\000\000\000\
\047\001\096\000\000\000\097\000\000\000\000\000\000\000\000\000\
\000\000\000\000\098\000\099\000\000\000\000\000\000\000\100\000\
\101\000\000\000\000\000\102\000\000\000\103\000\000\000\000\000\
\104\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\105\000\106\000\107\000\000\000\000\000\000\000\000\000\
\013\000\014\000\015\000\016\000\017\000\108\000\019\000\020\000\
\021\000\022\000\023\000\024\000\025\000\026\000\027\000\028\000\
\029\000\030\000\031\000\032\000\033\000\034\000\035\000\036\000\
\109\000\110\000\000\000\111\000\112\000\113\000\114\000\115\000\
\116\000\117\000\118\000\119\000\120\000\121\000\122\000\123\000\
\124\000\000\000\000\000\038\000\125\000\040\000\000\000\041\000\
\042\000\000\000\000\000\000\000\126\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\088\000\089\000\090\000\
\091\000\092\000\000\000\127\000\000\000\093\000\094\000\000\000\
\000\000\095\000\096\000\055\000\097\000\128\000\129\000\130\000\
\000\000\000\000\131\000\098\000\099\000\000\000\000\000\000\000\
\100\000\101\000\000\000\000\000\102\000\000\000\103\000\000\000\
\000\000\104\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\105\000\106\000\107\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\108\000\016\001\
\017\001\018\001\019\001\020\001\021\001\022\001\023\001\024\001\
\025\001\026\001\027\001\028\001\029\001\030\001\031\001\032\001\
\033\001\109\000\110\000\000\000\111\000\112\000\113\000\114\000\
\115\000\116\000\117\000\118\000\119\000\120\000\121\000\122\000\
\123\000\124\000\000\000\000\000\000\000\125\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\126\000\088\000\089\000\
\090\000\091\000\092\000\000\000\000\000\045\000\093\000\094\000\
\000\000\000\000\095\000\096\000\127\000\097\000\000\000\000\000\
\000\000\000\000\000\000\000\000\098\000\099\000\128\000\129\000\
\130\000\100\000\101\000\131\000\000\000\102\000\000\000\103\000\
\000\000\000\000\104\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\105\000\106\000\107\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\108\000\
\017\001\018\001\019\001\020\001\021\001\022\001\023\001\024\001\
\025\001\026\001\027\001\028\001\029\001\030\001\031\001\032\001\
\033\001\000\000\109\000\110\000\000\000\111\000\112\000\113\000\
\114\000\115\000\116\000\117\000\118\000\119\000\120\000\121\000\
\122\000\123\000\124\000\000\000\000\000\000\000\125\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\126\000\088\000\
\089\000\090\000\091\000\092\000\000\000\000\000\000\000\093\000\
\155\000\000\000\000\000\011\000\096\000\127\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\098\000\099\000\128\000\
\129\000\130\000\100\000\101\000\131\000\000\000\102\000\000\000\
\103\000\000\000\000\000\104\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\105\000\106\000\107\000\000\000\
\000\000\000\000\000\000\013\000\014\000\015\000\016\000\017\000\
\000\000\019\000\020\000\021\000\022\000\023\000\024\000\025\000\
\026\000\027\000\028\000\029\000\030\000\031\000\032\000\033\000\
\034\000\035\000\036\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\121\000\122\000\123\000\124\000\000\000\000\000\038\000\000\000\
\040\000\000\000\041\000\042\000\000\000\000\000\000\000\126\000\
\000\000\088\000\089\000\090\000\091\000\092\000\000\000\000\000\
\000\000\093\000\155\000\000\000\000\000\011\000\096\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\055\000\098\000\
\099\000\129\000\130\000\000\000\100\000\101\000\000\000\000\000\
\000\000\000\000\103\000\000\000\000\000\104\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\105\000\106\000\
\107\000\000\000\000\000\000\000\000\000\013\000\014\000\015\000\
\016\000\017\000\000\000\019\000\020\000\021\000\022\000\023\000\
\024\000\025\000\000\000\000\000\000\000\000\000\000\000\031\000\
\032\000\033\000\034\000\035\000\036\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\121\000\122\000\123\000\124\000\000\000\000\000\
\038\000\000\000\000\000\000\000\000\000\042\000\000\000\000\000\
\000\000\126\000\088\000\089\000\090\000\091\000\092\000\000\000\
\000\000\000\000\093\000\054\002\000\000\000\000\175\000\096\000\
\000\000\055\002\182\002\056\002\000\000\057\002\000\000\000\000\
\098\000\099\000\000\000\129\000\130\000\100\000\101\000\000\000\
\000\000\000\000\000\000\103\000\000\000\000\000\104\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\105\000\
\106\000\107\000\000\000\000\000\088\000\089\000\090\000\091\000\
\092\000\000\000\000\000\177\000\093\000\054\002\000\000\000\000\
\175\000\096\000\000\000\055\002\236\002\056\002\000\000\057\002\
\000\000\000\000\098\000\099\000\000\000\000\000\000\000\100\000\
\101\000\000\000\000\000\000\000\000\000\103\000\000\000\000\000\
\104\000\000\000\000\000\121\000\122\000\123\000\124\000\000\000\
\000\000\105\000\106\000\107\000\000\000\000\000\000\000\000\000\
\000\000\000\000\126\000\000\000\000\000\177\000\000\000\000\000\
\088\000\089\000\090\000\091\000\092\000\000\000\000\000\000\000\
\093\000\054\002\000\000\000\000\175\000\096\000\000\000\055\002\
\000\000\056\002\000\000\057\002\129\000\130\000\098\000\099\000\
\000\000\000\000\000\000\100\000\101\000\121\000\122\000\123\000\
\124\000\103\000\000\000\000\000\104\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\126\000\105\000\106\000\107\000\
\000\000\000\000\088\000\089\000\090\000\091\000\092\000\000\000\
\000\000\177\000\093\000\155\000\000\000\000\000\000\000\096\000\
\000\000\097\000\000\000\000\000\000\000\000\000\129\000\130\000\
\098\000\099\000\000\000\000\000\000\000\100\000\101\000\000\000\
\000\000\000\000\000\000\103\000\000\000\000\000\104\000\000\000\
\000\000\121\000\122\000\123\000\124\000\000\000\000\000\105\000\
\106\000\107\000\000\000\088\000\089\000\090\000\091\000\092\000\
\126\000\000\000\000\000\093\000\155\000\000\000\000\000\000\000\
\096\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\
\000\000\098\000\099\000\000\000\000\000\000\000\100\000\101\000\
\000\000\000\000\129\000\130\000\103\000\000\000\000\000\104\000\
\000\000\000\000\000\000\121\000\122\000\123\000\124\000\000\000\
\105\000\106\000\107\000\000\000\000\000\088\000\089\000\090\000\
\091\000\092\000\126\000\000\000\000\000\093\000\155\000\000\000\
\000\000\000\000\096\000\000\000\000\000\000\000\000\000\022\002\
\000\000\000\000\000\000\098\000\099\000\000\000\000\000\000\000\
\100\000\101\000\000\000\000\000\129\000\130\000\103\000\000\000\
\000\000\104\000\000\000\000\000\121\000\122\000\123\000\124\000\
\000\000\000\000\105\000\106\000\107\000\000\000\088\000\089\000\
\090\000\091\000\092\000\126\000\000\000\000\000\093\000\155\000\
\000\000\000\000\000\000\096\000\000\000\000\000\000\000\000\000\
\077\002\000\000\000\000\000\000\098\000\099\000\000\000\000\000\
\000\000\100\000\101\000\000\000\000\000\129\000\130\000\103\000\
\000\000\000\000\104\000\000\000\000\000\000\000\121\000\122\000\
\123\000\124\000\000\000\105\000\106\000\107\000\000\000\000\000\
\088\000\089\000\090\000\091\000\092\000\126\000\000\000\000\000\
\093\000\155\000\000\000\000\000\000\000\096\000\000\000\055\002\
\000\000\000\000\000\000\000\000\000\000\000\000\098\000\099\000\
\000\000\000\000\000\000\100\000\101\000\000\000\000\000\129\000\
\130\000\103\000\000\000\000\000\104\000\000\000\000\000\121\000\
\122\000\123\000\124\000\000\000\000\000\105\000\106\000\107\000\
\000\000\000\000\000\000\000\000\000\000\000\000\126\000\018\001\
\019\001\020\001\021\001\022\001\023\001\024\001\025\001\026\001\
\027\001\028\001\029\001\030\001\031\001\032\001\033\001\000\000\
\000\000\000\000\088\000\089\000\090\000\091\000\092\000\000\000\
\129\000\130\000\093\000\155\000\000\000\000\000\000\000\096\000\
\000\000\121\000\122\000\123\000\124\000\000\000\000\000\000\000\
\098\000\099\000\000\000\000\000\000\000\100\000\101\000\000\000\
\126\000\102\000\000\000\103\000\000\000\000\000\104\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\105\000\
\106\000\107\000\000\000\000\000\088\000\089\000\090\000\091\000\
\092\000\000\000\129\000\130\000\093\000\155\000\000\000\000\000\
\000\000\096\000\000\000\142\002\000\000\000\000\000\000\000\000\
\000\000\000\000\098\000\099\000\000\000\000\000\000\000\100\000\
\101\000\000\000\000\000\000\000\000\000\103\000\000\000\000\000\
\104\000\000\000\000\000\121\000\122\000\123\000\124\000\000\000\
\000\000\105\000\106\000\107\000\000\000\088\000\089\000\090\000\
\091\000\092\000\126\000\000\000\000\000\093\000\155\000\000\000\
\000\000\000\000\096\000\000\000\000\000\000\000\000\000\150\002\
\000\000\000\000\000\000\098\000\099\000\000\000\000\000\000\000\
\100\000\101\000\000\000\000\000\129\000\130\000\103\000\000\000\
\000\000\104\000\000\000\000\000\000\000\121\000\122\000\123\000\
\124\000\000\000\105\000\106\000\107\000\000\000\000\000\088\000\
\089\000\090\000\091\000\092\000\126\000\000\000\000\000\093\000\
\155\000\000\000\000\000\000\000\096\000\217\002\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\098\000\099\000\000\000\
\000\000\000\000\100\000\101\000\000\000\000\000\129\000\130\000\
\103\000\000\000\000\000\104\000\000\000\000\000\121\000\122\000\
\123\000\124\000\000\000\000\000\105\000\106\000\107\000\000\000\
\088\000\089\000\090\000\091\000\092\000\126\000\000\000\000\000\
\093\000\155\000\000\000\000\000\000\000\096\000\219\002\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\098\000\099\000\
\000\000\000\000\000\000\100\000\101\000\000\000\000\000\129\000\
\130\000\103\000\000\000\000\000\104\000\000\000\000\000\000\000\
\121\000\122\000\123\000\124\000\000\000\105\000\106\000\107\000\
\000\000\000\000\088\000\089\000\090\000\091\000\092\000\126\000\
\000\000\000\000\093\000\155\000\000\000\000\000\000\000\096\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\098\000\099\000\000\000\000\000\000\000\100\000\101\000\000\000\
\000\000\129\000\130\000\103\000\000\000\000\000\104\000\000\000\
\000\000\121\000\122\000\123\000\124\000\000\000\000\000\105\000\
\106\000\107\000\000\000\000\000\000\000\000\000\000\000\000\000\
\126\000\000\000\000\000\000\000\000\000\252\000\000\000\252\000\
\252\000\000\000\000\000\000\000\000\000\252\000\000\000\000\000\
\000\000\000\000\252\000\000\000\000\000\000\000\000\000\252\000\
\252\000\000\000\129\000\130\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\121\000\122\000\123\000\124\000\000\000\
\000\000\000\000\000\000\000\000\000\000\252\000\252\000\252\000\
\252\000\252\000\126\000\252\000\252\000\252\000\252\000\252\000\
\252\000\252\000\252\000\252\000\252\000\252\000\252\000\252\000\
\252\000\252\000\252\000\252\000\252\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\129\000\130\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\252\000\000\000\
\252\000\252\000\252\000\000\000\252\000\252\000\252\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\252\000\
\000\000\251\000\000\000\251\000\251\000\000\000\000\000\000\000\
\000\000\251\000\000\000\252\000\000\000\252\000\251\000\252\000\
\252\000\252\000\000\000\251\000\251\000\252\000\000\000\000\000\
\000\000\000\000\252\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\251\000\251\000\251\000\251\000\251\000\000\000\251\000\
\251\000\251\000\251\000\251\000\251\000\251\000\251\000\251\000\
\251\000\251\000\251\000\251\000\251\000\251\000\251\000\251\000\
\251\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\251\000\000\000\251\000\251\000\251\000\000\000\
\251\000\251\000\251\000\000\000\066\001\000\000\000\000\066\001\
\066\001\000\000\000\000\251\000\066\001\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\251\000\
\000\000\251\000\066\001\251\000\251\000\251\000\000\000\066\001\
\000\000\251\000\000\000\000\000\000\000\000\000\251\000\000\000\
\000\000\000\000\066\001\000\000\000\000\000\000\000\000\066\001\
\066\001\066\001\066\001\066\001\000\000\066\001\066\001\066\001\
\066\001\066\001\066\001\066\001\066\001\066\001\066\001\066\001\
\066\001\066\001\066\001\066\001\066\001\066\001\066\001\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\009\000\000\000\000\000\
\011\000\000\000\066\001\000\000\066\001\000\000\066\001\066\001\
\000\000\000\000\000\000\066\001\000\000\000\000\000\000\066\001\
\000\000\000\000\000\000\132\001\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\249\000\000\000\000\000\250\000\251\000\
\000\000\000\000\066\001\000\000\000\000\066\001\000\000\050\001\
\013\000\014\000\015\000\016\000\017\000\018\000\019\000\020\000\
\021\000\022\000\023\000\024\000\025\000\000\000\000\000\000\000\
\000\000\000\000\031\000\032\000\033\000\034\000\035\000\036\000\
\000\000\000\000\000\000\000\000\000\000\000\000\013\000\014\000\
\015\000\016\000\017\000\000\000\019\000\020\000\021\000\022\000\
\023\000\024\000\025\000\038\000\000\000\000\000\000\000\000\000\
\042\000\043\000\033\000\034\000\035\000\036\000\000\000\000\000\
\000\000\000\000\044\000\000\000\045\000\046\000\047\000\048\000\
\049\000\050\000\051\000\000\000\000\000\000\000\052\000\000\000\
\053\000\242\000\054\000\000\000\242\000\242\000\042\000\000\000\
\133\001\242\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\013\000\242\000\
\000\000\000\000\000\000\000\000\242\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\242\000\
\000\000\000\000\000\000\000\000\242\000\242\000\242\000\242\000\
\242\000\000\000\242\000\242\000\242\000\242\000\242\000\242\000\
\242\000\242\000\242\000\242\000\242\000\242\000\242\000\242\000\
\242\000\242\000\242\000\242\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\141\001\000\000\242\000\
\141\001\242\000\000\000\242\000\242\000\075\001\000\000\000\000\
\242\000\000\000\075\001\000\000\242\000\000\000\000\000\000\000\
\075\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\242\000\
\000\000\000\000\242\000\000\000\000\000\141\001\141\001\141\001\
\141\001\141\001\000\000\141\001\141\001\141\001\141\001\141\001\
\141\001\141\001\141\001\141\001\141\001\141\001\141\001\141\001\
\141\001\141\001\141\001\141\001\141\001\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\075\001\000\000\
\141\001\000\000\141\001\000\000\141\001\141\001\141\001\000\000\
\000\000\142\001\000\000\000\000\142\001\000\000\000\000\141\001\
\000\000\077\001\000\000\000\000\000\000\000\000\077\001\000\000\
\000\000\000\000\000\000\141\001\077\001\141\001\000\000\141\001\
\141\001\000\000\000\000\000\000\000\000\141\001\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\142\001\142\001\142\001\142\001\142\001\000\000\142\001\
\142\001\142\001\142\001\142\001\142\001\142\001\142\001\142\001\
\142\001\142\001\142\001\142\001\142\001\142\001\142\001\142\001\
\142\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\070\001\077\001\011\000\142\001\071\001\142\001\000\000\
\142\001\142\001\142\001\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\142\001\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\142\001\
\000\000\142\001\000\000\142\001\142\001\000\000\000\000\000\000\
\000\000\142\001\000\000\013\000\014\000\015\000\016\000\017\000\
\000\000\019\000\020\000\021\000\022\000\023\000\024\000\025\000\
\026\000\027\000\028\000\029\000\030\000\031\000\032\000\033\000\
\034\000\035\000\036\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\070\001\000\000\011\000\
\000\000\000\000\000\000\000\000\000\000\000\000\038\000\000\000\
\040\000\000\000\041\000\042\000\000\000\000\000\000\000\000\000\
\155\002\242\001\243\001\244\001\245\001\246\001\247\001\248\001\
\249\001\250\001\251\001\252\001\253\001\254\001\255\001\000\002\
\001\002\002\002\003\002\004\002\005\002\000\000\055\000\013\000\
\014\000\015\000\016\000\017\000\000\000\019\000\020\000\021\000\
\022\000\023\000\024\000\025\000\026\000\027\000\028\000\029\000\
\030\000\031\000\032\000\033\000\034\000\035\000\036\000\000\000\
\000\000\000\000\000\000\070\001\000\000\011\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\038\000\000\000\040\000\000\000\041\000\042\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\013\000\014\000\015\000\
\016\000\017\000\055\000\019\000\020\000\021\000\022\000\023\000\
\024\000\025\000\026\000\027\000\028\000\029\000\030\000\031\000\
\032\000\033\000\034\000\035\000\036\000\000\000\000\000\000\000\
\000\000\205\001\000\000\205\001\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\038\000\000\000\040\000\000\000\041\000\042\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\205\001\205\001\205\001\205\001\205\001\
\055\000\205\001\205\001\205\001\205\001\205\001\205\001\205\001\
\205\001\205\001\205\001\205\001\205\001\205\001\205\001\205\001\
\205\001\205\001\205\001\000\000\000\000\000\000\000\000\000\000\
\010\000\011\000\000\000\000\000\000\000\165\002\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\205\001\000\000\
\205\001\000\000\205\001\205\001\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\013\000\014\000\015\000\016\000\017\000\205\001\019\000\
\020\000\021\000\022\000\023\000\024\000\025\000\026\000\027\000\
\028\000\029\000\030\000\031\000\032\000\033\000\034\000\035\000\
\036\000\000\000\000\000\000\000\000\000\000\000\010\000\011\000\
\000\000\000\000\000\000\240\002\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\163\000\038\000\000\000\040\000\000\000\
\041\000\042\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\013\000\
\014\000\015\000\016\000\017\000\055\000\019\000\020\000\021\000\
\022\000\023\000\024\000\025\000\026\000\027\000\028\000\029\000\
\030\000\031\000\032\000\033\000\034\000\035\000\036\000\000\000\
\000\000\000\000\000\000\000\000\000\000\011\000\000\000\000\000\
\097\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\163\000\038\000\000\000\040\000\000\000\041\000\042\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\013\000\014\000\015\000\
\016\000\017\000\055\000\019\000\020\000\021\000\022\000\023\000\
\024\000\025\000\026\000\027\000\028\000\029\000\030\000\031\000\
\032\000\033\000\034\000\035\000\036\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\011\000\000\000\000\000\097\000\000\000\000\000\000\000\
\038\000\000\000\040\000\000\000\041\000\042\000\043\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\044\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\052\000\000\000\053\000\000\000\054\000\
\055\000\013\000\014\000\015\000\016\000\017\000\000\000\019\000\
\020\000\021\000\022\000\023\000\024\000\025\000\026\000\027\000\
\028\000\029\000\030\000\031\000\032\000\033\000\034\000\035\000\
\036\000\000\000\000\000\000\000\000\000\000\000\000\000\011\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\038\000\000\000\040\000\000\000\
\041\000\042\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\013\000\
\014\000\015\000\016\000\017\000\055\000\019\000\020\000\021\000\
\022\000\023\000\024\000\025\000\026\000\027\000\028\000\029\000\
\030\000\031\000\032\000\033\000\034\000\035\000\036\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\038\000\000\000\040\000\000\000\041\000\042\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\010\000\000\000\000\000\000\000\010\000\000\000\
\010\000\010\000\010\000\010\000\010\000\010\000\010\000\010\000\
\000\000\000\000\055\000\012\000\010\000\010\000\010\000\010\000\
\010\000\010\000\010\000\010\000\010\000\010\000\010\000\010\000\
\010\000\010\000\010\000\010\000\010\000\010\000\010\000\010\000\
\010\000\011\000\000\000\000\000\000\000\011\000\000\000\011\000\
\011\000\011\000\011\000\011\000\011\000\011\000\011\000\000\000\
\000\000\000\000\014\000\011\000\011\000\011\000\011\000\011\000\
\011\000\011\000\011\000\011\000\011\000\011\000\011\000\011\000\
\011\000\011\000\011\000\011\000\011\000\011\000\011\000\011\000\
\249\000\000\000\000\000\250\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\010\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\011\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\013\000\014\000\015\000\016\000\017\000\
\000\000\019\000\020\000\021\000\022\000\023\000\024\000\025\000\
\011\000\000\000\000\000\000\000\000\000\000\000\000\000\033\000\
\034\000\035\000\036\000\013\000\014\000\015\000\016\000\017\000\
\000\000\019\000\020\000\021\000\022\000\023\000\024\000\025\000\
\111\000\000\000\000\000\000\000\000\000\031\000\032\000\033\000\
\034\000\035\000\036\000\042\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\038\000\000\000\
\000\000\000\000\000\000\042\000\000\000\000\000\000\000\000\000\
\111\000\111\000\111\000\111\000\111\000\000\000\111\000\111\000\
\111\000\111\000\111\000\111\000\111\000\000\000\000\000\000\000\
\000\000\000\000\111\000\111\000\111\000\111\000\111\000\111\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\183\000\183\000\183\000\
\183\000\000\000\000\000\111\000\000\000\000\000\183\000\000\000\
\111\000\183\000\183\000\183\000\183\000\183\000\000\000\000\000\
\000\000\183\000\000\000\183\000\183\000\183\000\183\000\183\000\
\000\000\183\000\000\000\183\000\183\000\183\000\183\000\183\000\
\183\000\183\000\183\000\183\000\183\000\183\000\183\000\183\000\
\183\000\183\000\183\000\183\000\183\000\183\000\183\000\183\000\
\183\000\000\000\000\000\000\000\000\000\000\000\179\000\179\000\
\179\000\179\000\000\000\000\000\000\000\000\000\000\000\179\000\
\000\000\000\000\179\000\179\000\179\000\179\000\179\000\000\000\
\000\000\000\000\179\000\183\000\179\000\179\000\179\000\179\000\
\179\000\183\000\179\000\000\000\179\000\179\000\179\000\179\000\
\179\000\179\000\179\000\179\000\179\000\179\000\179\000\179\000\
\179\000\179\000\179\000\179\000\179\000\179\000\179\000\179\000\
\179\000\179\000\000\000\000\000\000\000\000\000\000\000\157\001\
\158\001\159\001\160\001\000\000\000\000\000\000\000\000\000\000\
\161\001\000\000\000\000\162\001\163\001\164\001\165\001\166\001\
\000\000\000\000\000\000\167\001\179\000\168\001\169\001\170\001\
\171\001\172\001\179\000\173\001\000\000\174\001\000\000\175\001\
\176\001\177\001\178\001\179\001\180\001\181\001\182\001\183\001\
\184\001\185\001\186\001\187\001\188\001\189\001\190\001\191\001\
\192\001\193\001\194\001\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\010\000\000\000\000\000\010\000\010\000\000\000\010\000\
\010\000\010\000\010\000\010\000\000\000\195\001\010\000\000\000\
\000\000\000\000\005\000\196\001\010\000\010\000\010\000\010\000\
\010\000\010\000\010\000\010\000\010\000\010\000\010\000\010\000\
\010\000\010\000\010\000\010\000\010\000\010\000\010\000\010\000"

let yycheck = "\003\000\
\070\000\003\000\002\000\002\000\002\000\070\000\002\000\033\000\
\034\000\187\000\004\000\034\000\008\000\035\000\080\000\010\001\
\202\000\002\000\154\000\002\000\002\001\125\001\064\001\008\000\
\112\000\008\000\000\000\129\001\000\000\010\000\096\000\090\002\
\198\001\018\001\162\000\085\001\008\001\159\000\160\000\119\000\
\038\002\125\001\019\001\021\001\203\002\008\001\233\002\014\001\
\025\001\000\000\074\001\187\000\061\002\014\001\124\000\077\000\
\017\001\014\001\014\001\112\000\002\000\128\001\018\001\130\001\
\014\001\233\002\065\001\017\001\062\001\019\001\020\001\237\000\
\035\001\019\001\154\000\025\001\167\000\162\000\021\001\025\001\
\080\000\090\002\072\002\030\001\080\000\035\001\036\001\014\001\
\019\001\018\001\017\001\052\001\180\000\215\000\025\001\080\000\
\120\001\080\000\101\001\179\000\007\001\062\001\096\000\019\001\
\010\001\062\001\012\001\010\003\019\001\025\001\109\000\115\000\
\062\001\115\000\025\001\119\000\014\001\019\001\000\000\204\000\
\021\001\120\001\018\001\025\001\118\000\056\003\196\000\180\000\
\035\001\018\001\133\001\196\000\202\000\142\002\025\001\062\001\
\113\001\102\001\128\002\030\001\000\000\146\000\109\001\156\001\
\056\003\036\001\172\000\076\001\109\001\219\000\154\000\098\001\
\154\000\109\001\220\000\221\000\154\000\062\001\154\000\137\001\
\251\000\037\002\160\002\005\000\136\001\142\001\018\001\132\001\
\135\001\154\000\113\001\154\000\007\001\136\001\135\001\179\000\
\056\001\182\000\204\000\135\001\076\001\056\001\109\001\187\000\
\060\002\187\000\000\001\076\001\018\001\187\000\038\002\187\000\
\142\001\187\000\137\001\018\001\142\001\000\003\211\001\109\002\
\035\001\004\003\187\000\019\001\187\000\077\001\201\001\098\001\
\135\001\025\001\021\001\142\001\113\001\037\001\038\001\215\000\
\048\001\215\000\098\001\000\000\021\001\221\000\203\000\098\001\
\220\000\018\001\142\001\018\001\100\001\022\001\065\001\063\001\
\056\001\062\001\028\002\220\000\137\001\220\000\018\001\233\000\
\142\001\237\000\246\000\225\001\246\000\239\000\240\000\033\002\
\077\001\243\000\246\000\048\001\237\000\002\001\237\000\079\001\
\036\001\025\002\086\002\027\002\116\001\246\000\010\001\077\001\
\010\001\131\001\063\001\112\000\077\001\112\001\010\001\100\001\
\019\001\215\000\098\001\013\001\142\001\016\002\123\000\112\001\
\122\000\010\001\093\002\094\002\027\002\120\001\100\001\119\001\
\035\001\037\001\038\001\100\001\202\001\203\001\014\001\124\001\
\045\001\094\001\036\001\144\000\142\000\019\001\113\001\019\001\
\214\002\212\001\213\001\183\002\056\001\137\001\056\001\125\001\
\113\001\081\002\056\001\113\001\056\001\159\000\160\000\023\001\
\196\002\025\001\119\001\137\001\019\001\051\002\137\001\056\001\
\137\001\056\001\025\001\079\001\014\003\015\003\018\001\180\000\
\137\001\086\001\022\001\137\001\098\000\099\000\067\001\091\001\
\186\000\091\001\020\001\019\001\014\001\075\002\098\001\017\001\
\098\001\025\001\124\001\203\002\098\001\138\001\098\001\033\002\
\174\001\237\002\036\001\121\000\025\001\047\003\008\001\018\001\
\200\001\098\001\109\001\098\001\014\001\215\000\035\001\036\001\
\014\001\212\001\213\001\017\001\022\001\125\001\020\001\029\001\
\030\001\153\002\014\001\131\001\230\000\131\001\018\001\025\001\
\117\001\019\001\022\001\021\001\062\001\023\001\142\001\025\001\
\142\001\018\001\036\001\200\001\018\001\031\001\248\000\146\002\
\034\001\035\001\036\001\037\001\038\001\039\001\186\000\019\001\
\006\003\018\001\113\001\191\000\062\001\025\001\035\001\142\000\
\062\001\014\001\015\001\016\001\017\001\018\001\019\001\020\001\
\021\001\022\001\023\001\024\001\025\001\026\001\027\001\028\001\
\029\001\030\001\031\001\032\001\033\001\131\001\019\001\142\001\
\027\002\175\002\026\002\030\002\025\001\201\001\014\001\201\001\
\142\001\017\001\031\002\048\001\020\001\201\001\035\001\019\001\
\040\002\191\002\042\002\186\000\014\001\025\001\038\002\025\001\
\201\001\031\002\063\001\033\002\225\001\216\002\031\002\251\000\
\056\002\109\001\036\001\221\001\019\001\026\002\234\001\113\001\
\226\001\014\001\025\001\007\001\008\001\018\001\019\001\011\001\
\012\001\022\001\019\001\040\002\025\001\042\002\062\001\018\001\
\025\001\094\001\089\001\135\001\014\001\113\001\176\002\230\000\
\018\001\018\001\035\001\056\002\142\001\071\002\032\002\035\001\
\061\002\032\002\035\001\015\002\016\002\015\002\016\002\036\001\
\086\002\248\000\119\001\015\002\016\002\014\001\041\000\019\001\
\017\001\025\001\142\001\020\001\018\001\025\001\015\002\016\002\
\022\001\131\001\038\002\057\002\014\001\090\002\038\002\017\001\
\176\002\060\000\020\001\024\002\142\001\044\002\051\002\043\002\
\101\002\068\000\069\000\005\000\000\000\025\001\098\000\099\000\
\075\000\023\001\043\002\018\001\043\002\014\001\014\001\022\001\
\036\001\017\001\020\001\025\001\034\001\062\001\075\002\097\002\
\109\001\022\001\097\002\024\001\113\001\121\000\036\001\025\001\
\160\002\030\001\041\001\023\001\062\001\025\001\086\002\000\000\
\019\001\142\002\036\001\109\001\021\001\052\001\025\001\023\001\
\025\001\025\001\135\001\200\001\128\001\129\001\130\001\014\001\
\020\001\142\001\019\001\018\001\113\001\113\002\062\001\113\002\
\025\001\030\001\020\001\119\002\120\002\135\001\019\001\036\001\
\130\001\222\001\116\002\117\002\118\002\036\001\179\002\180\002\
\119\002\120\002\041\001\019\001\185\002\203\002\018\001\139\002\
\140\002\025\001\203\002\179\002\180\002\052\001\146\002\020\001\
\146\002\185\002\011\001\019\001\139\002\140\002\146\002\009\001\
\205\002\025\001\106\001\014\001\160\002\109\001\154\002\019\001\
\160\002\146\002\007\002\115\001\252\002\025\001\019\001\019\001\
\167\002\154\002\175\002\154\002\176\002\025\001\176\002\127\001\
\090\001\129\001\176\002\131\001\176\002\026\002\176\002\135\001\
\212\001\213\001\191\002\018\001\142\000\018\001\022\001\176\002\
\024\001\176\002\026\001\040\002\010\003\042\002\109\001\252\002\
\106\001\010\003\000\000\203\002\019\001\159\000\160\000\023\001\
\041\001\115\001\025\001\056\002\216\002\217\002\216\002\219\002\
\061\002\211\002\022\001\052\001\216\002\127\001\018\001\129\001\
\135\001\131\001\217\002\231\002\219\002\231\002\019\001\216\002\
\186\000\019\001\000\000\019\001\018\001\019\001\019\001\025\001\
\022\001\025\001\075\001\076\001\025\001\090\002\019\001\246\002\
\014\001\019\001\204\000\017\001\025\001\247\002\018\001\025\001\
\101\002\035\001\022\001\041\001\024\001\215\000\026\001\027\001\
\028\001\018\001\010\003\100\001\034\001\102\001\052\001\019\003\
\019\001\021\003\020\001\023\003\230\000\035\001\025\001\027\003\
\028\003\019\001\021\001\019\001\019\003\127\002\021\003\025\001\
\023\003\025\001\019\001\019\001\027\003\028\003\248\000\019\001\
\025\001\142\002\019\001\132\001\072\002\025\001\034\001\035\001\
\025\001\071\001\048\001\049\001\050\001\051\001\052\001\053\001\
\054\001\055\001\056\001\025\001\064\003\065\003\064\003\065\003\
\025\001\093\002\094\002\030\001\072\003\019\001\072\003\019\001\
\019\001\021\001\019\001\023\001\014\001\025\001\179\002\180\002\
\018\001\034\001\035\001\031\001\185\002\107\001\034\001\035\001\
\036\001\037\001\038\001\039\001\040\001\041\001\042\001\043\001\
\044\001\045\001\046\001\047\001\128\002\118\001\119\001\041\001\
\205\002\113\001\019\001\143\001\021\001\022\001\023\001\000\000\
\025\001\141\002\052\001\019\001\029\001\030\001\031\001\125\001\
\126\001\034\001\035\001\036\001\037\001\038\001\039\001\040\001\
\041\001\042\001\043\001\044\001\045\001\046\001\047\001\048\001\
\049\001\050\001\051\001\052\001\053\001\054\001\055\001\056\001\
\050\001\051\001\052\001\053\001\054\001\055\001\056\001\252\002\
\044\001\045\001\046\001\047\001\048\001\049\001\050\001\051\001\
\052\001\053\001\054\001\055\001\056\001\113\001\018\001\113\001\
\018\001\109\001\124\001\109\001\001\000\002\000\003\000\004\000\
\005\000\131\001\052\001\053\001\054\001\055\001\056\001\021\001\
\024\001\036\001\018\001\143\001\142\001\019\001\019\001\035\001\
\019\001\035\001\142\001\023\001\021\001\135\001\018\001\036\001\
\113\001\090\001\035\001\025\001\018\001\023\001\014\001\020\001\
\014\001\000\000\036\001\035\001\035\001\023\001\019\001\019\001\
\244\002\018\001\025\001\018\001\014\001\019\001\019\001\021\001\
\014\001\023\001\021\001\025\001\019\001\142\001\083\001\023\001\
\019\001\000\000\006\003\113\001\034\001\035\001\036\001\005\001\
\006\001\007\001\008\001\036\001\025\001\021\001\019\001\036\001\
\014\001\083\001\036\001\017\001\018\001\019\001\020\001\021\001\
\022\001\023\001\024\001\025\001\026\001\027\001\028\001\029\001\
\030\001\031\001\036\001\033\001\034\001\035\001\036\001\037\001\
\038\001\039\001\040\001\041\001\042\001\043\001\044\001\045\001\
\046\001\047\001\048\001\049\001\050\001\051\001\052\001\053\001\
\054\001\055\001\056\001\057\001\058\001\059\001\060\001\061\001\
\068\003\063\001\064\001\065\001\066\001\067\001\068\001\069\001\
\070\001\071\001\072\001\073\001\074\001\075\001\076\001\077\001\
\078\001\079\001\080\001\113\001\021\001\083\001\019\001\008\001\
\023\001\036\001\018\001\089\001\120\001\019\001\126\001\009\001\
\137\001\036\001\000\000\021\001\098\001\035\001\100\001\101\001\
\102\001\036\001\104\001\105\001\106\001\036\001\019\001\021\001\
\142\001\019\001\113\001\113\001\113\001\115\001\113\001\021\001\
\036\001\021\001\035\001\000\000\019\001\113\001\113\001\113\001\
\113\001\127\001\002\000\129\001\093\001\131\001\132\001\133\001\
\127\002\225\000\146\000\137\001\005\001\006\001\007\001\008\001\
\142\001\105\001\214\001\045\002\246\002\014\001\068\003\209\002\
\017\001\018\001\019\001\020\001\021\001\022\001\023\001\024\001\
\025\001\026\001\027\001\028\001\029\001\030\001\031\001\078\002\
\033\001\034\001\035\001\036\001\037\001\038\001\039\001\040\001\
\041\001\042\001\043\001\044\001\045\001\046\001\047\001\048\001\
\049\001\050\001\051\001\052\001\053\001\054\001\055\001\056\001\
\057\001\058\001\059\001\060\001\061\001\198\002\063\001\064\001\
\065\001\066\001\067\001\068\001\069\001\070\001\071\001\072\001\
\073\001\074\001\075\001\076\001\077\001\078\001\079\001\080\001\
\006\003\063\002\083\001\143\001\214\000\092\002\100\002\131\001\
\089\001\205\002\178\000\142\001\079\001\176\002\158\002\103\001\
\136\002\098\001\056\003\100\001\101\001\102\001\055\003\104\001\
\105\001\106\001\255\255\255\255\255\255\000\000\255\255\014\001\
\113\001\255\255\115\001\018\001\019\001\255\255\255\255\022\001\
\255\255\255\255\025\001\255\255\255\255\255\255\127\001\255\255\
\129\001\255\255\131\001\132\001\133\001\255\255\255\255\014\001\
\137\001\255\255\017\001\018\001\019\001\142\001\021\001\022\001\
\023\001\255\255\025\001\255\255\255\255\255\255\029\001\030\001\
\031\001\255\255\255\255\034\001\035\001\036\001\037\001\038\001\
\039\001\040\001\041\001\042\001\043\001\044\001\045\001\046\001\
\047\001\048\001\049\001\050\001\051\001\052\001\053\001\054\001\
\055\001\056\001\057\001\058\001\059\001\060\001\061\001\255\255\
\063\001\064\001\065\001\066\001\067\001\068\001\069\001\070\001\
\071\001\072\001\073\001\074\001\075\001\076\001\077\001\078\001\
\079\001\080\001\255\255\255\255\255\255\255\255\109\001\255\255\
\255\255\255\255\113\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\100\001\255\255\102\001\
\255\255\104\001\105\001\255\255\255\255\255\255\109\001\000\000\
\135\001\255\255\113\001\255\255\255\255\255\255\255\255\142\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\132\001\255\255\255\255\
\135\001\014\001\255\255\255\255\017\001\018\001\019\001\142\001\
\021\001\022\001\023\001\255\255\025\001\255\255\255\255\255\255\
\029\001\030\001\031\001\255\255\255\255\034\001\035\001\036\001\
\037\001\038\001\039\001\040\001\041\001\042\001\043\001\044\001\
\045\001\046\001\047\001\048\001\049\001\050\001\051\001\052\001\
\053\001\054\001\055\001\056\001\057\001\058\001\059\001\060\001\
\061\001\255\255\063\001\064\001\065\001\066\001\067\001\068\001\
\069\001\070\001\071\001\072\001\073\001\074\001\075\001\076\001\
\077\001\078\001\079\001\080\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\014\001\255\255\255\255\255\255\
\018\001\255\255\255\255\255\255\022\001\255\255\255\255\100\001\
\255\255\102\001\255\255\104\001\105\001\255\255\255\255\255\255\
\109\001\000\000\036\001\255\255\113\001\255\255\255\255\041\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\052\001\255\255\255\255\255\255\255\255\132\001\
\255\255\255\255\135\001\014\001\255\255\255\255\017\001\018\001\
\019\001\142\001\021\001\022\001\023\001\255\255\025\001\255\255\
\255\255\255\255\029\001\030\001\031\001\255\255\255\255\034\001\
\035\001\036\001\037\001\038\001\039\001\040\001\041\001\042\001\
\043\001\044\001\045\001\046\001\047\001\048\001\049\001\050\001\
\051\001\052\001\053\001\054\001\055\001\056\001\057\001\058\001\
\059\001\060\001\061\001\109\001\063\001\064\001\065\001\066\001\
\067\001\068\001\069\001\070\001\071\001\072\001\073\001\074\001\
\075\001\076\001\077\001\078\001\079\001\080\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\135\001\014\001\255\255\
\255\255\255\255\018\001\019\001\255\255\255\255\022\001\255\255\
\255\255\100\001\255\255\102\001\255\255\104\001\105\001\255\255\
\255\255\255\255\109\001\000\000\255\255\255\255\113\001\255\255\
\255\255\041\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\052\001\255\255\255\255\255\255\
\255\255\132\001\255\255\255\255\135\001\014\001\255\255\255\255\
\017\001\018\001\019\001\142\001\021\001\022\001\023\001\255\255\
\025\001\255\255\000\000\255\255\029\001\030\001\031\001\255\255\
\255\255\034\001\035\001\036\001\037\001\038\001\039\001\040\001\
\041\001\042\001\043\001\044\001\045\001\046\001\047\001\048\001\
\049\001\050\001\051\001\052\001\053\001\054\001\055\001\056\001\
\057\001\058\001\059\001\060\001\061\001\109\001\063\001\064\001\
\065\001\066\001\067\001\068\001\069\001\070\001\071\001\072\001\
\073\001\074\001\075\001\076\001\077\001\078\001\079\001\080\001\
\255\255\255\255\255\255\255\255\014\001\255\255\255\255\135\001\
\018\001\019\001\255\255\255\255\022\001\255\255\014\001\025\001\
\255\255\255\255\018\001\100\001\255\255\102\001\255\255\104\001\
\105\001\255\255\036\001\255\255\109\001\255\255\255\255\041\001\
\113\001\255\255\255\255\035\001\255\255\255\255\255\255\255\255\
\255\255\041\001\052\001\255\255\255\255\255\255\255\255\255\255\
\255\255\008\001\255\255\132\001\052\001\255\255\135\001\000\000\
\255\255\255\255\255\255\018\001\019\001\142\001\021\001\022\001\
\023\001\024\001\025\001\026\001\027\001\028\001\029\001\030\001\
\031\001\255\255\255\255\034\001\035\001\036\001\037\001\038\001\
\039\001\040\001\041\001\042\001\043\001\044\001\045\001\046\001\
\047\001\048\001\049\001\050\001\051\001\052\001\053\001\054\001\
\055\001\056\001\000\000\109\001\255\255\014\001\255\255\113\001\
\255\255\018\001\106\001\255\255\255\255\109\001\255\255\255\255\
\255\255\255\255\255\255\115\001\255\255\255\255\255\255\255\255\
\255\255\255\255\035\001\036\001\255\255\135\001\255\255\127\001\
\041\001\129\001\255\255\131\001\142\001\255\255\255\255\135\001\
\000\000\255\255\255\255\052\001\014\001\255\255\255\255\255\255\
\018\001\255\255\255\255\255\255\022\001\255\255\255\255\255\255\
\255\255\255\255\113\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\041\001\
\255\255\255\255\255\255\008\001\255\255\255\255\255\255\255\255\
\255\255\136\001\052\001\000\000\255\255\018\001\019\001\142\001\
\021\001\022\001\023\001\024\001\025\001\026\001\027\001\028\001\
\029\001\030\001\031\001\255\255\109\001\034\001\035\001\036\001\
\037\001\038\001\039\001\040\001\041\001\042\001\043\001\044\001\
\045\001\046\001\047\001\048\001\049\001\050\001\051\001\052\001\
\053\001\054\001\055\001\056\001\018\001\019\001\135\001\021\001\
\022\001\023\001\024\001\025\001\026\001\027\001\028\001\029\001\
\030\001\031\001\255\255\109\001\034\001\035\001\036\001\037\001\
\038\001\039\001\040\001\041\001\042\001\043\001\044\001\045\001\
\046\001\047\001\048\001\049\001\050\001\051\001\052\001\053\001\
\054\001\055\001\056\001\255\255\000\000\135\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\031\001\
\255\255\255\255\255\255\255\255\113\001\037\001\038\001\039\001\
\040\001\041\001\042\001\043\001\044\001\045\001\046\001\047\001\
\048\001\049\001\050\001\051\001\052\001\053\001\054\001\055\001\
\056\001\255\255\255\255\136\001\255\255\000\000\255\255\255\255\
\255\255\142\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\113\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\018\001\019\001\255\255\021\001\022\001\023\001\024\001\
\025\001\026\001\027\001\028\001\029\001\030\001\031\001\000\000\
\142\001\034\001\035\001\036\001\037\001\038\001\039\001\040\001\
\041\001\042\001\043\001\044\001\045\001\046\001\047\001\048\001\
\049\001\050\001\051\001\052\001\053\001\054\001\055\001\056\001\
\255\255\255\255\255\255\255\255\255\255\019\001\255\255\021\001\
\255\255\023\001\255\255\025\001\255\255\255\255\000\000\029\001\
\030\001\031\001\255\255\255\255\034\001\035\001\036\001\037\001\
\038\001\039\001\040\001\041\001\042\001\043\001\044\001\045\001\
\046\001\047\001\048\001\049\001\050\001\051\001\052\001\053\001\
\054\001\055\001\056\001\019\001\255\255\021\001\255\255\023\001\
\255\255\025\001\255\255\255\255\255\255\029\001\030\001\031\001\
\113\001\255\255\034\001\035\001\036\001\037\001\038\001\039\001\
\040\001\041\001\042\001\043\001\044\001\045\001\046\001\047\001\
\048\001\049\001\050\001\051\001\052\001\053\001\054\001\055\001\
\056\001\255\255\255\255\255\255\255\255\142\001\019\001\255\255\
\021\001\255\255\023\001\255\255\025\001\255\255\255\255\000\000\
\029\001\030\001\031\001\113\001\255\255\034\001\035\001\036\001\
\037\001\038\001\039\001\040\001\041\001\042\001\043\001\044\001\
\045\001\046\001\047\001\048\001\049\001\050\001\051\001\052\001\
\053\001\054\001\055\001\056\001\255\255\255\255\000\000\255\255\
\142\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\113\001\038\001\039\001\040\001\041\001\042\001\043\001\
\044\001\045\001\046\001\047\001\048\001\049\001\050\001\051\001\
\052\001\053\001\054\001\055\001\056\001\000\000\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\142\001\019\001\
\255\255\021\001\255\255\023\001\255\255\025\001\255\255\255\255\
\255\255\029\001\030\001\031\001\113\001\255\255\034\001\035\001\
\036\001\037\001\038\001\039\001\040\001\041\001\042\001\043\001\
\044\001\045\001\046\001\047\001\048\001\049\001\050\001\051\001\
\052\001\053\001\054\001\055\001\056\001\255\255\255\255\000\000\
\019\001\142\001\021\001\255\255\023\001\255\255\025\001\255\255\
\255\255\255\255\255\255\255\255\031\001\255\255\255\255\034\001\
\035\001\036\001\037\001\038\001\039\001\040\001\041\001\042\001\
\043\001\044\001\045\001\046\001\047\001\048\001\049\001\050\001\
\051\001\052\001\053\001\054\001\055\001\056\001\000\000\255\255\
\255\255\255\255\019\001\255\255\021\001\255\255\023\001\255\255\
\025\001\255\255\255\255\255\255\255\255\113\001\031\001\255\255\
\255\255\034\001\035\001\036\001\037\001\038\001\039\001\040\001\
\041\001\042\001\043\001\044\001\045\001\046\001\047\001\048\001\
\049\001\050\001\051\001\255\255\255\255\255\255\255\255\000\000\
\255\255\019\001\142\001\021\001\255\255\023\001\255\255\025\001\
\255\255\255\255\255\255\255\255\255\255\031\001\113\001\255\255\
\034\001\035\001\036\001\037\001\038\001\039\001\040\001\041\001\
\042\001\043\001\044\001\045\001\046\001\047\001\048\001\049\001\
\050\001\051\001\255\255\255\255\255\255\255\255\255\255\000\000\
\255\255\255\255\255\255\142\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\014\001\255\255\
\113\001\255\255\018\001\019\001\255\255\255\255\022\001\255\255\
\255\255\025\001\255\255\000\000\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\036\001\255\255\255\255\255\255\
\255\255\041\001\019\001\255\255\021\001\142\001\023\001\255\255\
\025\001\255\255\000\000\255\255\052\001\255\255\031\001\113\001\
\255\255\034\001\035\001\036\001\037\001\038\001\039\001\040\001\
\041\001\042\001\043\001\044\001\045\001\046\001\047\001\048\001\
\049\001\019\001\255\255\021\001\255\255\023\001\255\255\025\001\
\255\255\255\255\255\255\000\000\142\001\031\001\255\255\255\255\
\034\001\035\001\036\001\037\001\038\001\039\001\040\001\041\001\
\042\001\043\001\044\001\045\001\046\001\047\001\048\001\049\001\
\019\001\255\255\021\001\255\255\023\001\109\001\025\001\000\000\
\255\255\113\001\255\255\255\255\031\001\255\255\255\255\034\001\
\035\001\036\001\037\001\038\001\039\001\040\001\041\001\042\001\
\043\001\044\001\045\001\046\001\047\001\255\255\255\255\135\001\
\113\001\255\255\255\255\255\255\255\255\255\255\142\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\019\001\255\255\021\001\255\255\023\001\255\255\
\025\001\255\255\255\255\255\255\255\255\142\001\031\001\113\001\
\255\255\034\001\035\001\036\001\037\001\038\001\039\001\040\001\
\041\001\042\001\043\001\044\001\045\001\046\001\047\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\019\001\255\255\021\001\142\001\023\001\113\001\025\001\
\000\000\255\255\255\255\255\255\255\255\031\001\255\255\255\255\
\034\001\035\001\036\001\037\001\038\001\039\001\040\001\041\001\
\042\001\043\001\044\001\045\001\046\001\047\001\255\255\255\255\
\255\255\255\255\255\255\142\001\255\255\255\255\255\255\255\255\
\255\255\255\255\019\001\255\255\021\001\255\255\023\001\255\255\
\025\001\255\255\255\255\255\255\255\255\255\255\031\001\255\255\
\113\001\034\001\035\001\036\001\037\001\038\001\039\001\040\001\
\041\001\042\001\043\001\042\001\043\001\044\001\045\001\046\001\
\047\001\048\001\049\001\050\001\051\001\052\001\053\001\054\001\
\055\001\056\001\019\001\255\255\021\001\142\001\023\001\255\255\
\025\001\255\255\255\255\255\255\255\255\255\255\031\001\113\001\
\255\255\034\001\035\001\036\001\037\001\038\001\039\001\040\001\
\041\001\042\001\043\001\255\255\255\255\255\255\019\001\255\255\
\021\001\255\255\023\001\255\255\025\001\255\255\255\255\255\255\
\255\255\255\255\031\001\255\255\142\001\034\001\035\001\036\001\
\037\001\038\001\039\001\040\001\041\001\019\001\000\000\021\001\
\113\001\023\001\255\255\025\001\255\255\000\000\014\001\255\255\
\255\255\031\001\018\001\255\255\034\001\035\001\036\001\037\001\
\038\001\039\001\040\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\142\001\019\001\255\255\
\021\001\041\001\023\001\255\255\025\001\255\255\255\255\255\255\
\113\001\255\255\031\001\255\255\052\001\034\001\035\001\036\001\
\037\001\038\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\019\001\255\255\021\001\255\255\023\001\255\255\
\025\001\255\255\255\255\255\255\113\001\142\001\031\001\255\255\
\255\255\034\001\035\001\036\001\037\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\000\000\255\255\255\255\255\255\
\255\255\255\255\255\255\113\001\255\255\255\255\255\255\255\255\
\255\255\142\001\106\001\255\255\255\255\109\001\255\255\255\255\
\255\255\255\255\255\255\115\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\127\001\
\142\001\129\001\255\255\131\001\113\001\255\255\255\255\135\001\
\255\255\255\255\255\255\255\255\255\255\005\001\006\001\007\001\
\008\001\009\001\255\255\255\255\255\255\013\001\014\001\255\255\
\016\001\017\001\018\001\255\255\020\001\021\001\255\255\255\255\
\113\001\142\001\255\255\027\001\028\001\255\255\255\255\255\255\
\032\001\033\001\000\000\255\255\036\001\255\255\038\001\255\255\
\255\255\041\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\050\001\051\001\052\001\142\001\255\255\255\255\
\255\255\057\001\058\001\059\001\060\001\061\001\062\001\063\001\
\064\001\065\001\066\001\067\001\068\001\069\001\070\001\071\001\
\072\001\073\001\074\001\075\001\076\001\077\001\078\001\079\001\
\080\001\081\001\082\001\255\255\084\001\085\001\086\001\087\001\
\088\001\089\001\090\001\091\001\092\001\093\001\094\001\095\001\
\096\001\097\001\255\255\255\255\100\001\101\001\102\001\014\001\
\104\001\105\001\106\001\018\001\019\001\109\001\255\255\022\001\
\255\255\113\001\025\001\115\001\255\255\117\001\118\001\119\001\
\120\001\121\001\122\001\123\001\124\001\036\001\126\001\127\001\
\255\255\129\001\041\001\131\001\132\001\255\255\134\001\135\001\
\136\001\137\001\014\001\139\001\014\001\052\001\018\001\019\001\
\018\001\019\001\022\001\014\001\022\001\025\001\255\255\018\001\
\019\001\255\255\255\255\022\001\255\255\255\255\255\255\255\255\
\036\001\035\001\036\001\255\255\255\255\041\001\255\255\041\001\
\035\001\036\001\255\255\255\255\255\255\255\255\041\001\255\255\
\052\001\255\255\052\001\255\255\255\255\255\255\255\255\255\255\
\255\255\052\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\109\001\255\255\
\014\001\255\255\113\001\255\255\018\001\019\001\255\255\255\255\
\022\001\255\255\255\255\025\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\036\001\255\255\
\135\001\255\255\014\001\041\001\016\001\017\001\255\255\142\001\
\255\255\109\001\255\255\109\001\255\255\113\001\052\001\255\255\
\255\255\255\255\109\001\255\255\255\255\255\255\255\255\255\255\
\036\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\135\001\255\255\135\001\255\255\255\255\
\255\255\255\255\142\001\255\255\135\001\057\001\058\001\059\001\
\060\001\061\001\062\001\063\001\064\001\065\001\066\001\067\001\
\068\001\069\001\070\001\071\001\072\001\073\001\074\001\075\001\
\076\001\077\001\078\001\079\001\080\001\255\255\255\255\109\001\
\255\255\255\255\255\255\113\001\255\255\255\255\255\255\255\255\
\255\255\255\255\016\001\017\001\255\255\255\255\255\255\099\001\
\100\001\101\001\102\001\255\255\104\001\105\001\106\001\255\255\
\255\255\135\001\255\255\255\255\255\255\255\255\255\255\115\001\
\142\001\117\001\118\001\119\001\120\001\121\001\122\001\123\001\
\255\255\255\255\255\255\127\001\255\255\129\001\255\255\131\001\
\132\001\255\255\255\255\057\001\058\001\059\001\060\001\061\001\
\255\255\063\001\064\001\065\001\066\001\067\001\068\001\069\001\
\070\001\071\001\072\001\073\001\074\001\075\001\076\001\077\001\
\078\001\079\001\080\001\255\255\255\255\255\255\005\001\006\001\
\007\001\008\001\009\001\255\255\255\255\255\255\013\001\014\001\
\015\001\255\255\017\001\018\001\019\001\099\001\100\001\255\255\
\102\001\255\255\104\001\105\001\027\001\028\001\255\255\255\255\
\255\255\032\001\033\001\255\255\255\255\255\255\255\255\038\001\
\255\255\255\255\041\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\050\001\051\001\052\001\132\001\255\255\
\255\255\255\255\057\001\058\001\059\001\060\001\061\001\255\255\
\063\001\064\001\065\001\066\001\067\001\068\001\069\001\070\001\
\071\001\072\001\073\001\074\001\075\001\076\001\077\001\078\001\
\079\001\080\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\094\001\
\095\001\096\001\097\001\255\255\255\255\100\001\255\255\102\001\
\255\255\104\001\105\001\255\255\255\255\255\255\109\001\255\255\
\005\001\006\001\007\001\008\001\009\001\255\255\255\255\255\255\
\013\001\014\001\015\001\255\255\017\001\018\001\019\001\255\255\
\255\255\255\255\255\255\255\255\255\255\132\001\027\001\028\001\
\135\001\136\001\255\255\032\001\033\001\255\255\255\255\255\255\
\143\001\038\001\255\255\255\255\041\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\050\001\051\001\052\001\
\255\255\255\255\255\255\255\255\057\001\058\001\059\001\060\001\
\061\001\255\255\063\001\064\001\065\001\066\001\067\001\068\001\
\069\001\070\001\071\001\072\001\073\001\074\001\075\001\076\001\
\077\001\078\001\079\001\080\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\094\001\095\001\096\001\097\001\255\255\255\255\100\001\
\255\255\102\001\255\255\104\001\105\001\255\255\255\255\255\255\
\109\001\255\255\005\001\006\001\007\001\008\001\009\001\255\255\
\255\255\255\255\013\001\014\001\015\001\255\255\017\001\018\001\
\019\001\255\255\255\255\255\255\255\255\255\255\255\255\132\001\
\027\001\028\001\135\001\136\001\255\255\032\001\033\001\255\255\
\255\255\255\255\143\001\038\001\255\255\255\255\041\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\050\001\
\051\001\052\001\255\255\255\255\255\255\255\255\057\001\058\001\
\059\001\060\001\061\001\255\255\063\001\064\001\065\001\066\001\
\067\001\068\001\069\001\070\001\071\001\072\001\073\001\074\001\
\075\001\076\001\077\001\078\001\079\001\080\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\094\001\095\001\096\001\097\001\255\255\
\255\255\100\001\255\255\102\001\255\255\104\001\105\001\255\255\
\255\255\255\255\109\001\255\255\005\001\006\001\007\001\008\001\
\009\001\255\255\255\255\255\255\013\001\014\001\015\001\255\255\
\017\001\018\001\019\001\255\255\255\255\255\255\255\255\255\255\
\255\255\132\001\027\001\028\001\135\001\136\001\255\255\032\001\
\033\001\255\255\255\255\255\255\143\001\038\001\255\255\255\255\
\041\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\050\001\051\001\052\001\255\255\255\255\255\255\255\255\
\057\001\058\001\059\001\060\001\061\001\255\255\063\001\064\001\
\065\001\066\001\067\001\068\001\069\001\070\001\071\001\072\001\
\073\001\074\001\075\001\076\001\077\001\078\001\079\001\080\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\094\001\095\001\096\001\
\097\001\255\255\255\255\100\001\255\255\102\001\255\255\104\001\
\105\001\255\255\255\255\255\255\109\001\255\255\005\001\006\001\
\007\001\008\001\009\001\255\255\255\255\255\255\013\001\014\001\
\015\001\255\255\017\001\018\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\132\001\027\001\028\001\135\001\136\001\
\255\255\032\001\033\001\255\255\255\255\255\255\143\001\038\001\
\255\255\255\255\041\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\050\001\051\001\052\001\255\255\255\255\
\255\255\255\255\057\001\058\001\059\001\060\001\061\001\255\255\
\063\001\064\001\065\001\066\001\067\001\068\001\069\001\070\001\
\071\001\072\001\073\001\074\001\075\001\076\001\077\001\078\001\
\079\001\080\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\094\001\
\095\001\096\001\097\001\255\255\255\255\100\001\255\255\102\001\
\255\255\104\001\105\001\255\255\255\255\255\255\109\001\255\255\
\005\001\006\001\007\001\008\001\009\001\255\255\255\255\255\255\
\013\001\014\001\015\001\255\255\017\001\018\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\132\001\027\001\028\001\
\135\001\136\001\255\255\032\001\033\001\255\255\255\255\255\255\
\143\001\038\001\255\255\255\255\041\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\050\001\051\001\052\001\
\255\255\255\255\255\255\255\255\057\001\058\001\059\001\060\001\
\061\001\255\255\063\001\064\001\065\001\066\001\067\001\068\001\
\069\001\070\001\071\001\072\001\073\001\074\001\075\001\076\001\
\077\001\078\001\079\001\080\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\094\001\095\001\096\001\097\001\255\255\255\255\100\001\
\255\255\102\001\255\255\104\001\105\001\255\255\255\255\255\255\
\109\001\255\255\005\001\006\001\007\001\008\001\009\001\255\255\
\255\255\255\255\013\001\014\001\255\255\016\001\017\001\018\001\
\255\255\020\001\255\255\255\255\255\255\255\255\255\255\132\001\
\027\001\028\001\135\001\136\001\255\255\032\001\033\001\255\255\
\255\255\036\001\143\001\038\001\255\255\255\255\041\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\050\001\
\051\001\052\001\255\255\255\255\255\255\255\255\057\001\058\001\
\059\001\060\001\061\001\062\001\063\001\064\001\065\001\066\001\
\067\001\068\001\069\001\070\001\071\001\072\001\073\001\074\001\
\075\001\076\001\077\001\078\001\079\001\080\001\081\001\082\001\
\255\255\084\001\085\001\086\001\087\001\088\001\089\001\090\001\
\091\001\092\001\093\001\094\001\095\001\096\001\097\001\255\255\
\255\255\100\001\101\001\102\001\255\255\104\001\105\001\106\001\
\255\255\255\255\109\001\110\001\111\001\255\255\255\255\255\255\
\115\001\255\255\117\001\118\001\119\001\120\001\121\001\122\001\
\123\001\124\001\255\255\255\255\127\001\255\255\129\001\255\255\
\131\001\132\001\255\255\134\001\135\001\136\001\255\255\255\255\
\139\001\005\001\006\001\007\001\008\001\009\001\255\255\255\255\
\255\255\013\001\014\001\255\255\016\001\017\001\018\001\255\255\
\020\001\255\255\255\255\255\255\255\255\255\255\255\255\027\001\
\028\001\255\255\255\255\255\255\032\001\033\001\255\255\255\255\
\036\001\255\255\038\001\255\255\255\255\041\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\050\001\051\001\
\052\001\255\255\255\255\255\255\255\255\057\001\058\001\059\001\
\060\001\061\001\062\001\063\001\064\001\065\001\066\001\067\001\
\068\001\069\001\070\001\071\001\072\001\073\001\074\001\075\001\
\076\001\077\001\078\001\079\001\080\001\081\001\082\001\255\255\
\084\001\085\001\086\001\087\001\088\001\089\001\090\001\091\001\
\092\001\093\001\094\001\095\001\096\001\097\001\255\255\255\255\
\100\001\101\001\102\001\255\255\104\001\105\001\106\001\255\255\
\255\255\109\001\255\255\255\255\255\255\113\001\255\255\115\001\
\255\255\117\001\118\001\119\001\120\001\121\001\122\001\123\001\
\124\001\255\255\255\255\127\001\255\255\129\001\255\255\131\001\
\132\001\255\255\134\001\135\001\136\001\137\001\255\255\139\001\
\005\001\006\001\007\001\008\001\009\001\255\255\255\255\255\255\
\013\001\014\001\255\255\016\001\017\001\018\001\255\255\020\001\
\255\255\255\255\255\255\255\255\255\255\255\255\027\001\028\001\
\255\255\255\255\255\255\032\001\033\001\255\255\255\255\036\001\
\255\255\038\001\255\255\255\255\041\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\050\001\051\001\052\001\
\255\255\255\255\255\255\255\255\057\001\058\001\059\001\060\001\
\061\001\062\001\063\001\064\001\065\001\066\001\067\001\068\001\
\069\001\070\001\071\001\072\001\073\001\074\001\075\001\076\001\
\077\001\078\001\079\001\080\001\081\001\082\001\255\255\084\001\
\085\001\086\001\087\001\088\001\089\001\090\001\091\001\092\001\
\093\001\094\001\095\001\096\001\097\001\255\255\255\255\100\001\
\101\001\102\001\255\255\104\001\105\001\106\001\255\255\255\255\
\109\001\255\255\255\255\255\255\113\001\255\255\115\001\255\255\
\117\001\118\001\119\001\120\001\121\001\122\001\123\001\124\001\
\255\255\255\255\127\001\255\255\129\001\255\255\131\001\132\001\
\255\255\134\001\135\001\136\001\137\001\255\255\139\001\005\001\
\006\001\007\001\008\001\009\001\255\255\255\255\255\255\013\001\
\014\001\255\255\016\001\017\001\018\001\255\255\020\001\255\255\
\255\255\255\255\255\255\255\255\255\255\027\001\028\001\255\255\
\255\255\255\255\032\001\033\001\255\255\255\255\036\001\255\255\
\038\001\255\255\255\255\041\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\050\001\051\001\052\001\255\255\
\255\255\255\255\255\255\057\001\058\001\059\001\060\001\061\001\
\062\001\063\001\064\001\065\001\066\001\067\001\068\001\069\001\
\070\001\071\001\072\001\073\001\074\001\075\001\076\001\077\001\
\078\001\079\001\080\001\081\001\082\001\255\255\084\001\085\001\
\086\001\087\001\088\001\089\001\090\001\091\001\092\001\093\001\
\094\001\095\001\096\001\097\001\255\255\255\255\100\001\101\001\
\102\001\255\255\104\001\105\001\106\001\255\255\255\255\109\001\
\255\255\255\255\255\255\113\001\255\255\115\001\255\255\117\001\
\118\001\119\001\120\001\121\001\122\001\123\001\124\001\255\255\
\255\255\127\001\255\255\129\001\255\255\131\001\132\001\255\255\
\134\001\135\001\136\001\137\001\255\255\139\001\005\001\006\001\
\007\001\008\001\009\001\255\255\255\255\255\255\013\001\014\001\
\255\255\016\001\017\001\018\001\255\255\020\001\255\255\255\255\
\255\255\255\255\255\255\255\255\027\001\028\001\255\255\255\255\
\255\255\032\001\033\001\255\255\255\255\036\001\255\255\038\001\
\255\255\255\255\041\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\050\001\051\001\052\001\255\255\255\255\
\255\255\255\255\057\001\058\001\059\001\060\001\061\001\062\001\
\063\001\064\001\065\001\066\001\067\001\068\001\069\001\070\001\
\071\001\072\001\073\001\074\001\075\001\076\001\077\001\078\001\
\079\001\080\001\081\001\082\001\255\255\084\001\085\001\086\001\
\087\001\088\001\089\001\090\001\091\001\092\001\093\001\094\001\
\095\001\096\001\097\001\255\255\255\255\100\001\101\001\102\001\
\255\255\104\001\105\001\106\001\255\255\255\255\109\001\255\255\
\111\001\255\255\255\255\255\255\115\001\255\255\117\001\118\001\
\119\001\120\001\121\001\122\001\123\001\124\001\255\255\255\255\
\127\001\255\255\129\001\255\255\131\001\132\001\255\255\134\001\
\135\001\136\001\255\255\255\255\139\001\005\001\006\001\007\001\
\008\001\009\001\255\255\255\255\255\255\013\001\014\001\255\255\
\016\001\017\001\018\001\255\255\020\001\255\255\255\255\255\255\
\255\255\255\255\255\255\027\001\028\001\255\255\255\255\255\255\
\032\001\033\001\255\255\255\255\036\001\255\255\038\001\255\255\
\255\255\041\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\050\001\051\001\052\001\255\255\255\255\255\255\
\255\255\057\001\058\001\059\001\060\001\061\001\062\001\063\001\
\064\001\065\001\066\001\067\001\068\001\069\001\070\001\071\001\
\072\001\073\001\074\001\075\001\076\001\077\001\078\001\079\001\
\080\001\081\001\082\001\255\255\084\001\085\001\086\001\087\001\
\088\001\089\001\090\001\091\001\092\001\093\001\094\001\095\001\
\096\001\097\001\255\255\255\255\100\001\101\001\102\001\255\255\
\104\001\105\001\106\001\255\255\255\255\109\001\255\255\255\255\
\255\255\255\255\255\255\115\001\255\255\117\001\118\001\119\001\
\120\001\121\001\122\001\123\001\124\001\255\255\255\255\127\001\
\255\255\129\001\255\255\131\001\132\001\255\255\134\001\135\001\
\136\001\255\255\255\255\139\001\005\001\006\001\007\001\008\001\
\009\001\255\255\255\255\255\255\013\001\014\001\255\255\255\255\
\017\001\018\001\255\255\020\001\255\255\255\255\255\255\255\255\
\255\255\255\255\027\001\028\001\255\255\255\255\255\255\032\001\
\033\001\255\255\255\255\036\001\255\255\038\001\255\255\255\255\
\041\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\050\001\051\001\052\001\255\255\255\255\255\255\255\255\
\057\001\058\001\059\001\060\001\061\001\062\001\063\001\064\001\
\065\001\066\001\067\001\068\001\069\001\070\001\071\001\072\001\
\073\001\074\001\075\001\076\001\077\001\078\001\079\001\080\001\
\081\001\082\001\255\255\084\001\085\001\086\001\087\001\088\001\
\089\001\090\001\091\001\092\001\093\001\094\001\095\001\096\001\
\097\001\255\255\255\255\100\001\101\001\102\001\255\255\104\001\
\105\001\255\255\255\255\255\255\109\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\005\001\006\001\007\001\
\008\001\009\001\255\255\124\001\255\255\013\001\014\001\255\255\
\255\255\017\001\018\001\132\001\020\001\134\001\135\001\136\001\
\255\255\255\255\139\001\027\001\028\001\255\255\255\255\255\255\
\032\001\033\001\255\255\255\255\036\001\255\255\038\001\255\255\
\255\255\041\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\050\001\051\001\052\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\062\001\039\001\
\040\001\041\001\042\001\043\001\044\001\045\001\046\001\047\001\
\048\001\049\001\050\001\051\001\052\001\053\001\054\001\055\001\
\056\001\081\001\082\001\255\255\084\001\085\001\086\001\087\001\
\088\001\089\001\090\001\091\001\092\001\093\001\094\001\095\001\
\096\001\097\001\255\255\255\255\255\255\101\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\109\001\005\001\006\001\
\007\001\008\001\009\001\255\255\255\255\117\001\013\001\014\001\
\255\255\255\255\017\001\018\001\124\001\020\001\255\255\255\255\
\255\255\255\255\255\255\255\255\027\001\028\001\134\001\135\001\
\136\001\032\001\033\001\139\001\255\255\036\001\255\255\038\001\
\255\255\255\255\041\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\050\001\051\001\052\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\062\001\
\040\001\041\001\042\001\043\001\044\001\045\001\046\001\047\001\
\048\001\049\001\050\001\051\001\052\001\053\001\054\001\055\001\
\056\001\255\255\081\001\082\001\255\255\084\001\085\001\086\001\
\087\001\088\001\089\001\090\001\091\001\092\001\093\001\094\001\
\095\001\096\001\097\001\255\255\255\255\255\255\101\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\109\001\005\001\
\006\001\007\001\008\001\009\001\255\255\255\255\255\255\013\001\
\014\001\255\255\255\255\017\001\018\001\124\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\027\001\028\001\134\001\
\135\001\136\001\032\001\033\001\139\001\255\255\036\001\255\255\
\038\001\255\255\255\255\041\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\050\001\051\001\052\001\255\255\
\255\255\255\255\255\255\057\001\058\001\059\001\060\001\061\001\
\255\255\063\001\064\001\065\001\066\001\067\001\068\001\069\001\
\070\001\071\001\072\001\073\001\074\001\075\001\076\001\077\001\
\078\001\079\001\080\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\094\001\095\001\096\001\097\001\255\255\255\255\100\001\255\255\
\102\001\255\255\104\001\105\001\255\255\255\255\255\255\109\001\
\255\255\005\001\006\001\007\001\008\001\009\001\255\255\255\255\
\255\255\013\001\014\001\255\255\255\255\017\001\018\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\132\001\027\001\
\028\001\135\001\136\001\255\255\032\001\033\001\255\255\255\255\
\255\255\255\255\038\001\255\255\255\255\041\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\050\001\051\001\
\052\001\255\255\255\255\255\255\255\255\057\001\058\001\059\001\
\060\001\061\001\255\255\063\001\064\001\065\001\066\001\067\001\
\068\001\069\001\255\255\255\255\255\255\255\255\255\255\075\001\
\076\001\077\001\078\001\079\001\080\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\094\001\095\001\096\001\097\001\255\255\255\255\
\100\001\255\255\255\255\255\255\255\255\105\001\255\255\255\255\
\255\255\109\001\005\001\006\001\007\001\008\001\009\001\255\255\
\255\255\255\255\013\001\014\001\255\255\255\255\017\001\018\001\
\255\255\020\001\021\001\022\001\255\255\024\001\255\255\255\255\
\027\001\028\001\255\255\135\001\136\001\032\001\033\001\255\255\
\255\255\255\255\255\255\038\001\255\255\255\255\041\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\050\001\
\051\001\052\001\255\255\255\255\005\001\006\001\007\001\008\001\
\009\001\255\255\255\255\062\001\013\001\014\001\255\255\255\255\
\017\001\018\001\255\255\020\001\021\001\022\001\255\255\024\001\
\255\255\255\255\027\001\028\001\255\255\255\255\255\255\032\001\
\033\001\255\255\255\255\255\255\255\255\038\001\255\255\255\255\
\041\001\255\255\255\255\094\001\095\001\096\001\097\001\255\255\
\255\255\050\001\051\001\052\001\255\255\255\255\255\255\255\255\
\255\255\255\255\109\001\255\255\255\255\062\001\255\255\255\255\
\005\001\006\001\007\001\008\001\009\001\255\255\255\255\255\255\
\013\001\014\001\255\255\255\255\017\001\018\001\255\255\020\001\
\255\255\022\001\255\255\024\001\135\001\136\001\027\001\028\001\
\255\255\255\255\255\255\032\001\033\001\094\001\095\001\096\001\
\097\001\038\001\255\255\255\255\041\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\109\001\050\001\051\001\052\001\
\255\255\255\255\005\001\006\001\007\001\008\001\009\001\255\255\
\255\255\062\001\013\001\014\001\255\255\255\255\255\255\018\001\
\255\255\020\001\255\255\255\255\255\255\255\255\135\001\136\001\
\027\001\028\001\255\255\255\255\255\255\032\001\033\001\255\255\
\255\255\255\255\255\255\038\001\255\255\255\255\041\001\255\255\
\255\255\094\001\095\001\096\001\097\001\255\255\255\255\050\001\
\051\001\052\001\255\255\005\001\006\001\007\001\008\001\009\001\
\109\001\255\255\255\255\013\001\014\001\255\255\255\255\255\255\
\018\001\255\255\255\255\255\255\022\001\255\255\255\255\255\255\
\255\255\027\001\028\001\255\255\255\255\255\255\032\001\033\001\
\255\255\255\255\135\001\136\001\038\001\255\255\255\255\041\001\
\255\255\255\255\255\255\094\001\095\001\096\001\097\001\255\255\
\050\001\051\001\052\001\255\255\255\255\005\001\006\001\007\001\
\008\001\009\001\109\001\255\255\255\255\013\001\014\001\255\255\
\255\255\255\255\018\001\255\255\255\255\255\255\255\255\023\001\
\255\255\255\255\255\255\027\001\028\001\255\255\255\255\255\255\
\032\001\033\001\255\255\255\255\135\001\136\001\038\001\255\255\
\255\255\041\001\255\255\255\255\094\001\095\001\096\001\097\001\
\255\255\255\255\050\001\051\001\052\001\255\255\005\001\006\001\
\007\001\008\001\009\001\109\001\255\255\255\255\013\001\014\001\
\255\255\255\255\255\255\018\001\255\255\255\255\255\255\255\255\
\023\001\255\255\255\255\255\255\027\001\028\001\255\255\255\255\
\255\255\032\001\033\001\255\255\255\255\135\001\136\001\038\001\
\255\255\255\255\041\001\255\255\255\255\255\255\094\001\095\001\
\096\001\097\001\255\255\050\001\051\001\052\001\255\255\255\255\
\005\001\006\001\007\001\008\001\009\001\109\001\255\255\255\255\
\013\001\014\001\255\255\255\255\255\255\018\001\255\255\020\001\
\255\255\255\255\255\255\255\255\255\255\255\255\027\001\028\001\
\255\255\255\255\255\255\032\001\033\001\255\255\255\255\135\001\
\136\001\038\001\255\255\255\255\041\001\255\255\255\255\094\001\
\095\001\096\001\097\001\255\255\255\255\050\001\051\001\052\001\
\255\255\255\255\255\255\255\255\255\255\255\255\109\001\041\001\
\042\001\043\001\044\001\045\001\046\001\047\001\048\001\049\001\
\050\001\051\001\052\001\053\001\054\001\055\001\056\001\255\255\
\255\255\255\255\005\001\006\001\007\001\008\001\009\001\255\255\
\135\001\136\001\013\001\014\001\255\255\255\255\255\255\018\001\
\255\255\094\001\095\001\096\001\097\001\255\255\255\255\255\255\
\027\001\028\001\255\255\255\255\255\255\032\001\033\001\255\255\
\109\001\036\001\255\255\038\001\255\255\255\255\041\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\050\001\
\051\001\052\001\255\255\255\255\005\001\006\001\007\001\008\001\
\009\001\255\255\135\001\136\001\013\001\014\001\255\255\255\255\
\255\255\018\001\255\255\020\001\255\255\255\255\255\255\255\255\
\255\255\255\255\027\001\028\001\255\255\255\255\255\255\032\001\
\033\001\255\255\255\255\255\255\255\255\038\001\255\255\255\255\
\041\001\255\255\255\255\094\001\095\001\096\001\097\001\255\255\
\255\255\050\001\051\001\052\001\255\255\005\001\006\001\007\001\
\008\001\009\001\109\001\255\255\255\255\013\001\014\001\255\255\
\255\255\255\255\018\001\255\255\255\255\255\255\255\255\023\001\
\255\255\255\255\255\255\027\001\028\001\255\255\255\255\255\255\
\032\001\033\001\255\255\255\255\135\001\136\001\038\001\255\255\
\255\255\041\001\255\255\255\255\255\255\094\001\095\001\096\001\
\097\001\255\255\050\001\051\001\052\001\255\255\255\255\005\001\
\006\001\007\001\008\001\009\001\109\001\255\255\255\255\013\001\
\014\001\255\255\255\255\255\255\018\001\019\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\027\001\028\001\255\255\
\255\255\255\255\032\001\033\001\255\255\255\255\135\001\136\001\
\038\001\255\255\255\255\041\001\255\255\255\255\094\001\095\001\
\096\001\097\001\255\255\255\255\050\001\051\001\052\001\255\255\
\005\001\006\001\007\001\008\001\009\001\109\001\255\255\255\255\
\013\001\014\001\255\255\255\255\255\255\018\001\019\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\027\001\028\001\
\255\255\255\255\255\255\032\001\033\001\255\255\255\255\135\001\
\136\001\038\001\255\255\255\255\041\001\255\255\255\255\255\255\
\094\001\095\001\096\001\097\001\255\255\050\001\051\001\052\001\
\255\255\255\255\005\001\006\001\007\001\008\001\009\001\109\001\
\255\255\255\255\013\001\014\001\255\255\255\255\255\255\018\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\027\001\028\001\255\255\255\255\255\255\032\001\033\001\255\255\
\255\255\135\001\136\001\038\001\255\255\255\255\041\001\255\255\
\255\255\094\001\095\001\096\001\097\001\255\255\255\255\050\001\
\051\001\052\001\255\255\255\255\255\255\255\255\255\255\255\255\
\109\001\255\255\255\255\255\255\255\255\017\001\255\255\019\001\
\020\001\255\255\255\255\255\255\255\255\025\001\255\255\255\255\
\255\255\255\255\030\001\255\255\255\255\255\255\255\255\035\001\
\036\001\255\255\135\001\136\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\094\001\095\001\096\001\097\001\255\255\
\255\255\255\255\255\255\255\255\255\255\057\001\058\001\059\001\
\060\001\061\001\109\001\063\001\064\001\065\001\066\001\067\001\
\068\001\069\001\070\001\071\001\072\001\073\001\074\001\075\001\
\076\001\077\001\078\001\079\001\080\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\135\001\136\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\098\001\255\255\
\100\001\101\001\102\001\255\255\104\001\105\001\106\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\115\001\
\255\255\017\001\255\255\019\001\020\001\255\255\255\255\255\255\
\255\255\025\001\255\255\127\001\255\255\129\001\030\001\131\001\
\132\001\133\001\255\255\035\001\036\001\137\001\255\255\255\255\
\255\255\255\255\142\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\057\001\058\001\059\001\060\001\061\001\255\255\063\001\
\064\001\065\001\066\001\067\001\068\001\069\001\070\001\071\001\
\072\001\073\001\074\001\075\001\076\001\077\001\078\001\079\001\
\080\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\098\001\255\255\100\001\101\001\102\001\255\255\
\104\001\105\001\106\001\255\255\014\001\255\255\255\255\017\001\
\018\001\255\255\255\255\115\001\022\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\127\001\
\255\255\129\001\036\001\131\001\132\001\133\001\255\255\041\001\
\255\255\137\001\255\255\255\255\255\255\255\255\142\001\255\255\
\255\255\255\255\052\001\255\255\255\255\255\255\255\255\057\001\
\058\001\059\001\060\001\061\001\255\255\063\001\064\001\065\001\
\066\001\067\001\068\001\069\001\070\001\071\001\072\001\073\001\
\074\001\075\001\076\001\077\001\078\001\079\001\080\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\014\001\255\255\255\255\
\017\001\255\255\100\001\255\255\102\001\255\255\104\001\105\001\
\255\255\255\255\255\255\109\001\255\255\255\255\255\255\113\001\
\255\255\255\255\255\255\036\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\014\001\255\255\255\255\017\001\018\001\
\255\255\255\255\132\001\255\255\255\255\135\001\255\255\137\001\
\057\001\058\001\059\001\060\001\061\001\062\001\063\001\064\001\
\065\001\066\001\067\001\068\001\069\001\255\255\255\255\255\255\
\255\255\255\255\075\001\076\001\077\001\078\001\079\001\080\001\
\255\255\255\255\255\255\255\255\255\255\255\255\057\001\058\001\
\059\001\060\001\061\001\255\255\063\001\064\001\065\001\066\001\
\067\001\068\001\069\001\100\001\255\255\255\255\255\255\255\255\
\105\001\106\001\077\001\078\001\079\001\080\001\255\255\255\255\
\255\255\255\255\115\001\255\255\117\001\118\001\119\001\120\001\
\121\001\122\001\123\001\255\255\255\255\255\255\127\001\255\255\
\129\001\014\001\131\001\255\255\017\001\018\001\105\001\255\255\
\137\001\022\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\035\001\036\001\
\255\255\255\255\255\255\255\255\041\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\052\001\
\255\255\255\255\255\255\255\255\057\001\058\001\059\001\060\001\
\061\001\255\255\063\001\064\001\065\001\066\001\067\001\068\001\
\069\001\070\001\071\001\072\001\073\001\074\001\075\001\076\001\
\077\001\078\001\079\001\080\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\017\001\255\255\100\001\
\020\001\102\001\255\255\104\001\105\001\025\001\255\255\255\255\
\109\001\255\255\030\001\255\255\113\001\255\255\255\255\255\255\
\036\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\132\001\
\255\255\255\255\135\001\255\255\255\255\057\001\058\001\059\001\
\060\001\061\001\255\255\063\001\064\001\065\001\066\001\067\001\
\068\001\069\001\070\001\071\001\072\001\073\001\074\001\075\001\
\076\001\077\001\078\001\079\001\080\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\098\001\255\255\
\100\001\255\255\102\001\255\255\104\001\105\001\106\001\255\255\
\255\255\017\001\255\255\255\255\020\001\255\255\255\255\115\001\
\255\255\025\001\255\255\255\255\255\255\255\255\030\001\255\255\
\255\255\255\255\255\255\127\001\036\001\129\001\255\255\131\001\
\132\001\255\255\255\255\255\255\255\255\137\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\057\001\058\001\059\001\060\001\061\001\255\255\063\001\
\064\001\065\001\066\001\067\001\068\001\069\001\070\001\071\001\
\072\001\073\001\074\001\075\001\076\001\077\001\078\001\079\001\
\080\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\015\001\098\001\017\001\100\001\019\001\102\001\255\255\
\104\001\105\001\106\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\115\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\127\001\
\255\255\129\001\255\255\131\001\132\001\255\255\255\255\255\255\
\255\255\137\001\255\255\057\001\058\001\059\001\060\001\061\001\
\255\255\063\001\064\001\065\001\066\001\067\001\068\001\069\001\
\070\001\071\001\072\001\073\001\074\001\075\001\076\001\077\001\
\078\001\079\001\080\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\015\001\255\255\017\001\
\255\255\255\255\255\255\255\255\255\255\255\255\100\001\255\255\
\102\001\255\255\104\001\105\001\255\255\255\255\255\255\255\255\
\034\001\014\001\015\001\016\001\017\001\018\001\019\001\020\001\
\021\001\022\001\023\001\024\001\025\001\026\001\027\001\028\001\
\029\001\030\001\031\001\032\001\033\001\255\255\132\001\057\001\
\058\001\059\001\060\001\061\001\255\255\063\001\064\001\065\001\
\066\001\067\001\068\001\069\001\070\001\071\001\072\001\073\001\
\074\001\075\001\076\001\077\001\078\001\079\001\080\001\255\255\
\255\255\255\255\255\255\015\001\255\255\017\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\100\001\255\255\102\001\255\255\104\001\105\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\057\001\058\001\059\001\
\060\001\061\001\132\001\063\001\064\001\065\001\066\001\067\001\
\068\001\069\001\070\001\071\001\072\001\073\001\074\001\075\001\
\076\001\077\001\078\001\079\001\080\001\255\255\255\255\255\255\
\255\255\015\001\255\255\017\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\100\001\255\255\102\001\255\255\104\001\105\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\057\001\058\001\059\001\060\001\061\001\
\132\001\063\001\064\001\065\001\066\001\067\001\068\001\069\001\
\070\001\071\001\072\001\073\001\074\001\075\001\076\001\077\001\
\078\001\079\001\080\001\255\255\255\255\255\255\255\255\255\255\
\016\001\017\001\255\255\255\255\255\255\021\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\100\001\255\255\
\102\001\255\255\104\001\105\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\057\001\058\001\059\001\060\001\061\001\132\001\063\001\
\064\001\065\001\066\001\067\001\068\001\069\001\070\001\071\001\
\072\001\073\001\074\001\075\001\076\001\077\001\078\001\079\001\
\080\001\255\255\255\255\255\255\255\255\255\255\016\001\017\001\
\255\255\255\255\255\255\021\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\099\001\100\001\255\255\102\001\255\255\
\104\001\105\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\057\001\
\058\001\059\001\060\001\061\001\132\001\063\001\064\001\065\001\
\066\001\067\001\068\001\069\001\070\001\071\001\072\001\073\001\
\074\001\075\001\076\001\077\001\078\001\079\001\080\001\255\255\
\255\255\255\255\255\255\255\255\255\255\017\001\255\255\255\255\
\020\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\099\001\100\001\255\255\102\001\255\255\104\001\105\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\057\001\058\001\059\001\
\060\001\061\001\132\001\063\001\064\001\065\001\066\001\067\001\
\068\001\069\001\070\001\071\001\072\001\073\001\074\001\075\001\
\076\001\077\001\078\001\079\001\080\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\017\001\255\255\255\255\020\001\255\255\255\255\255\255\
\100\001\255\255\102\001\255\255\104\001\105\001\106\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\115\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\127\001\255\255\129\001\255\255\131\001\
\132\001\057\001\058\001\059\001\060\001\061\001\255\255\063\001\
\064\001\065\001\066\001\067\001\068\001\069\001\070\001\071\001\
\072\001\073\001\074\001\075\001\076\001\077\001\078\001\079\001\
\080\001\255\255\255\255\255\255\255\255\255\255\255\255\017\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\100\001\255\255\102\001\255\255\
\104\001\105\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\057\001\
\058\001\059\001\060\001\061\001\132\001\063\001\064\001\065\001\
\066\001\067\001\068\001\069\001\070\001\071\001\072\001\073\001\
\074\001\075\001\076\001\077\001\078\001\079\001\080\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\100\001\255\255\102\001\255\255\104\001\105\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\018\001\255\255\255\255\255\255\022\001\255\255\
\024\001\025\001\026\001\027\001\028\001\029\001\030\001\031\001\
\255\255\255\255\132\001\035\001\036\001\037\001\038\001\039\001\
\040\001\041\001\042\001\043\001\044\001\045\001\046\001\047\001\
\048\001\049\001\050\001\051\001\052\001\053\001\054\001\055\001\
\056\001\018\001\255\255\255\255\255\255\022\001\255\255\024\001\
\025\001\026\001\027\001\028\001\029\001\030\001\031\001\255\255\
\255\255\255\255\035\001\036\001\037\001\038\001\039\001\040\001\
\041\001\042\001\043\001\044\001\045\001\046\001\047\001\048\001\
\049\001\050\001\051\001\052\001\053\001\054\001\055\001\056\001\
\014\001\255\255\255\255\017\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\113\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\017\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\057\001\058\001\059\001\060\001\061\001\
\255\255\063\001\064\001\065\001\066\001\067\001\068\001\069\001\
\113\001\255\255\255\255\255\255\255\255\255\255\255\255\077\001\
\078\001\079\001\080\001\057\001\058\001\059\001\060\001\061\001\
\255\255\063\001\064\001\065\001\066\001\067\001\068\001\069\001\
\017\001\255\255\255\255\255\255\255\255\075\001\076\001\077\001\
\078\001\079\001\080\001\105\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\100\001\255\255\
\255\255\255\255\255\255\105\001\255\255\255\255\255\255\255\255\
\057\001\058\001\059\001\060\001\061\001\255\255\063\001\064\001\
\065\001\066\001\067\001\068\001\069\001\255\255\255\255\255\255\
\255\255\255\255\075\001\076\001\077\001\078\001\079\001\080\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\005\001\006\001\007\001\
\008\001\255\255\255\255\100\001\255\255\255\255\014\001\255\255\
\105\001\017\001\018\001\019\001\020\001\021\001\255\255\255\255\
\255\255\025\001\255\255\027\001\028\001\029\001\030\001\031\001\
\255\255\033\001\255\255\035\001\036\001\037\001\038\001\039\001\
\040\001\041\001\042\001\043\001\044\001\045\001\046\001\047\001\
\048\001\049\001\050\001\051\001\052\001\053\001\054\001\055\001\
\056\001\255\255\255\255\255\255\255\255\255\255\005\001\006\001\
\007\001\008\001\255\255\255\255\255\255\255\255\255\255\014\001\
\255\255\255\255\017\001\018\001\019\001\020\001\021\001\255\255\
\255\255\255\255\025\001\083\001\027\001\028\001\029\001\030\001\
\031\001\089\001\033\001\255\255\035\001\036\001\037\001\038\001\
\039\001\040\001\041\001\042\001\043\001\044\001\045\001\046\001\
\047\001\048\001\049\001\050\001\051\001\052\001\053\001\054\001\
\055\001\056\001\255\255\255\255\255\255\255\255\255\255\005\001\
\006\001\007\001\008\001\255\255\255\255\255\255\255\255\255\255\
\014\001\255\255\255\255\017\001\018\001\019\001\020\001\021\001\
\255\255\255\255\255\255\025\001\083\001\027\001\028\001\029\001\
\030\001\031\001\089\001\033\001\255\255\035\001\255\255\037\001\
\038\001\039\001\040\001\041\001\042\001\043\001\044\001\045\001\
\046\001\047\001\048\001\049\001\050\001\051\001\052\001\053\001\
\054\001\055\001\056\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\018\001\255\255\255\255\021\001\022\001\255\255\024\001\
\025\001\026\001\027\001\028\001\255\255\083\001\031\001\255\255\
\255\255\255\255\035\001\089\001\037\001\038\001\039\001\040\001\
\041\001\042\001\043\001\044\001\045\001\046\001\047\001\048\001\
\049\001\050\001\051\001\052\001\053\001\054\001\055\001\056\001"

let yynames_const = "\
  "

let yynames_block = "\
  TUnknown\000\
  TCommentSpace\000\
  TCommentNewline\000\
  TComment\000\
  TInt\000\
  TFloat\000\
  TChar\000\
  TString\000\
  TQuote\000\
  TPct\000\
  TFormat\000\
  TSubString\000\
  TDecimal\000\
  TIdent\000\
  TKRParam\000\
  Tconstructorname\000\
  TypedefIdent\000\
  TOPar\000\
  TCPar\000\
  TOBrace\000\
  TCBrace\000\
  TOCro\000\
  TCCro\000\
  TDot\000\
  TComma\000\
  TPtrOp\000\
  TInc\000\
  TDec\000\
  TAssign\000\
  TEq\000\
  TWhy\000\
  TTilde\000\
  TBang\000\
  TEllipsis\000\
  TDotDot\000\
  TPtVirg\000\
  TOrLog\000\
  TAndLog\000\
  TOr\000\
  TXor\000\
  TAnd\000\
  TEqEq\000\
  TNotEq\000\
  TInf\000\
  TSup\000\
  TInfEq\000\
  TSupEq\000\
  TShl\000\
  TShr\000\
  TPlus\000\
  TMinus\000\
  TMul\000\
  TDiv\000\
  TMod\000\
  TMax\000\
  TMin\000\
  Tchar\000\
  Tshort\000\
  Tint\000\
  Tdouble\000\
  Tfloat\000\
  Tcomplex\000\
  Tlong\000\
  Tunsigned\000\
  Tsigned\000\
  Tvoid\000\
  Tsize_t\000\
  Tssize_t\000\
  Tptrdiff_t\000\
  Tauto\000\
  Tregister\000\
  Textern\000\
  Tstatic\000\
  Ttypedef\000\
  Tconst\000\
  Tvolatile\000\
  Tstruct\000\
  Tunion\000\
  Tenum\000\
  Tdecimal\000\
  Texec\000\
  Tbreak\000\
  Telse\000\
  Tswitch\000\
  Tcase\000\
  Tcontinue\000\
  Tfor\000\
  Tdo\000\
  Tif\000\
  Twhile\000\
  Treturn\000\
  Tgoto\000\
  Tdefault\000\
  Tsizeof\000\
  Tnew\000\
  Tdelete\000\
  Tdefined\000\
  TOParCplusplusInit\000\
  Tnamespace\000\
  Trestrict\000\
  Tasm\000\
  Tattribute\000\
  TattributeNoarg\000\
  Tinline\000\
  Ttypeof\000\
  TDefine\000\
  TDefParamVariadic\000\
  TCppEscapedNewline\000\
  TCppConcatOp\000\
  TOParDefine\000\
  TOBraceDefineInit\000\
  TIdentDefine\000\
  TDefEOL\000\
  TInclude\000\
  TIncludeStart\000\
  TIncludeFilename\000\
  TIfdef\000\
  TIfdefelif\000\
  TIfdefelse\000\
  TEndif\000\
  TIfdefBool\000\
  TIfdefMisc\000\
  TIfdefVersion\000\
  TUifdef\000\
  TUelseif\000\
  TUendif\000\
  TUndef\000\
  TPrePragma\000\
  TPragma\000\
  TPragmaString\000\
  TCppDirectiveOther\000\
  TMacroAttr\000\
  TMacroEndAttr\000\
  TMacroStmt\000\
  TMacroIdentBuilder\000\
  TMacroString\000\
  TMacroDecl\000\
  TMacroDeclConst\000\
  TMacroIterator\000\
  TCommentSkipTagStart\000\
  TCommentSkipTagEnd\000\
  TCParEOL\000\
  TAction\000\
  TCommentMisc\000\
  TCommentCpp\000\
  EOF\000\
  TTODO\000\
  "

let yyact = [|
  (fun _ -> failwith "parser")
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'translation_unit) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 701 "parsing_c/parser_c.mly"
                          ( _1 )
# 3337 "parsing_c/parser_c.ml"
               : Ast_c.program))
; (fun __caml_parser_env ->
    Obj.repr(
# 705 "parsing_c/parser_c.mly"
     ( [] )
# 3343 "parsing_c/parser_c.ml"
               : 'translation_unit))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'translation_unit) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'external_declaration) in
    Obj.repr(
# 707 "parsing_c/parser_c.mly"
     ( !LP._lexer_hint.context_stack <- [LP.InTopLevel]; _1 @ [_2] )
# 3351 "parsing_c/parser_c.ml"
               : 'translation_unit))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : 'translation_unit) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : string * Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : 'translation_unit) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 709 "parsing_c/parser_c.mly"
     ( !LP._lexer_hint.context_stack <- [LP.InTopLevel];
       _1 @ [Namespace (_5, [_2; snd _3; _4; _6])] )
# 3364 "parsing_c/parser_c.ml"
               : 'translation_unit))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 722 "parsing_c/parser_c.mly"
                ( _1 )
# 3371 "parsing_c/parser_c.ml"
               : 'ident))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 723 "parsing_c/parser_c.mly"
                ( _1 )
# 3378 "parsing_c/parser_c.ml"
               : 'ident))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 724 "parsing_c/parser_c.mly"
                ( ("complex", _1) )
# 3385 "parsing_c/parser_c.ml"
               : 'ident))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 728 "parsing_c/parser_c.mly"
                ( _1 )
# 3392 "parsing_c/parser_c.ml"
               : 'identifier))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 729 "parsing_c/parser_c.mly"
                ( ("complex", _1) )
# 3399 "parsing_c/parser_c.ml"
               : 'identifier))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 738 "parsing_c/parser_c.mly"
     ( RegularName (mk_string_wrap _1) )
# 3406 "parsing_c/parser_c.ml"
               : 'identifier_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'ident_extra_cpp) in
    Obj.repr(
# 739 "parsing_c/parser_c.mly"
                   ( _1 )
# 3413 "parsing_c/parser_c.ml"
               : 'identifier_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 743 "parsing_c/parser_c.mly"
     ( RegularName (mk_string_wrap _1) )
# 3420 "parsing_c/parser_c.ml"
               : 'ident_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 745 "parsing_c/parser_c.mly"
     ( RegularName (mk_string_wrap _1) )
# 3427 "parsing_c/parser_c.ml"
               : 'ident_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'ident_extra_cpp) in
    Obj.repr(
# 746 "parsing_c/parser_c.mly"
                   ( _1 )
# 3434 "parsing_c/parser_c.ml"
               : 'ident_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 747 "parsing_c/parser_c.mly"
                ( RegularName (mk_string_wrap ("complex", _1)) )
# 3441 "parsing_c/parser_c.ml"
               : 'ident_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'identifier_cpp_list) in
    Obj.repr(
# 751 "parsing_c/parser_c.mly"
     (
       CppConcatenatedName (
         match _3 with
         | [] -> raise (Impossible 87)
         | (x,concatnull)::xs ->
             assert (concatnull = []);
             (mk_string_wrap _1, [])::(x,[_2])::xs
       )
   )
# 3458 "parsing_c/parser_c.ml"
               : 'ident_extra_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 761 "parsing_c/parser_c.mly"
     ( CppVariadicName (fst _2, [_1; snd _2]) )
# 3466 "parsing_c/parser_c.ml"
               : 'ident_extra_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : (string * Ast_c.info)) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'param_define_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 763 "parsing_c/parser_c.mly"
     ( CppIdentBuilder ((fst _1, [snd _1;_2;_4]), _3) )
# 3476 "parsing_c/parser_c.ml"
               : 'ident_extra_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 766 "parsing_c/parser_c.mly"
          ( [mk_string_wrap _1, []] )
# 3483 "parsing_c/parser_c.ml"
               : 'identifier_cpp_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'identifier_cpp_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 767 "parsing_c/parser_c.mly"
                                           ( _1 @ [mk_string_wrap _3, [_2]] )
# 3492 "parsing_c/parser_c.ml"
               : 'identifier_cpp_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 774 "parsing_c/parser_c.mly"
                           ( _1 )
# 3499 "parsing_c/parser_c.ml"
               : Ast_c.expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.expression) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 775 "parsing_c/parser_c.mly"
                           ( mk_e (Sequence (_1,_3)) [_2] )
# 3508 "parsing_c/parser_c.ml"
               : Ast_c.expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cond_expr) in
    Obj.repr(
# 781 "parsing_c/parser_c.mly"
                                 ( _1 )
# 3515 "parsing_c/parser_c.ml"
               : 'assign_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'cast_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.assignOp) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 782 "parsing_c/parser_c.mly"
                                 ( mk_e(Assignment (_1, _2, _3)) [])
# 3524 "parsing_c/parser_c.ml"
               : 'assign_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'cast_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 783 "parsing_c/parser_c.mly"
                                 ( mk_e (Assignment (_1, (SimpleAssign, [_2]),_3)) [])
# 3533 "parsing_c/parser_c.ml"
               : 'assign_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 791 "parsing_c/parser_c.mly"
     ( _1 )
# 3540 "parsing_c/parser_c.ml"
               : 'cond_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'gcc_opt_expr) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 793 "parsing_c/parser_c.mly"
     ( mk_e (CondExpr (_1,_3,_5)) [_2;_4] )
# 3551 "parsing_c/parser_c.ml"
               : 'cond_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cast_expr) in
    Obj.repr(
# 797 "parsing_c/parser_c.mly"
                                 ( _1 )
# 3558 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 798 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith Mul,[_2]), _3)) [] )
# 3567 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 799 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith Div, [_2]), _3)) [] )
# 3576 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 800 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith Min, [_2]), _3)) [] )
# 3585 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 801 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith Max, [_2]), _3)) [] )
# 3594 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 802 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith Mod, [_2]), _3)) [] )
# 3603 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 803 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith Plus, [_2]), _3)) [] )
# 3612 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 804 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith Minus, [_2]), _3)) [] )
# 3621 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 805 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith DecLeft, [_2]), _3)) [] )
# 3630 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 806 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith DecRight, [_2]), _3)) [] )
# 3639 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 807 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Logical Inf, [_2]), _3)) [] )
# 3648 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 808 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Logical Sup, [_2]), _3)) [] )
# 3657 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 809 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Logical InfEq, [_2]), _3)) [] )
# 3666 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 810 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Logical SupEq, [_2]), _3)) [] )
# 3675 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 811 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Logical Eq, [_2]), _3)) [] )
# 3684 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 812 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Logical NotEq, [_2]), _3)) [] )
# 3693 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 813 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith And, [_2]), _3)) [] )
# 3702 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 814 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith Or, [_2]), _3)) [] )
# 3711 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 815 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith Xor, [_2]), _3)) [] )
# 3720 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 816 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Logical AndLog, [_2]), _3)) [] )
# 3729 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 817 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Logical OrLog, [_2]), _3)) [] )
# 3738 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'unary_expr) in
    Obj.repr(
# 820 "parsing_c/parser_c.mly"
                                     ( _1 )
# 3745 "parsing_c/parser_c.ml"
               : 'cast_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'topar2) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.fullType) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'tcpar2) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'cast_expr) in
    Obj.repr(
# 821 "parsing_c/parser_c.mly"
                                     ( mk_e(Cast (_2, _4)) [_1;_3] )
# 3755 "parsing_c/parser_c.ml"
               : 'cast_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'postfix_expr) in
    Obj.repr(
# 829 "parsing_c/parser_c.mly"
                                   ( _1 )
# 3762 "parsing_c/parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'unary_expr) in
    Obj.repr(
# 830 "parsing_c/parser_c.mly"
                                   ( mk_e(Infix (_2, Inc))    [_1] )
# 3770 "parsing_c/parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'unary_expr) in
    Obj.repr(
# 831 "parsing_c/parser_c.mly"
                                   ( mk_e(Infix (_2, Dec))    [_1] )
# 3778 "parsing_c/parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'unary_op) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'cast_expr) in
    Obj.repr(
# 832 "parsing_c/parser_c.mly"
                                   ( mk_e(Unary (_2, fst _1)) [snd _1] )
# 3786 "parsing_c/parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'unary_expr) in
    Obj.repr(
# 833 "parsing_c/parser_c.mly"
                                   ( mk_e(SizeOfExpr (_2))    [_1] )
# 3794 "parsing_c/parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'topar2) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.fullType) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tcpar2) in
    Obj.repr(
# 834 "parsing_c/parser_c.mly"
                                   ( mk_e(SizeOfType (_3))    [_1;_2;_4] )
# 3804 "parsing_c/parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'new_argument) in
    Obj.repr(
# 835 "parsing_c/parser_c.mly"
                                   ( mk_e(New (None, _2))     [_1] )
# 3812 "parsing_c/parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list_ne) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'new_argument) in
    Obj.repr(
# 836 "parsing_c/parser_c.mly"
                                                  ( mk_e(New (Some _3, _5))             [_1; _2; _4] )
# 3823 "parsing_c/parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'cast_expr) in
    Obj.repr(
# 837 "parsing_c/parser_c.mly"
                                   ( mk_e(Delete(false, _2))  [_1] )
# 3831 "parsing_c/parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'cast_expr) in
    Obj.repr(
# 838 "parsing_c/parser_c.mly"
                                   ( mk_e(Delete(true, _4))   [_1;_2;_3] )
# 3841 "parsing_c/parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'identifier_cpp) in
    Obj.repr(
# 839 "parsing_c/parser_c.mly"
                                   ( mk_e(Defined _2)         [_1] )
# 3849 "parsing_c/parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'identifier_cpp) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 841 "parsing_c/parser_c.mly"
 ( mk_e(Defined _3) [_1;_2;_4] )
# 3859 "parsing_c/parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'argument_list_ne) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 845 "parsing_c/parser_c.mly"
     ( let fn = mk_e(Ident (RegularName (mk_string_wrap _1))) [] in
       Left (mk_e(FunCall (fn, _3)) [_2;_4]) )
# 3870 "parsing_c/parser_c.ml"
               : 'new_argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 848 "parsing_c/parser_c.mly"
     ( let fn = mk_e(Ident (RegularName (mk_string_wrap _1))) [] in
       Left(mk_e(FunCall (fn, [])) [_2;_3]) )
# 3880 "parsing_c/parser_c.ml"
               : 'new_argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'argument_list_ne) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 851 "parsing_c/parser_c.mly"
     ( let fn = mk_e(Ident (RegularName (mk_string_wrap _1))) [] in
       Left (mk_e(FunCall (fn, _3)) [_2;_4]) )
# 3891 "parsing_c/parser_c.ml"
               : 'new_argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 854 "parsing_c/parser_c.mly"
     ( let fn = mk_e(Ident (RegularName (mk_string_wrap _1))) [] in
       Left (mk_e(FunCall (fn, [])) [_2;_3]) )
# 3901 "parsing_c/parser_c.ml"
               : 'new_argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_spec) in
    Obj.repr(
# 857 "parsing_c/parser_c.mly"
     ( let ty = addTypeD (_1,nullDecl) in
       let ((returnType,hasreg), iihasreg) = fixDeclSpecForParam ty in
       Right (ArgType { p_namei = None; p_type = returnType;
			p_register = hasreg, iihasreg;
		      } )
     )
# 3913 "parsing_c/parser_c.ml"
               : 'new_argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'new_argument) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.expression) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 864 "parsing_c/parser_c.mly"
     (
       match _1 with
	 Left(e) -> Left(mk_e(ArrayAccess (e, _3)) [_2;_4])
       | Right(ArgType(ty)) -> (* lots of hacks to make the right type *)
	   let fty = mk_ty (Array (Some _3, ty.Ast_c.p_type)) [_2;_4] in
	   let pty = { ty with p_type = fty } in
	   Right(ArgType pty)
       | _ -> raise (Impossible 88)
     )
# 3931 "parsing_c/parser_c.ml"
               : 'new_argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 875 "parsing_c/parser_c.mly"
          ( GetRef,     _1 )
# 3938 "parsing_c/parser_c.ml"
               : 'unary_op))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 876 "parsing_c/parser_c.mly"
          ( DeRef,      _1 )
# 3945 "parsing_c/parser_c.ml"
               : 'unary_op))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 877 "parsing_c/parser_c.mly"
          ( UnPlus,     _1 )
# 3952 "parsing_c/parser_c.ml"
               : 'unary_op))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 878 "parsing_c/parser_c.mly"
          ( UnMinus,    _1 )
# 3959 "parsing_c/parser_c.ml"
               : 'unary_op))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 879 "parsing_c/parser_c.mly"
          ( Tilde,      _1 )
# 3966 "parsing_c/parser_c.ml"
               : 'unary_op))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 880 "parsing_c/parser_c.mly"
          ( Not,        _1 )
# 3973 "parsing_c/parser_c.ml"
               : 'unary_op))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 884 "parsing_c/parser_c.mly"
           ( GetRefLabel, _1 )
# 3980 "parsing_c/parser_c.ml"
               : 'unary_op))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'primary_expr) in
    Obj.repr(
# 887 "parsing_c/parser_c.mly"
                              ( _1 )
# 3987 "parsing_c/parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'postfix_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.expression) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 889 "parsing_c/parser_c.mly"
     ( mk_e(ArrayAccess (_1, _3)) [_2;_4] )
# 3997 "parsing_c/parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'postfix_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'argument_list_ne) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 891 "parsing_c/parser_c.mly"
     ( mk_e(FunCall (_1, _3)) [_2;_4] )
# 4007 "parsing_c/parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'postfix_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 892 "parsing_c/parser_c.mly"
                              ( mk_e(FunCall (_1, [])) [_2;_3] )
# 4016 "parsing_c/parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'postfix_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'ident_cpp) in
    Obj.repr(
# 893 "parsing_c/parser_c.mly"
                                 ( mk_e(RecordAccess   (_1,_3)) [_2] )
# 4025 "parsing_c/parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'postfix_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'ident_cpp) in
    Obj.repr(
# 894 "parsing_c/parser_c.mly"
                                 ( mk_e(RecordPtAccess (_1,_3)) [_2] )
# 4034 "parsing_c/parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'postfix_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 895 "parsing_c/parser_c.mly"
                              ( mk_e(Postfix (_1, Inc)) [_2] )
# 4042 "parsing_c/parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'postfix_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 896 "parsing_c/parser_c.mly"
                              ( mk_e(Postfix (_1, Dec)) [_2] )
# 4050 "parsing_c/parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : 'topar2) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.fullType) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'tcpar2) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 900 "parsing_c/parser_c.mly"
     ( mk_e(Constructor (_2, (InitList [], [_4;_5]))) [_1;_3] )
# 4061 "parsing_c/parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 6 : 'topar2) in
    let _2 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.fullType) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : 'tcpar2) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 2 : 'initialize_list) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : 'gcc_comma_opt_struct) in
    let _7 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 902 "parsing_c/parser_c.mly"
     ( mk_e(Constructor (_2, (InitList (List.rev _5),[_4;_7] @ _6))) [_1;_3] )
# 4074 "parsing_c/parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'identifier_cpp) in
    Obj.repr(
# 906 "parsing_c/parser_c.mly"
                   ( mk_e(Ident  (_1)) [] )
# 4081 "parsing_c/parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * (Ast_c.sign * Ast_c.base)) * Ast_c.info) in
    Obj.repr(
# 908 "parsing_c/parser_c.mly"
    ( let (str,(sign,base)) = fst _1 in
      mk_e(Constant (Int (str,Si(sign,base)))) [snd _1] )
# 4089 "parsing_c/parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.floatType) * Ast_c.info) in
    Obj.repr(
# 910 "parsing_c/parser_c.mly"
           ( mk_e(Constant (Float  (fst _1))) [snd _1] )
# 4096 "parsing_c/parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.isWchar) * Ast_c.info) in
    Obj.repr(
# 911 "parsing_c/parser_c.mly"
           ( mk_e(Constant (String (fst _1))) [snd _1] )
# 4103 "parsing_c/parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : (string * Ast_c.isWchar) * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'string_fragments) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.isWchar) * Ast_c.info) in
    Obj.repr(
# 913 "parsing_c/parser_c.mly"
     ( let ((fullstring,isW),lqinfo) = _1 in
       let (_,rqinfo) = _3 in
       mk_e (Ast_c.StringConstant(_2, fullstring, isW)) [lqinfo;rqinfo] )
# 4114 "parsing_c/parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.isWchar) * Ast_c.info) in
    Obj.repr(
# 916 "parsing_c/parser_c.mly"
           ( mk_e(Constant (Char   (fst _1))) [snd _1] )
# 4121 "parsing_c/parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * string (*n*) * string (*p*)) * Ast_c.info) in
    Obj.repr(
# 917 "parsing_c/parser_c.mly"
            ( let (a,b,c) = fst _1 in
              mk_e(Constant (DecimalConst (a,b,c))) [snd _1] )
# 4129 "parsing_c/parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 919 "parsing_c/parser_c.mly"
                    ( mk_e(ParenExpr (_2)) [_1;_3] )
# 4138 "parsing_c/parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 922 "parsing_c/parser_c.mly"
                ( mk_e(Constant (MultiString [fst _1])) [snd _1] )
# 4145 "parsing_c/parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'string_elem) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'string_list) in
    Obj.repr(
# 924 "parsing_c/parser_c.mly"
     ( mk_e(Constant (MultiString ["TODO: MultiString"])) (_1 @ _2) )
# 4153 "parsing_c/parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'compound) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 927 "parsing_c/parser_c.mly"
                         ( mk_e(StatementExpr (_2)) [_1;_3] )
# 4162 "parsing_c/parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    Obj.repr(
# 930 "parsing_c/parser_c.mly"
               ( [] )
# 4168 "parsing_c/parser_c.ml"
               : 'string_fragments))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'string_fragment) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'string_fragments) in
    Obj.repr(
# 931 "parsing_c/parser_c.mly"
                                    ( _1 :: _2 )
# 4176 "parsing_c/parser_c.ml"
               : 'string_fragments))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'string_format) in
    Obj.repr(
# 934 "parsing_c/parser_c.mly"
                      ( Ast_c.FormatFragment(_2), [_1] )
# 4184 "parsing_c/parser_c.ml"
               : 'string_fragment))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 935 "parsing_c/parser_c.mly"
              ( Ast_c.ConstantFragment(fst _1), [snd _1] )
# 4191 "parsing_c/parser_c.ml"
               : 'string_fragment))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 938 "parsing_c/parser_c.mly"
           ( Ast_c.ConstantFormat(fst _1), [snd _1] )
# 4198 "parsing_c/parser_c.ml"
               : 'string_format))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 947 "parsing_c/parser_c.mly"
               ( Left _1 )
# 4205 "parsing_c/parser_c.ml"
               : 'argument_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'parameter_decl) in
    Obj.repr(
# 948 "parsing_c/parser_c.mly"
                  ( Right (ArgType _1)  )
# 4212 "parsing_c/parser_c.ml"
               : 'argument_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'action_higherordermacro_ne) in
    Obj.repr(
# 949 "parsing_c/parser_c.mly"
                              ( Right (ArgAction _1) )
# 4219 "parsing_c/parser_c.ml"
               : 'argument_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 953 "parsing_c/parser_c.mly"
               ( Left _1 )
# 4226 "parsing_c/parser_c.ml"
               : 'argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'parameter_decl) in
    Obj.repr(
# 954 "parsing_c/parser_c.mly"
                  ( Right (ArgType _1)  )
# 4233 "parsing_c/parser_c.ml"
               : 'argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'action_higherordermacro) in
    Obj.repr(
# 956 "parsing_c/parser_c.mly"
                           ( Right (ArgAction _1) )
# 4240 "parsing_c/parser_c.ml"
               : 'argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'taction_list_ne) in
    Obj.repr(
# 960 "parsing_c/parser_c.mly"
     ( if _1=[]
       then ActMisc [Ast_c.fakeInfo()]
       else ActMisc _1
     )
# 4250 "parsing_c/parser_c.ml"
               : 'action_higherordermacro_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'taction_list) in
    Obj.repr(
# 968 "parsing_c/parser_c.mly"
     ( if _1=[]
       then ActMisc [Ast_c.fakeInfo()]
       else ActMisc _1
     )
# 4260 "parsing_c/parser_c.ml"
               : 'action_higherordermacro))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cond_expr) in
    Obj.repr(
# 979 "parsing_c/parser_c.mly"
                      ( _1  )
# 4267 "parsing_c/parser_c.ml"
               : 'const_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 982 "parsing_c/parser_c.mly"
              ( et "topar2" (); _1  )
# 4274 "parsing_c/parser_c.ml"
               : 'topar2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 983 "parsing_c/parser_c.mly"
              ( et "tcpar2" (); _1 (*TODO? et ? sure ? c pas dt plutot ? *) )
# 4281 "parsing_c/parser_c.ml"
               : 'tcpar2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'statement2) in
    Obj.repr(
# 991 "parsing_c/parser_c.mly"
                      ( mk_st (fst _1) (snd _1) )
# 4288 "parsing_c/parser_c.ml"
               : Ast_c.statement))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'labeled) in
    Obj.repr(
# 994 "parsing_c/parser_c.mly"
                   ( Labeled      (fst _1), snd _1 )
# 4295 "parsing_c/parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'compound) in
    Obj.repr(
# 995 "parsing_c/parser_c.mly"
                   ( Compound     (fst _1), snd _1 )
# 4302 "parsing_c/parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'expr_statement) in
    Obj.repr(
# 996 "parsing_c/parser_c.mly"
                   ( ExprStatement(fst _1), snd _1 )
# 4309 "parsing_c/parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'selection) in
    Obj.repr(
# 997 "parsing_c/parser_c.mly"
                   ( Selection    (fst _1), snd _1 @ [postfakeInfo(snd _1)] )
# 4316 "parsing_c/parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'iteration) in
    Obj.repr(
# 998 "parsing_c/parser_c.mly"
                   ( Iteration    (fst _1), snd _1 @ [postfakeInfo(snd _1)] )
# 4323 "parsing_c/parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'jump) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 999 "parsing_c/parser_c.mly"
                   ( Jump         (fst _1), snd _1 @ [_2] )
# 4331 "parsing_c/parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'asmbody) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1002 "parsing_c/parser_c.mly"
                                                ( Asm _3, [_1;_2;_4;_5] )
# 4342 "parsing_c/parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : 'asmbody) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1003 "parsing_c/parser_c.mly"
                                                ( Asm _4, [_1;_2;_3;_5;_6] )
# 4354 "parsing_c/parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 1006 "parsing_c/parser_c.mly"
              ( MacroStmt, [snd _1] )
# 4361 "parsing_c/parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'identifier) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'exec_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1008 "parsing_c/parser_c.mly"
                                      ( Exec(_3), [_1;snd _2;_4] )
# 4371 "parsing_c/parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'ident_cpp) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'sw_stat_or_decl) in
    Obj.repr(
# 1015 "parsing_c/parser_c.mly"
                                              ( Label (_1, _3),  [_2] )
# 4380 "parsing_c/parser_c.ml"
               : 'labeled))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'const_expr) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'sw_stat_or_decl) in
    Obj.repr(
# 1016 "parsing_c/parser_c.mly"
                                              ( Case (_2, _4),       [_1; _3] )
# 4390 "parsing_c/parser_c.ml"
               : 'labeled))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : 'const_expr) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : 'const_expr) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : 'sw_stat_or_decl) in
    Obj.repr(
# 1018 "parsing_c/parser_c.mly"
     ( CaseRange (_2, _4, _6), [_1;_3;_5] )
# 4402 "parsing_c/parser_c.ml"
               : 'labeled))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'sw_stat_or_decl) in
    Obj.repr(
# 1019 "parsing_c/parser_c.mly"
                                         ( Default _3,             [_1; _2] )
# 4411 "parsing_c/parser_c.ml"
               : 'labeled))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl) in
    Obj.repr(
# 1022 "parsing_c/parser_c.mly"
             ( mk_st (Decl (_1 Ast_c.LocalDecl)) Ast_c.noii )
# 4418 "parsing_c/parser_c.ml"
               : 'sw_stat_or_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1023 "parsing_c/parser_c.mly"
             ( _1 )
# 4425 "parsing_c/parser_c.ml"
               : 'sw_stat_or_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'ident_cpp) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1034 "parsing_c/parser_c.mly"
     ( Label (_1, (mk_st (ExprStatement None) Ast_c.noii)), [_2] )
# 4433 "parsing_c/parser_c.ml"
               : 'end_labeled))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'const_expr) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1036 "parsing_c/parser_c.mly"
     ( Case (_2, (mk_st (ExprStatement None) Ast_c.noii)), [_1;_3] )
# 4442 "parsing_c/parser_c.ml"
               : 'end_labeled))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1038 "parsing_c/parser_c.mly"
     ( Default (mk_st (ExprStatement None) Ast_c.noii),    [_1; _2] )
# 4450 "parsing_c/parser_c.ml"
               : 'end_labeled))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'tobrace) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'compound2) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace) in
    Obj.repr(
# 1044 "parsing_c/parser_c.mly"
                                    ( _2, [_1; _3]  )
# 4459 "parsing_c/parser_c.ml"
               : 'compound))
; (fun __caml_parser_env ->
    Obj.repr(
# 1056 "parsing_c/parser_c.mly"
                     ( ([]) )
# 4465 "parsing_c/parser_c.ml"
               : 'compound2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'stat_or_decl_list) in
    Obj.repr(
# 1057 "parsing_c/parser_c.mly"
                     ( _1 )
# 4472 "parsing_c/parser_c.ml"
               : 'compound2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'stat_or_decl) in
    Obj.repr(
# 1061 "parsing_c/parser_c.mly"
                                  ( [_1] )
# 4479 "parsing_c/parser_c.ml"
               : 'stat_or_decl_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'end_labeled) in
    Obj.repr(
# 1063 "parsing_c/parser_c.mly"
                ( [StmtElem (mk_st (Labeled  (fst _1)) (snd _1))] )
# 4486 "parsing_c/parser_c.ml"
               : 'stat_or_decl_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'stat_or_decl) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'stat_or_decl_list) in
    Obj.repr(
# 1065 "parsing_c/parser_c.mly"
                                  ( _1 :: _2 )
# 4494 "parsing_c/parser_c.ml"
               : 'stat_or_decl_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl) in
    Obj.repr(
# 1068 "parsing_c/parser_c.mly"
             ( StmtElem (mk_st (Decl (_1 Ast_c.LocalDecl)) Ast_c.noii) )
# 4501 "parsing_c/parser_c.ml"
               : 'stat_or_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1069 "parsing_c/parser_c.mly"
             ( StmtElem _1 )
# 4508 "parsing_c/parser_c.ml"
               : 'stat_or_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'function_definition) in
    Obj.repr(
# 1072 "parsing_c/parser_c.mly"
                       ( StmtElem (mk_st (NestedFunc _1) Ast_c.noii) )
# 4515 "parsing_c/parser_c.ml"
               : 'stat_or_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_directive) in
    Obj.repr(
# 1076 "parsing_c/parser_c.mly"
     ( CppDirectiveStmt _1 )
# 4522 "parsing_c/parser_c.ml"
               : 'stat_or_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_ifdef_directive) in
    Obj.repr(
# 1078 "parsing_c/parser_c.mly"
     ( IfdefStmt _1 )
# 4529 "parsing_c/parser_c.ml"
               : 'stat_or_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1082 "parsing_c/parser_c.mly"
                ( None,    [_1] )
# 4536 "parsing_c/parser_c.ml"
               : 'expr_statement))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.expression) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1083 "parsing_c/parser_c.mly"
                ( Some _1, [_2] )
# 4544 "parsing_c/parser_c.ml"
               : 'expr_statement))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.expression) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_ifdef_statement) in
    Obj.repr(
# 1087 "parsing_c/parser_c.mly"
     ( If (_3, _5, (mk_st (ExprStatement None) Ast_c.noii)),   [_1;_2;_4] )
# 4555 "parsing_c/parser_c.ml"
               : 'selection))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 6 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.expression) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 2 : 'cpp_ifdef_statement) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _7 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_ifdef_statement) in
    Obj.repr(
# 1089 "parsing_c/parser_c.mly"
     ( If (_3, _5, _7),  [_1;_2;_4;_6] )
# 4568 "parsing_c/parser_c.ml"
               : 'selection))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.expression) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1091 "parsing_c/parser_c.mly"
     ( Switch (_3,_5),   [_1;_2;_4]  )
# 4579 "parsing_c/parser_c.ml"
               : 'selection))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 8 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 7 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 6 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.expression) in
    let _5 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.statement) in
    let _7 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _8 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _9 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1094 "parsing_c/parser_c.mly"
     ( Ifdef_Ite (_4,_6,_9), [_1;_2;_3;_5;_7;_8] )
# 4594 "parsing_c/parser_c.ml"
               : 'selection))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 10 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 9 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 8 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 7 : Ast_c.expression) in
    let _5 = (Parsing.peek_val __caml_parser_env 6 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.statement) in
    let _7 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _8 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _9 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.statement) in
    let _10 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _11 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1097 "parsing_c/parser_c.mly"
     ( Ifdef_Ite2 (_4,_6,_9,_11), [_1;_2;_3;_5;_7;_8;_10] )
# 4611 "parsing_c/parser_c.ml"
               : 'selection))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.expression) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_ifdef_statement) in
    Obj.repr(
# 1101 "parsing_c/parser_c.mly"
     ( While (_3,_5),                [_1;_2;_4] )
# 4622 "parsing_c/parser_c.ml"
               : 'iteration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 6 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.statement) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.expression) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _7 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1103 "parsing_c/parser_c.mly"
     ( DoWhile (_2,_5),              [_1;_3;_4;_6;_7] )
# 4635 "parsing_c/parser_c.ml"
               : 'iteration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : 'expr_statement) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : 'expr_statement) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_ifdef_statement) in
    Obj.repr(
# 1105 "parsing_c/parser_c.mly"
     ( For (ForExp _3,_4,(None, []),_6),    [_1;_2;_5])
# 4647 "parsing_c/parser_c.ml"
               : 'iteration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 6 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : 'expr_statement) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : 'expr_statement) in
    let _5 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.expression) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _7 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_ifdef_statement) in
    Obj.repr(
# 1107 "parsing_c/parser_c.mly"
     ( For (ForExp _3,_4,(Some _5, []),_7), [_1;_2;_6] )
# 4660 "parsing_c/parser_c.ml"
               : 'iteration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : 'decl) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : 'expr_statement) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_ifdef_statement) in
    Obj.repr(
# 1110 "parsing_c/parser_c.mly"
     ( For (ForDecl (_3 Ast_c.LocalDecl),_4,(None, []),_6),    [_1;_2;_5])
# 4672 "parsing_c/parser_c.ml"
               : 'iteration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 6 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : 'decl) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : 'expr_statement) in
    let _5 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.expression) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _7 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_ifdef_statement) in
    Obj.repr(
# 1112 "parsing_c/parser_c.mly"
     ( For (ForDecl (_3 Ast_c.LocalDecl),_4,(Some _5, []),_7), [_1;_2;_6] )
# 4685 "parsing_c/parser_c.ml"
               : 'iteration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : (string * Ast_c.info)) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list_ne) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_ifdef_statement) in
    Obj.repr(
# 1115 "parsing_c/parser_c.mly"
     ( MacroIteration (fst _1, _3, _5), [snd _1;_2;_4] )
# 4696 "parsing_c/parser_c.ml"
               : 'iteration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : (string * Ast_c.info)) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_ifdef_statement) in
    Obj.repr(
# 1117 "parsing_c/parser_c.mly"
     ( MacroIteration (fst _1, [], _4), [snd _1;_2;_3] )
# 4706 "parsing_c/parser_c.ml"
               : 'iteration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'ident_cpp) in
    Obj.repr(
# 1121 "parsing_c/parser_c.mly"
                    ( Goto (_2),  [_1] )
# 4714 "parsing_c/parser_c.ml"
               : 'jump))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1122 "parsing_c/parser_c.mly"
                ( Continue,       [_1] )
# 4721 "parsing_c/parser_c.ml"
               : 'jump))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1123 "parsing_c/parser_c.mly"
                ( Break,          [_1] )
# 4728 "parsing_c/parser_c.ml"
               : 'jump))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1124 "parsing_c/parser_c.mly"
                ( Return,         [_1] )
# 4735 "parsing_c/parser_c.ml"
               : 'jump))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.expression) in
    Obj.repr(
# 1125 "parsing_c/parser_c.mly"
                ( ReturnExpr _2,  [_1] )
# 4743 "parsing_c/parser_c.ml"
               : 'jump))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.expression) in
    Obj.repr(
# 1126 "parsing_c/parser_c.mly"
                   ( GotoComputed _3, [_1;_2] )
# 4752 "parsing_c/parser_c.ml"
               : 'jump))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.isWchar) * Ast_c.info) in
    Obj.repr(
# 1134 "parsing_c/parser_c.mly"
           ( [snd _1] )
# 4759 "parsing_c/parser_c.ml"
               : 'string_elem))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 1136 "parsing_c/parser_c.mly"
                ( [snd _1] )
# 4766 "parsing_c/parser_c.ml"
               : 'string_elem))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'string_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'colon_asm_list) in
    Obj.repr(
# 1140 "parsing_c/parser_c.mly"
                               ( _1, _2 )
# 4774 "parsing_c/parser_c.ml"
               : 'asmbody))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'string_list) in
    Obj.repr(
# 1141 "parsing_c/parser_c.mly"
               ( _1, [] )
# 4781 "parsing_c/parser_c.ml"
               : 'asmbody))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'colon_option_list) in
    Obj.repr(
# 1144 "parsing_c/parser_c.mly"
                                     ( Colon _2, [_1]   )
# 4789 "parsing_c/parser_c.ml"
               : 'colon_asm))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.isWchar) * Ast_c.info) in
    Obj.repr(
# 1147 "parsing_c/parser_c.mly"
                                ( ColonMisc, [snd _1] )
# 4796 "parsing_c/parser_c.ml"
               : 'colon_option))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : (string * Ast_c.isWchar) * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'asm_expr) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1148 "parsing_c/parser_c.mly"
                                ( ColonExpr _3, [snd _1; _2;_4] )
# 4806 "parsing_c/parser_c.ml"
               : 'colon_option))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 6 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 5 : 'identifier) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : (string * Ast_c.isWchar) * Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : 'asm_expr) in
    let _7 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1151 "parsing_c/parser_c.mly"
     ( ColonExpr _6, [_1;snd _2;_3;snd _4; _5; _7 ] )
# 4819 "parsing_c/parser_c.ml"
               : 'colon_option))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'identifier) in
    Obj.repr(
# 1152 "parsing_c/parser_c.mly"
                                    ( ColonMisc, [snd _1] )
# 4826 "parsing_c/parser_c.ml"
               : 'colon_option))
; (fun __caml_parser_env ->
    Obj.repr(
# 1153 "parsing_c/parser_c.mly"
                                    ( ColonMisc, [] )
# 4832 "parsing_c/parser_c.ml"
               : 'colon_option))
; (fun __caml_parser_env ->
    Obj.repr(
# 1157 "parsing_c/parser_c.mly"
                ( [] )
# 4838 "parsing_c/parser_c.ml"
               : 'exec_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'identifier_cpp) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'exec_ident) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'exec_list) in
    Obj.repr(
# 1159 "parsing_c/parser_c.mly"
      ( (ExecEval (_3 (mk_e (Ident _2) [])), [_1]) :: _4 )
# 4848 "parsing_c/parser_c.ml"
               : 'exec_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'exec_ident2) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'exec_list) in
    Obj.repr(
# 1161 "parsing_c/parser_c.mly"
      ( (ExecToken, [snd _1]) :: _2 @ _3 )
# 4857 "parsing_c/parser_c.ml"
               : 'exec_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'token) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'exec_list) in
    Obj.repr(
# 1162 "parsing_c/parser_c.mly"
                    ( (ExecToken, [_1]) :: _2 )
# 4865 "parsing_c/parser_c.ml"
               : 'exec_list))
; (fun __caml_parser_env ->
    Obj.repr(
# 1165 "parsing_c/parser_c.mly"
    ( function prev -> prev )
# 4871 "parsing_c/parser_c.ml"
               : 'exec_ident))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : string * Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'exec_ident) in
    Obj.repr(
# 1167 "parsing_c/parser_c.mly"
     ( function prev ->
       let fld = RegularName (mk_string_wrap _2) in
       _3 (mk_e(RecordAccess   (prev,fld)) [_1]) )
# 4882 "parsing_c/parser_c.ml"
               : 'exec_ident))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : string * Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'exec_ident) in
    Obj.repr(
# 1171 "parsing_c/parser_c.mly"
     ( function prev ->
       let fld = RegularName (mk_string_wrap _2) in
       _3 (mk_e(RecordPtAccess   (prev,fld)) [_1]) )
# 4893 "parsing_c/parser_c.ml"
               : 'exec_ident))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'exec_ident) in
    Obj.repr(
# 1175 "parsing_c/parser_c.mly"
     ( function prev ->
       _4 (mk_e(ArrayAccess   (prev,_2)) [_1;_3]) )
# 4904 "parsing_c/parser_c.ml"
               : 'exec_ident))
; (fun __caml_parser_env ->
    Obj.repr(
# 1179 "parsing_c/parser_c.mly"
    ( [] )
# 4910 "parsing_c/parser_c.ml"
               : 'exec_ident2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : string * Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'exec_ident2) in
    Obj.repr(
# 1181 "parsing_c/parser_c.mly"
    ( (ExecToken, [_1]) :: (ExecToken, [snd _2]) :: _3 )
# 4919 "parsing_c/parser_c.ml"
               : 'exec_ident2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 1183 "parsing_c/parser_c.mly"
                      ( _1 )
# 4926 "parsing_c/parser_c.ml"
               : 'asm_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1186 "parsing_c/parser_c.mly"
            ( _1 )
# 4933 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1187 "parsing_c/parser_c.mly"
            ( _1 )
# 4940 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1188 "parsing_c/parser_c.mly"
            ( _1 )
# 4947 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1189 "parsing_c/parser_c.mly"
            ( _1 )
# 4954 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1190 "parsing_c/parser_c.mly"
            ( _1 )
# 4961 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1191 "parsing_c/parser_c.mly"
            ( _1 )
# 4968 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1192 "parsing_c/parser_c.mly"
            ( _1 )
# 4975 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1193 "parsing_c/parser_c.mly"
            ( _1 )
# 4982 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1194 "parsing_c/parser_c.mly"
            ( _1 )
# 4989 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1195 "parsing_c/parser_c.mly"
            ( _1 )
# 4996 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.assignOp) in
    Obj.repr(
# 1196 "parsing_c/parser_c.mly"
            ( List.hd (snd _1) )
# 5003 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1198 "parsing_c/parser_c.mly"
            ( _1 )
# 5010 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1199 "parsing_c/parser_c.mly"
            ( _1 )
# 5017 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1200 "parsing_c/parser_c.mly"
            ( _1 )
# 5024 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1201 "parsing_c/parser_c.mly"
            ( _1 )
# 5031 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1202 "parsing_c/parser_c.mly"
            ( _1 )
# 5038 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1203 "parsing_c/parser_c.mly"
            ( _1 )
# 5045 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1205 "parsing_c/parser_c.mly"
            ( _1 )
# 5052 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1206 "parsing_c/parser_c.mly"
            ( _1 )
# 5059 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1207 "parsing_c/parser_c.mly"
            ( _1 )
# 5066 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1208 "parsing_c/parser_c.mly"
            ( _1 )
# 5073 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1209 "parsing_c/parser_c.mly"
            ( _1 )
# 5080 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1210 "parsing_c/parser_c.mly"
            ( _1 )
# 5087 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1211 "parsing_c/parser_c.mly"
            ( _1 )
# 5094 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1213 "parsing_c/parser_c.mly"
            ( _1 )
# 5101 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1214 "parsing_c/parser_c.mly"
            ( _1 )
# 5108 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1217 "parsing_c/parser_c.mly"
            ( _1 )
# 5115 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1218 "parsing_c/parser_c.mly"
            ( _1 )
# 5122 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1222 "parsing_c/parser_c.mly"
            ( _1 )
# 5129 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1223 "parsing_c/parser_c.mly"
            ( _1 )
# 5136 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1224 "parsing_c/parser_c.mly"
            ( _1 )
# 5143 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 1226 "parsing_c/parser_c.mly"
                 ( snd _1 )
# 5150 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1228 "parsing_c/parser_c.mly"
            ( _1 )
# 5157 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1229 "parsing_c/parser_c.mly"
            ( _1 )
# 5164 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * (Ast_c.sign * Ast_c.base)) * Ast_c.info) in
    Obj.repr(
# 1230 "parsing_c/parser_c.mly"
            ( snd _1 )
# 5171 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.floatType) * Ast_c.info) in
    Obj.repr(
# 1231 "parsing_c/parser_c.mly"
            ( snd _1 )
# 5178 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.isWchar) * Ast_c.info) in
    Obj.repr(
# 1232 "parsing_c/parser_c.mly"
            ( snd _1 )
# 5185 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.isWchar) * Ast_c.info) in
    Obj.repr(
# 1233 "parsing_c/parser_c.mly"
            ( snd _1 )
# 5192 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1244 "parsing_c/parser_c.mly"
                        ( Right3 (BaseType Void),            [_1] )
# 5199 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1245 "parsing_c/parser_c.mly"
                        ( Right3 (BaseType (IntType CChar)), [_1])
# 5206 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1246 "parsing_c/parser_c.mly"
                        ( Right3 (BaseType (IntType (Si (Signed,CInt)))), [_1])
# 5213 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1247 "parsing_c/parser_c.mly"
                        ( Right3 (BaseType (FloatType CFloat)),  [_1])
# 5220 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1248 "parsing_c/parser_c.mly"
                        ( Right3 (BaseType (FloatType CDouble)), [_1] )
# 5227 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1249 "parsing_c/parser_c.mly"
                        ( Right3 (BaseType (FloatType CFloatComplex)),  [_1;_2])
# 5235 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1250 "parsing_c/parser_c.mly"
                        ( Right3 (BaseType (FloatType CDoubleComplex)), [_1;_2] )
# 5243 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1251 "parsing_c/parser_c.mly"
                        ( Right3 (BaseType SizeType),            [_1] )
# 5250 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1252 "parsing_c/parser_c.mly"
                        ( Right3 (BaseType SSizeType),           [_1] )
# 5257 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1253 "parsing_c/parser_c.mly"
                        ( Right3 (BaseType PtrDiffType),         [_1] )
# 5264 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1254 "parsing_c/parser_c.mly"
                        ( Middle3 Short,  [_1])
# 5271 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1255 "parsing_c/parser_c.mly"
                        ( Middle3 Long,   [_1])
# 5278 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1256 "parsing_c/parser_c.mly"
                        ( Left3 Signed,   [_1])
# 5285 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1257 "parsing_c/parser_c.mly"
                        ( Left3 UnSigned, [_1])
# 5292 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'struct_or_union_spec) in
    Obj.repr(
# 1258 "parsing_c/parser_c.mly"
                        ( Right3 (fst _1), snd _1 )
# 5299 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'enum_spec) in
    Obj.repr(
# 1259 "parsing_c/parser_c.mly"
                        ( Right3 (fst _1), snd _1 )
# 5306 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : 'const_expr) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : 'const_expr) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1261 "parsing_c/parser_c.mly"
     ( Right3 (Decimal(_3,Some _5)), [_1;_2;_4;_6] )
# 5318 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'const_expr) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1263 "parsing_c/parser_c.mly"
     ( Right3 (Decimal(_3,None)), [_1;_2;_4] )
# 5328 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 1279 "parsing_c/parser_c.mly"
     ( let name = RegularName (mk_string_wrap _1) in
       Right3 (TypeName (name, Ast_c.noTypedefDef())),[] )
# 5336 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'assign_expr) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1282 "parsing_c/parser_c.mly"
                                   ( Right3 (TypeOfExpr (_3)), [_1;_2;_4] )
# 5346 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.fullType) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1283 "parsing_c/parser_c.mly"
                                   ( Right3 (TypeOfType (_3)), [_1;_2;_4] )
# 5356 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_spec2) in
    Obj.repr(
# 1289 "parsing_c/parser_c.mly"
                         ( dt "type" (); _1   )
# 5363 "parsing_c/parser_c.ml"
               : 'type_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1296 "parsing_c/parser_c.mly"
             ( {const=true  ; volatile=false}, _1 )
# 5370 "parsing_c/parser_c.ml"
               : 'type_qualif))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1297 "parsing_c/parser_c.mly"
             ( {const=false ; volatile=true},  _1 )
# 5377 "parsing_c/parser_c.ml"
               : 'type_qualif))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1299 "parsing_c/parser_c.mly"
             ( (* TODO *) {const=false ; volatile=false},  _1 )
# 5384 "parsing_c/parser_c.ml"
               : 'type_qualif))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1307 "parsing_c/parser_c.mly"
                                    ( raise Todo )
# 5393 "parsing_c/parser_c.ml"
               : 'attribute))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 1309 "parsing_c/parser_c.mly"
              ( Attribute (fst _1), [snd _1] )
# 5400 "parsing_c/parser_c.ml"
               : 'attribute))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'pointer) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'direct_d) in
    Obj.repr(
# 1324 "parsing_c/parser_c.mly"
                    ( let (attr,ptr) = _1 in
                      (attr, (fst _2, fun x -> x +> ptr +> (snd _2))) )
# 5409 "parsing_c/parser_c.ml"
               : 'declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'direct_d) in
    Obj.repr(
# 1326 "parsing_c/parser_c.mly"
                    ( (Ast_c.noattr, _1)  )
# 5416 "parsing_c/parser_c.ml"
               : 'declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'tmul) in
    Obj.repr(
# 1330 "parsing_c/parser_c.mly"
                          ( (Ast_c.noattr,fun x -> mk_ty (Pointer x) [_1]) )
# 5423 "parsing_c/parser_c.ml"
               : 'pointer))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'tmul) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'pointer) in
    Obj.repr(
# 1332 "parsing_c/parser_c.mly"
     ( let (attr,ptr) = _2 in
       (attr,fun x -> mk_ty (Pointer (ptr x)) [_1]) )
# 5432 "parsing_c/parser_c.ml"
               : 'pointer))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'tmul) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'type_qualif_list) in
    Obj.repr(
# 1335 "parsing_c/parser_c.mly"
     ( let (attr,tq) = _2 in
       (attr,fun x -> (tq.qualifD, mk_tybis (Pointer x) [_1])))
# 5441 "parsing_c/parser_c.ml"
               : 'pointer))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'tmul) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'type_qualif_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'pointer) in
    Obj.repr(
# 1338 "parsing_c/parser_c.mly"
     ( let (attr1,tq) = _2 in
       let (attr2,ptr) = _3 in
       (attr1@attr2,fun x -> (tq.qualifD, mk_tybis (Pointer (ptr x)) [_1])) )
# 5452 "parsing_c/parser_c.ml"
               : 'pointer))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1343 "parsing_c/parser_c.mly"
        ( _1 )
# 5459 "parsing_c/parser_c.ml"
               : 'tmul))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1345 "parsing_c/parser_c.mly"
     ( if !Flag.c_plus_plus
     then _1
     else
       let i = Ast_c.parse_info_of_info _1 in
       raise (Semantic("& not allowed in C types, try -c++ option", i)) )
# 5470 "parsing_c/parser_c.ml"
               : 'tmul))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'identifier_cpp) in
    Obj.repr(
# 1354 "parsing_c/parser_c.mly"
     ( (_1, fun x -> x) )
# 5477 "parsing_c/parser_c.ml"
               : 'direct_d))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'declarator) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1356 "parsing_c/parser_c.mly"
     ( let (attr,dec) = _2 in  (* attr gets ignored... *)
       (fst dec, fun x -> mk_ty (ParenType ((snd dec) x)) [_1;_3]) )
# 5487 "parsing_c/parser_c.ml"
               : 'direct_d))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'direct_d) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'tocro) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'tccro) in
    Obj.repr(
# 1359 "parsing_c/parser_c.mly"
     ( (fst _1,fun x->(snd _1) (mk_ty (Array (None,x)) [_2;_3])) )
# 5496 "parsing_c/parser_c.ml"
               : 'direct_d))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'direct_d) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'tocro) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'const_expr) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tccro) in
    Obj.repr(
# 1361 "parsing_c/parser_c.mly"
     ( (fst _1,fun x->(snd _1) (mk_ty (Array (Some _3,x)) [_2;_4])) )
# 5506 "parsing_c/parser_c.ml"
               : 'direct_d))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'direct_d) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'topar) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'tcpar) in
    Obj.repr(
# 1363 "parsing_c/parser_c.mly"
     ( (fst _1,
       fun x->(snd _1)
         (mk_ty (FunctionType (x,(([],(false, []))))) [_2;_3]))
     )
# 5518 "parsing_c/parser_c.ml"
               : 'direct_d))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'direct_d) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'topar) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'parameter_type_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tcpar) in
    Obj.repr(
# 1368 "parsing_c/parser_c.mly"
     ( (fst _1,fun x->(snd _1)
       (mk_ty (FunctionType (x, _3)) [_2;_4]))
     )
# 5530 "parsing_c/parser_c.ml"
               : 'direct_d))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1377 "parsing_c/parser_c.mly"
             ( et "tocro" ();_1 )
# 5537 "parsing_c/parser_c.ml"
               : 'tocro))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1378 "parsing_c/parser_c.mly"
             ( dt "tccro" ();_1 )
# 5544 "parsing_c/parser_c.ml"
               : 'tccro))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'pointer) in
    Obj.repr(
# 1382 "parsing_c/parser_c.mly"
                                      ( snd _1 )
# 5551 "parsing_c/parser_c.ml"
               : 'abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'direct_abstract_declarator) in
    Obj.repr(
# 1383 "parsing_c/parser_c.mly"
                                      ( _1 )
# 5558 "parsing_c/parser_c.ml"
               : 'abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'pointer) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'direct_abstract_declarator) in
    Obj.repr(
# 1384 "parsing_c/parser_c.mly"
                                      ( fun x -> x +> _2 +> (snd _1) )
# 5566 "parsing_c/parser_c.ml"
               : 'abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'abstract_declarator) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1388 "parsing_c/parser_c.mly"
     ( fun x -> mk_ty (ParenType (_2 x)) [_1;_3] )
# 5575 "parsing_c/parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1391 "parsing_c/parser_c.mly"
     ( fun x -> mk_ty (Array (None, x)) [_1;_2] )
# 5583 "parsing_c/parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'const_expr) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1393 "parsing_c/parser_c.mly"
     ( fun x -> mk_ty (Array (Some _2, x)) [_1;_3] )
# 5592 "parsing_c/parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'direct_abstract_declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1395 "parsing_c/parser_c.mly"
     ( fun x -> _1 (mk_ty (Array (None, x))  [_2;_3]) )
# 5601 "parsing_c/parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'direct_abstract_declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'const_expr) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1397 "parsing_c/parser_c.mly"
     ( fun x -> _1 (mk_ty (Array (Some _3,x))  [_2;_4]) )
# 5611 "parsing_c/parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1399 "parsing_c/parser_c.mly"
     ( fun x -> mk_ty (FunctionType (x, ([], (false,  [])))) [_1;_2] )
# 5619 "parsing_c/parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'topar) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'parameter_type_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'tcpar) in
    Obj.repr(
# 1401 "parsing_c/parser_c.mly"
     ( fun x -> mk_ty (FunctionType (x, _2))  [_1;_3] )
# 5628 "parsing_c/parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'direct_abstract_declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'topar) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'tcpar) in
    Obj.repr(
# 1412 "parsing_c/parser_c.mly"
     ( fun x -> _1 (mk_ty (FunctionType (x, (([], (false, []))))) [_2;_3]) )
# 5637 "parsing_c/parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'direct_abstract_declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'topar) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'parameter_type_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tcpar) in
    Obj.repr(
# 1414 "parsing_c/parser_c.mly"
     ( fun x -> _1 (mk_ty (FunctionType (x, _3)) [_2;_4]) )
# 5647 "parsing_c/parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'parameter_list) in
    Obj.repr(
# 1420 "parsing_c/parser_c.mly"
                                   ( (_1, (false, [])))
# 5654 "parsing_c/parser_c.ml"
               : 'parameter_type_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'parameter_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1421 "parsing_c/parser_c.mly"
                                   ( (_1, (true,  [_2;_3])) )
# 5663 "parsing_c/parser_c.ml"
               : 'parameter_type_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 1425 "parsing_c/parser_c.mly"
            (
     let name = RegularName (mk_string_wrap _1) in
     LP.add_ident (str_of_name name);
     { p_namei = Some name;
       p_type = mk_ty NoType [];
       p_register = (false, []);
     }
   )
# 5677 "parsing_c/parser_c.ml"
               : 'parameter_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'decl_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'declaratorp) in
    Obj.repr(
# 1434 "parsing_c/parser_c.mly"
     ( LP.kr_impossible();
       let ((returnType,hasreg),iihasreg) = fixDeclSpecForParam (snd _1) in
       let (name, ftyp) = _2 in
       { p_namei = Some (name);
         p_type = ftyp returnType;
         p_register = (hasreg, iihasreg);
       }
     )
# 5692 "parsing_c/parser_c.ml"
               : 'parameter_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'decl_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'abstract_declaratorp) in
    Obj.repr(
# 1443 "parsing_c/parser_c.mly"
     ( LP.kr_impossible();
       let ((returnType,hasreg), iihasreg) = fixDeclSpecForParam (snd _1) in
       { p_namei = None;
         p_type = _2 returnType;
         p_register = hasreg, iihasreg;
       }
     )
# 5706 "parsing_c/parser_c.ml"
               : 'parameter_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec) in
    Obj.repr(
# 1451 "parsing_c/parser_c.mly"
     ( LP.kr_impossible();
       let ((returnType,hasreg), iihasreg) = fixDeclSpecForParam (snd _1) in
       { p_namei = None;
         p_type = returnType;
         p_register = hasreg, iihasreg;
       }
     )
# 5719 "parsing_c/parser_c.ml"
               : 'parameter_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'parameter_decl2) in
    Obj.repr(
# 1464 "parsing_c/parser_c.mly"
                                ( et "param" ();  _1 )
# 5726 "parsing_c/parser_c.ml"
               : 'parameter_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'declarator) in
    Obj.repr(
# 1467 "parsing_c/parser_c.mly"
               ( let (attr,dec) = _1 in (* attr gets ignored *)
                 LP.add_ident (str_of_name (fst dec)); dec )
# 5734 "parsing_c/parser_c.ml"
               : 'declaratorp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'attributes) in
    Obj.repr(
# 1471 "parsing_c/parser_c.mly"
               ( let (attr,dec) = _1 in (* attr gets ignored *)
                 LP.add_ident (str_of_name (fst dec)); dec )
# 5743 "parsing_c/parser_c.ml"
               : 'declaratorp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'abstract_declarator) in
    Obj.repr(
# 1475 "parsing_c/parser_c.mly"
                       ( _1 )
# 5750 "parsing_c/parser_c.ml"
               : 'abstract_declaratorp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_spec) in
    Obj.repr(
# 1485 "parsing_c/parser_c.mly"
                                ( addTypeD (_1, nullDecl) )
# 5757 "parsing_c/parser_c.ml"
               : 'spec_qualif_list2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_qualif) in
    Obj.repr(
# 1486 "parsing_c/parser_c.mly"
                                ( {nullDecl with qualifD = (fst _1,[snd _1])})
# 5764 "parsing_c/parser_c.ml"
               : 'spec_qualif_list2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'type_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'spec_qualif_list) in
    Obj.repr(
# 1487 "parsing_c/parser_c.mly"
                                ( addTypeD (_1,_2)   )
# 5772 "parsing_c/parser_c.ml"
               : 'spec_qualif_list2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'type_qualif) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'spec_qualif_list) in
    Obj.repr(
# 1488 "parsing_c/parser_c.mly"
                                ( addQualifD (_1,_2) )
# 5780 "parsing_c/parser_c.ml"
               : 'spec_qualif_list2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'spec_qualif_list2) in
    Obj.repr(
# 1490 "parsing_c/parser_c.mly"
                                               (  dt "spec_qualif" (); _1 )
# 5787 "parsing_c/parser_c.ml"
               : 'spec_qualif_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_qualif) in
    Obj.repr(
# 1495 "parsing_c/parser_c.mly"
               ( (Ast_c.noattr,{nullDecl with qualifD = (fst _1,[snd _1])}) )
# 5794 "parsing_c/parser_c.ml"
               : 'type_qualif_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'attribute) in
    Obj.repr(
# 1496 "parsing_c/parser_c.mly"
                                ( ([_1],nullDecl) )
# 5801 "parsing_c/parser_c.ml"
               : 'type_qualif_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'type_qualif_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'type_qualif) in
    Obj.repr(
# 1497 "parsing_c/parser_c.mly"
                                ( (fst _1,addQualifD (_2,snd _1)) )
# 5809 "parsing_c/parser_c.ml"
               : 'type_qualif_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'type_qualif_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'attribute) in
    Obj.repr(
# 1498 "parsing_c/parser_c.mly"
                                ( ((fst _1)@[_2],snd _1) )
# 5817 "parsing_c/parser_c.ml"
               : 'type_qualif_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'spec_qualif_list) in
    Obj.repr(
# 1506 "parsing_c/parser_c.mly"
     ( let (returnType, _) = fixDeclSpecForDecl _1 in  returnType )
# 5824 "parsing_c/parser_c.ml"
               : Ast_c.fullType))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'spec_qualif_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'abstract_declaratort) in
    Obj.repr(
# 1508 "parsing_c/parser_c.mly"
     ( let (returnType, _) = fixDeclSpecForDecl _1 in _2 returnType )
# 5832 "parsing_c/parser_c.ml"
               : Ast_c.fullType))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'abstract_declarator) in
    Obj.repr(
# 1513 "parsing_c/parser_c.mly"
                       ( _1 )
# 5839 "parsing_c/parser_c.ml"
               : 'abstract_declaratort))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'decl_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1523 "parsing_c/parser_c.mly"
     ( function local ->
       let (returnType,storage) = fixDeclSpecForDecl (snd _1) in
       let iistart = Ast_c.fakeInfo () in
       DeclList ([{v_namei = None; v_type = returnType;
                   v_storage = unwrap storage; v_local = local;
                   v_attr = fst _1; v_endattr = Ast_c.noattr;
                   v_type_bis = ref None;
                },[]],
                (_2::iistart::snd storage))
     )
# 5856 "parsing_c/parser_c.ml"
               : 'decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'decl_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'init_declarator_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1534 "parsing_c/parser_c.mly"
     ( function local ->
       let (returnType,storage) = fixDeclSpecForDecl (snd _1) in
       let iistart = Ast_c.fakeInfo () in
       DeclList (
         (_2 +> List.map (fun ((((name,f),attrs,endattrs), ini), iivirg) ->
           let s = str_of_name name in
	   if fst (unwrap storage) = StoTypedef
	   then LP.add_typedef s;
           {v_namei = Some (name, ini);
            v_type = f returnType;
            v_storage = unwrap storage;
            v_local = local;
            v_attr = (fst _1)@attrs;
            v_endattr = endattrs;
            v_type_bis = ref None;
           },
           iivirg
         )
         ),  (_3::iistart::snd storage))
     )
# 5884 "parsing_c/parser_c.ml"
               : 'decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : 'storage_const_opt) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : (string * Ast_c.info)) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1557 "parsing_c/parser_c.mly"
     ( function _ ->
       match _1 with
	 Some (sto,stoii) ->
	   MacroDecl
	     ((sto, fst _2, _4, true), (snd _2::_3::_5::_6::fakeInfo()::stoii))
       | None ->
	   MacroDecl
	     ((NoSto, fst _2, _4, true), [snd _2;_3;_5;_6;fakeInfo()]) )
# 5903 "parsing_c/parser_c.ml"
               : 'decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 7 : 'storage_const_opt) in
    let _2 = (Parsing.peek_val __caml_parser_env 6 : (string * Ast_c.info)) in
    let _3 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 4 : 'argument_list) in
    let _5 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 2 : 'teq) in
    let _7 = (Parsing.peek_val __caml_parser_env 1 : 'initialize) in
    let _8 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1568 "parsing_c/parser_c.mly"
     ( function _ ->
       match _1 with
	 Some (sto,stoii) ->
	   MacroDeclInit
	     ((sto, fst _2, _4, _7),
	      (snd _2::_3::_5::_6::_8::fakeInfo()::stoii))
       | None ->
	   MacroDeclInit
	     ((NoSto, fst _2, _4, _7), [snd _2;_3;_5;_6;_8;fakeInfo()]) )
# 5925 "parsing_c/parser_c.ml"
               : 'decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'storage_class_spec_nt) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1579 "parsing_c/parser_c.mly"
                                         ( Some (fst _1,[snd _1; _2]) )
# 5933 "parsing_c/parser_c.ml"
               : 'storage_const_opt))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'storage_class_spec_nt) in
    Obj.repr(
# 1580 "parsing_c/parser_c.mly"
                         ( Some (fst _1,[snd _1]) )
# 5940 "parsing_c/parser_c.ml"
               : 'storage_const_opt))
; (fun __caml_parser_env ->
    Obj.repr(
# 1581 "parsing_c/parser_c.mly"
                         ( None )
# 5946 "parsing_c/parser_c.ml"
               : 'storage_const_opt))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'storage_class_spec) in
    Obj.repr(
# 1585 "parsing_c/parser_c.mly"
                      ( ([], {nullDecl with storageD = (fst _1, [snd _1]) }) )
# 5953 "parsing_c/parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_spec) in
    Obj.repr(
# 1586 "parsing_c/parser_c.mly"
                      ( ([], addTypeD (_1,nullDecl)) )
# 5960 "parsing_c/parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_qualif) in
    Obj.repr(
# 1587 "parsing_c/parser_c.mly"
                      ( ([], {nullDecl with qualifD  = (fst _1, [snd _1]) }) )
# 5967 "parsing_c/parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1588 "parsing_c/parser_c.mly"
                      ( ([], {nullDecl with inlineD = (true, [_1]) }) )
# 5974 "parsing_c/parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'attribute) in
    Obj.repr(
# 1589 "parsing_c/parser_c.mly"
                      ( ([_1], nullDecl) )
# 5981 "parsing_c/parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'storage_class_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec2) in
    Obj.repr(
# 1590 "parsing_c/parser_c.mly"
                                 ( (fst _2, addStorageD (_1, snd _2)) )
# 5989 "parsing_c/parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'type_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec2) in
    Obj.repr(
# 1591 "parsing_c/parser_c.mly"
                                 ( (fst _2, addTypeD    (_1, snd _2)) )
# 5997 "parsing_c/parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'type_qualif) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec2) in
    Obj.repr(
# 1592 "parsing_c/parser_c.mly"
                                 ( (fst _2, addQualifD  (_1, snd _2)) )
# 6005 "parsing_c/parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec2) in
    Obj.repr(
# 1593 "parsing_c/parser_c.mly"
                                 ( (fst _2, addInlineD ((true, _1), snd _2)) )
# 6013 "parsing_c/parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'attribute) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec2) in
    Obj.repr(
# 1594 "parsing_c/parser_c.mly"
                                 ( (_1::(fst _2), snd _2) )
# 6021 "parsing_c/parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1602 "parsing_c/parser_c.mly"
                ( Sto Static,  _1 )
# 6028 "parsing_c/parser_c.ml"
               : 'storage_class_spec_nt))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1603 "parsing_c/parser_c.mly"
                ( Sto Extern,  _1 )
# 6035 "parsing_c/parser_c.ml"
               : 'storage_class_spec_nt))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1604 "parsing_c/parser_c.mly"
                ( Sto Auto,    _1 )
# 6042 "parsing_c/parser_c.ml"
               : 'storage_class_spec_nt))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1605 "parsing_c/parser_c.mly"
                ( Sto Register,_1 )
# 6049 "parsing_c/parser_c.ml"
               : 'storage_class_spec_nt))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'storage_class_spec_nt) in
    Obj.repr(
# 1608 "parsing_c/parser_c.mly"
                         ( _1 )
# 6056 "parsing_c/parser_c.ml"
               : 'storage_class_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1609 "parsing_c/parser_c.mly"
                ( StoTypedef,  _1 )
# 6063 "parsing_c/parser_c.ml"
               : 'storage_class_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl2) in
    Obj.repr(
# 1616 "parsing_c/parser_c.mly"
                         ( et "decl" (); _1 )
# 6070 "parsing_c/parser_c.ml"
               : 'decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec2) in
    Obj.repr(
# 1617 "parsing_c/parser_c.mly"
                         ( dt "declspec" (); _1  )
# 6077 "parsing_c/parser_c.ml"
               : 'decl_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'declaratori) in
    Obj.repr(
# 1623 "parsing_c/parser_c.mly"
                                ( (_1, NoInit) )
# 6084 "parsing_c/parser_c.ml"
               : 'init_declarator2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'declaratori) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'teq) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'initialize) in
    Obj.repr(
# 1624 "parsing_c/parser_c.mly"
                                ( (_1, ValInit(_2, _3)) )
# 6093 "parsing_c/parser_c.ml"
               : 'init_declarator2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'declaratori) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'argument_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1627 "parsing_c/parser_c.mly"
     ( (_1, ConstrInit(_3,[_2;_4])) )
# 6103 "parsing_c/parser_c.ml"
               : 'init_declarator2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1633 "parsing_c/parser_c.mly"
          ( et "teq" (); _1 )
# 6110 "parsing_c/parser_c.ml"
               : 'teq))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'init_declarator2) in
    Obj.repr(
# 1635 "parsing_c/parser_c.mly"
                                   ( dt "init" (); _1 )
# 6117 "parsing_c/parser_c.ml"
               : 'init_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'declarator) in
    Obj.repr(
# 1644 "parsing_c/parser_c.mly"
     ( let (attr,dec) = _1 in
       LP.add_ident (str_of_name (fst dec)); dec, attr, [] )
# 6125 "parsing_c/parser_c.ml"
               : 'declaratori))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'gcc_asm_decl) in
    Obj.repr(
# 1648 "parsing_c/parser_c.mly"
     ( let (attr,dec) = _1 in
       LP.add_ident (str_of_name (fst dec)); dec, attr, [] )
# 6134 "parsing_c/parser_c.ml"
               : 'declaratori))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'end_attributes) in
    Obj.repr(
# 1652 "parsing_c/parser_c.mly"
     ( let (attr,dec) = _1 in
       LP.add_ident (str_of_name (fst dec)); dec, attr, _2 (* TODO *) )
# 6143 "parsing_c/parser_c.ml"
               : 'declaratori))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'asmbody) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1657 "parsing_c/parser_c.mly"
                                         (  )
# 6153 "parsing_c/parser_c.ml"
               : 'gcc_asm_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'asmbody) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1658 "parsing_c/parser_c.mly"
                                        (  )
# 6164 "parsing_c/parser_c.ml"
               : 'gcc_asm_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 1664 "parsing_c/parser_c.mly"
     ( InitExpr _1,                [] )
# 6171 "parsing_c/parser_c.ml"
               : 'initialize))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'tobrace_ini) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'initialize_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'gcc_comma_opt_struct) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace_ini) in
    Obj.repr(
# 1666 "parsing_c/parser_c.mly"
     ( InitList (List.rev _2),     [_1;_4] @ _3 )
# 6181 "parsing_c/parser_c.ml"
               : 'initialize))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'tobrace_ini) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace_ini) in
    Obj.repr(
# 1668 "parsing_c/parser_c.mly"
     ( InitList [],       [_1;_2] )
# 6189 "parsing_c/parser_c.ml"
               : 'initialize))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'initialize2) in
    Obj.repr(
# 1679 "parsing_c/parser_c.mly"
                                      ( [_1,   []] )
# 6196 "parsing_c/parser_c.ml"
               : 'initialize_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'initialize_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'initialize2) in
    Obj.repr(
# 1680 "parsing_c/parser_c.mly"
                                      ( (_3,  [_2])::_1 )
# 6205 "parsing_c/parser_c.ml"
               : 'initialize_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cond_expr) in
    Obj.repr(
# 1686 "parsing_c/parser_c.mly"
     ( InitExpr _1,   [] )
# 6212 "parsing_c/parser_c.ml"
               : 'initialize2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'tobrace_ini) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'initialize_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'gcc_comma_opt_struct) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace_ini) in
    Obj.repr(
# 1688 "parsing_c/parser_c.mly"
     ( InitList (List.rev _2),   [_1;_4] @ _3 )
# 6222 "parsing_c/parser_c.ml"
               : 'initialize2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'tobrace_ini) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace_ini) in
    Obj.repr(
# 1690 "parsing_c/parser_c.mly"
     ( InitList [],  [_1;_2]  )
# 6230 "parsing_c/parser_c.ml"
               : 'initialize2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'designator_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'initialize2) in
    Obj.repr(
# 1694 "parsing_c/parser_c.mly"
     ( InitDesignators (_1, _3), [_2] )
# 6239 "parsing_c/parser_c.ml"
               : 'initialize2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'ident) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'initialize2) in
    Obj.repr(
# 1698 "parsing_c/parser_c.mly"
     ( InitFieldOld (fst _1, _3),     [snd _1; _2] )
# 6248 "parsing_c/parser_c.ml"
               : 'initialize2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'ident) in
    Obj.repr(
# 1709 "parsing_c/parser_c.mly"
     ( DesignatorField (fst _2), [_1;snd _2] )
# 6256 "parsing_c/parser_c.ml"
               : 'designator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'const_expr) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1711 "parsing_c/parser_c.mly"
     ( DesignatorIndex (_2),  [_1;_3] )
# 6265 "parsing_c/parser_c.ml"
               : 'designator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : 'const_expr) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'const_expr) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1713 "parsing_c/parser_c.mly"
     ( DesignatorRange (_2, _4),  [_1;_3;_5] )
# 6276 "parsing_c/parser_c.ml"
               : 'designator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1721 "parsing_c/parser_c.mly"
          (  [_1] )
# 6283 "parsing_c/parser_c.ml"
               : 'gcc_comma_opt_struct))
; (fun __caml_parser_env ->
    Obj.repr(
# 1722 "parsing_c/parser_c.mly"
                    (  [Ast_c.fakeInfo() +> Ast_c.rewrap_str ","]  )
# 6289 "parsing_c/parser_c.ml"
               : 'gcc_comma_opt_struct))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : 'struct_or_union) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : 'ident) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'tobrace_struct) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'struct_decl_list_gcc) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace_struct) in
    Obj.repr(
# 1737 "parsing_c/parser_c.mly"
     ( StructUnion (fst _1, Some (fst _2), _4),  [snd _1;snd _2;_3;_5]  )
# 6300 "parsing_c/parser_c.ml"
               : 's_or_u_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'struct_or_union) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'tobrace_struct) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'struct_decl_list_gcc) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace_struct) in
    Obj.repr(
# 1739 "parsing_c/parser_c.mly"
     ( StructUnion (fst _1, None, _3), [snd _1;_2;_4] )
# 6310 "parsing_c/parser_c.ml"
               : 's_or_u_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'struct_or_union) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'ident) in
    Obj.repr(
# 1741 "parsing_c/parser_c.mly"
     ( StructUnionName (fst _1, fst _2), [snd _1;snd _2] )
# 6318 "parsing_c/parser_c.ml"
               : 's_or_u_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1744 "parsing_c/parser_c.mly"
             ( Struct, _1 )
# 6325 "parsing_c/parser_c.ml"
               : 'struct_or_union2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1745 "parsing_c/parser_c.mly"
             ( Union, _1 )
# 6332 "parsing_c/parser_c.ml"
               : 'struct_or_union2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'attributes) in
    Obj.repr(
# 1747 "parsing_c/parser_c.mly"
                        ( Struct, _1 (* TODO *) )
# 6340 "parsing_c/parser_c.ml"
               : 'struct_or_union2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'attributes) in
    Obj.repr(
# 1748 "parsing_c/parser_c.mly"
                        ( Union, _1  (* TODO *) )
# 6348 "parsing_c/parser_c.ml"
               : 'struct_or_union2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'field_declaration) in
    Obj.repr(
# 1753 "parsing_c/parser_c.mly"
                     ( DeclarationField _1 )
# 6355 "parsing_c/parser_c.ml"
               : 'struct_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1754 "parsing_c/parser_c.mly"
           ( EmptyField _1  )
# 6362 "parsing_c/parser_c.ml"
               : 'struct_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : 'identifier) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1760 "parsing_c/parser_c.mly"
     ( MacroDeclField ((fst _1, _3), [snd _1;_2;_4;_5;fakeInfo()]) )
# 6373 "parsing_c/parser_c.ml"
               : 'struct_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : (string * Ast_c.info)) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1763 "parsing_c/parser_c.mly"
     ( MacroDeclField ((fst _1, _3), [snd _1;_2;_4;_5;fakeInfo()]) )
# 6384 "parsing_c/parser_c.ml"
               : 'struct_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_directive) in
    Obj.repr(
# 1767 "parsing_c/parser_c.mly"
     ( CppDirectiveStruct _1 )
# 6391 "parsing_c/parser_c.ml"
               : 'struct_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_ifdef_directive) in
    Obj.repr(
# 1769 "parsing_c/parser_c.mly"
     ( IfdefStruct _1 )
# 6398 "parsing_c/parser_c.ml"
               : 'struct_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'spec_qualif_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'struct_declarator_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1774 "parsing_c/parser_c.mly"
     (
       let (returnType,storage) = fixDeclSpecForDecl _1 in
       if fst (unwrap storage) <> NoSto
       then internal_error "parsing don't allow this";

       let iistart = Ast_c.fakeInfo () in (* for parallelism with DeclList *)
       FieldDeclList (_2 +> (List.map (fun (f, iivirg) ->
         f returnType, iivirg))
                         ,[_3;iistart])
         (* don't need to check if typedef or func initialised cos
          * grammar don't allow typedef nor initialiser in struct
          *)
     )
# 6419 "parsing_c/parser_c.ml"
               : 'field_declaration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'spec_qualif_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1789 "parsing_c/parser_c.mly"
     (
       (* gccext: allow empty elements if it is a structdef or enumdef *)
       let (returnType,storage) = fixDeclSpecForDecl _1 in
       if fst (unwrap storage) <> NoSto
       then internal_error "parsing don't allow this";

       let iistart = Ast_c.fakeInfo () in (* for parallelism with DeclList *)
       FieldDeclList ([(Simple (None, returnType)) , []], [_2;iistart])
     )
# 6435 "parsing_c/parser_c.ml"
               : 'field_declaration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'declaratorsd) in
    Obj.repr(
# 1805 "parsing_c/parser_c.mly"
     ( (fun x -> Simple   (Some (fst _1), (snd _1) x)) )
# 6442 "parsing_c/parser_c.ml"
               : 'struct_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'dotdot) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'const_expr2) in
    Obj.repr(
# 1807 "parsing_c/parser_c.mly"
     ( (fun x -> BitField (None, x, _1, _2)) )
# 6450 "parsing_c/parser_c.ml"
               : 'struct_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'declaratorsd) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'dotdot) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'const_expr2) in
    Obj.repr(
# 1809 "parsing_c/parser_c.mly"
     ( (fun x -> BitField (Some (fst _1), ((snd _1) x), _2, _3)) )
# 6459 "parsing_c/parser_c.ml"
               : 'struct_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'declarator) in
    Obj.repr(
# 1817 "parsing_c/parser_c.mly"
     ( let (attr,dec) = _1 in (* attr ignored *)
       (*also ? LP.add_ident (fst (fst dec)); *) dec )
# 6467 "parsing_c/parser_c.ml"
               : 'declaratorsd))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'attributes) in
    Obj.repr(
# 1820 "parsing_c/parser_c.mly"
                           ( let (attr,dec) = _1 in dec )
# 6475 "parsing_c/parser_c.ml"
               : 'declaratorsd))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 's_or_u_spec2) in
    Obj.repr(
# 1825 "parsing_c/parser_c.mly"
                                   ( dt "su" (); _1 )
# 6482 "parsing_c/parser_c.ml"
               : 'struct_or_union_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'struct_or_union2) in
    Obj.repr(
# 1826 "parsing_c/parser_c.mly"
                                  ( et "su" (); _1 )
# 6489 "parsing_c/parser_c.ml"
               : 'struct_or_union))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'struct_decl2) in
    Obj.repr(
# 1827 "parsing_c/parser_c.mly"
                           ( et "struct" (); _1 )
# 6496 "parsing_c/parser_c.ml"
               : 'struct_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1829 "parsing_c/parser_c.mly"
                 ( et "dotdot" (); _1 )
# 6503 "parsing_c/parser_c.ml"
               : 'dotdot))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'const_expr) in
    Obj.repr(
# 1830 "parsing_c/parser_c.mly"
                        ( dt "const_expr2" (); _1 )
# 6510 "parsing_c/parser_c.ml"
               : 'const_expr2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'struct_decl_list) in
    Obj.repr(
# 1833 "parsing_c/parser_c.mly"
                     ( _1 )
# 6517 "parsing_c/parser_c.ml"
               : 'struct_decl_list_gcc))
; (fun __caml_parser_env ->
    Obj.repr(
# 1834 "parsing_c/parser_c.mly"
                         ( [] )
# 6523 "parsing_c/parser_c.ml"
               : 'struct_decl_list_gcc))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : 'tobrace_enum) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'enumerator_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'gcc_comma_opt_struct) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace_enum) in
    Obj.repr(
# 1842 "parsing_c/parser_c.mly"
     ( Enum (None,    _3),           [_1;_2;_5] @ _4 )
# 6534 "parsing_c/parser_c.ml"
               : 'enum_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : 'ident) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : 'tobrace_enum) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : 'enumerator_list) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : 'gcc_comma_opt_struct) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace_enum) in
    Obj.repr(
# 1844 "parsing_c/parser_c.mly"
     ( Enum (Some (fst _2), _4),     [_1; snd _2; _3;_6] @ _5 )
# 6546 "parsing_c/parser_c.ml"
               : 'enum_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'ident) in
    Obj.repr(
# 1846 "parsing_c/parser_c.mly"
     ( EnumName (fst _2),       [_1; snd _2] )
# 6554 "parsing_c/parser_c.ml"
               : 'enum_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'idente) in
    Obj.repr(
# 1849 "parsing_c/parser_c.mly"
                          ( _1, None     )
# 6561 "parsing_c/parser_c.ml"
               : 'enumerator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'idente) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'const_expr) in
    Obj.repr(
# 1850 "parsing_c/parser_c.mly"
                          ( _1, Some (_2, _3) )
# 6570 "parsing_c/parser_c.ml"
               : 'enumerator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'ident_cpp) in
    Obj.repr(
# 1857 "parsing_c/parser_c.mly"
                  ( LP.add_ident (str_of_name _1); _1 )
# 6577 "parsing_c/parser_c.ml"
               : 'idente))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'function_def) in
    Obj.repr(
# 1864 "parsing_c/parser_c.mly"
                                     ( fixFunc _1 )
# 6584 "parsing_c/parser_c.ml"
               : 'function_definition))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl) in
    Obj.repr(
# 1867 "parsing_c/parser_c.mly"
                  ( [_1 Ast_c.LocalDecl]   )
# 6591 "parsing_c/parser_c.ml"
               : 'decl_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'decl_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'decl) in
    Obj.repr(
# 1868 "parsing_c/parser_c.mly"
                  ( _1 @ [_2 Ast_c.LocalDecl] )
# 6599 "parsing_c/parser_c.ml"
               : 'decl_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_directive) in
    Obj.repr(
# 1872 "parsing_c/parser_c.mly"
                                    ( )
# 6606 "parsing_c/parser_c.ml"
               : 'cpp_directive_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'cpp_directive_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_directive) in
    Obj.repr(
# 1873 "parsing_c/parser_c.mly"
                                    ( )
# 6614 "parsing_c/parser_c.ml"
               : 'cpp_directive_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'start_fun) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'compound) in
    Obj.repr(
# 1876 "parsing_c/parser_c.mly"
                           ( LP.del_scope(); (_1, _2, None) )
# 6622 "parsing_c/parser_c.ml"
               : 'function_def))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'start_fun) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'cpp_directive_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'compound) in
    Obj.repr(
# 1877 "parsing_c/parser_c.mly"
                                         ( LP.del_scope(); (_1, _3, None) )
# 6631 "parsing_c/parser_c.ml"
               : 'function_def))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'start_fun) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'decl_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'compound) in
    Obj.repr(
# 1878 "parsing_c/parser_c.mly"
                                     (
     (* TODO: undo the typedef added ? *)
     LP.del_scope();
     (_1, _3, Some _2)
   )
# 6644 "parsing_c/parser_c.ml"
               : 'function_def))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'start_fun2) in
    Obj.repr(
# 1885 "parsing_c/parser_c.mly"
  ( LP.new_scope();
    fix_add_params_ident _1;
    (* toreput? !LP._lexer_hint.toplevel <- false;  *)
    _1
  )
# 6655 "parsing_c/parser_c.ml"
               : 'start_fun))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'decl_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'declaratorfd) in
    Obj.repr(
# 1892 "parsing_c/parser_c.mly"
     ( let (returnType,storage) = fixDeclSpecForFuncDef (snd _1) in
       let (id, attrs) = _2 in
       (fst id, fixOldCDecl ((snd id) returnType) , storage, (fst _1)@attrs)
     )
# 6666 "parsing_c/parser_c.ml"
               : 'start_fun2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'ctor_dtor) in
    Obj.repr(
# 1896 "parsing_c/parser_c.mly"
               ( _1 )
# 6673 "parsing_c/parser_c.ml"
               : 'start_fun2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'topar) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'tcpar) in
    Obj.repr(
# 1899 "parsing_c/parser_c.mly"
                                (
     let id = RegularName (mk_string_wrap _1) in
     let ret = mk_ty NoType [] in
     let ty = mk_ty (FunctionType (ret, (([], (false, []))))) [_2;_3] in
     let storage = ((NoSto,false),[]) in
     let attrs = [] in
     (id, ty, storage, attrs) )
# 6688 "parsing_c/parser_c.ml"
               : 'ctor_dtor))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'topar) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'parameter_type_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tcpar) in
    Obj.repr(
# 1906 "parsing_c/parser_c.mly"
                                                    (
     let id = RegularName (mk_string_wrap _1) in
     let ret = mk_ty NoType [] in
     let ty = mk_ty (FunctionType (ret, _3)) [_2;_4] in
     let storage = ((NoSto,false),[]) in
     let attrs = [] in
     (id, ty, storage, attrs) )
# 6704 "parsing_c/parser_c.ml"
               : 'ctor_dtor))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'declarator) in
    Obj.repr(
# 1928 "parsing_c/parser_c.mly"
   ( et "declaratorfd" (); let (attr,dec) = _1 in dec, attr )
# 6711 "parsing_c/parser_c.ml"
               : 'declaratorfd))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'end_attributes) in
    Obj.repr(
# 1931 "parsing_c/parser_c.mly"
   ( et "declaratorfd" (); let (attr,dec) = _1 in dec, attr )
# 6719 "parsing_c/parser_c.ml"
               : 'declaratorfd))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : (Ast_c.info * bool ref)) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 1940 "parsing_c/parser_c.mly"
     (
       let (i1, in_ifdef) = _1 in
       let (s, i2) = _2 in

       (* redo some lexing work :( *)
       let inc_file =
         match () with
         | _ when s =~ "^\"\\(.*\\)\"$" ->
             Local (Common.split "/" (matched1 s))
         | _ when s =~ "^\\<\\(.*\\)\\>$" ->
             NonLocal (Common.split "/" (matched1 s))
         | _ ->
             Weird s
       in
       Include { i_include = (inc_file, [i1;i2]);
                 i_rel_pos = Ast_c.noRelPos();
                 i_overall_rel_pos = Ast_c.noRelPos();
                 i_is_in_ifdef = !in_ifdef;
                 i_content = Ast_c.noi_content;
       }
     )
# 6747 "parsing_c/parser_c.ml"
               : 'cpp_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : (string * Ast_c.info)) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'define_val) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1963 "parsing_c/parser_c.mly"
     ( Define ((fst _2, [_1; snd _2;_4]), (DefineVar, _3)) )
# 6757 "parsing_c/parser_c.ml"
               : 'cpp_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 6 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 5 : (string * Ast_c.info)) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : 'param_define_list) in
    let _5 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : 'define_val) in
    let _7 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1970 "parsing_c/parser_c.mly"
     ( Define
         ((fst _2, [_1; snd _2; _7]),
           (DefineFunc (_4, [_3;_5]), _6))
     )
# 6773 "parsing_c/parser_c.ml"
               : 'cpp_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : (string * Ast_c.info)) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1976 "parsing_c/parser_c.mly"
     ( Define((fst _2, [_1; snd _2; _3]), (Undef,DefineEmpty)) )
# 6782 "parsing_c/parser_c.ml"
               : 'cpp_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : string * Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'pragma_strings) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1979 "parsing_c/parser_c.mly"
     ( Pragma((RegularName (mk_string_wrap _2),_3),[_1;_4]) )
# 6792 "parsing_c/parser_c.ml"
               : 'cpp_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1981 "parsing_c/parser_c.mly"
                      ( OtherDirective ([_1]) )
# 6799 "parsing_c/parser_c.ml"
               : 'cpp_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 1984 "parsing_c/parser_c.mly"
                 ( [(fst _1, [snd _1])] )
# 6806 "parsing_c/parser_c.ml"
               : 'pragma_strings))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'pragma_strings) in
    Obj.repr(
# 1985 "parsing_c/parser_c.mly"
                                ( (fst _1, [snd _1])::_2 )
# 6814 "parsing_c/parser_c.ml"
               : 'pragma_strings))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.expression) in
    Obj.repr(
# 1991 "parsing_c/parser_c.mly"
             ( DefineExpr _1 )
# 6821 "parsing_c/parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1992 "parsing_c/parser_c.mly"
             ( DefineStmt _1 )
# 6828 "parsing_c/parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl) in
    Obj.repr(
# 1993 "parsing_c/parser_c.mly"
             ( DefineStmt (mk_st (Decl (_1 Ast_c.NotLocalDecl)) Ast_c.noii) )
# 6835 "parsing_c/parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec) in
    Obj.repr(
# 2003 "parsing_c/parser_c.mly"
     ( let returnType = fixDeclSpecForMacro (snd _1) in
       DefineType returnType
     )
# 6844 "parsing_c/parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'decl_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'abstract_declarator) in
    Obj.repr(
# 2007 "parsing_c/parser_c.mly"
     ( let returnType = fixDeclSpecForMacro (snd _1) in
       let typ = _2 returnType in
       DefineType typ
     )
# 6855 "parsing_c/parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'stat_or_decl) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'stat_or_decl_list) in
    Obj.repr(
# 2019 "parsing_c/parser_c.mly"
     ( DefineMulti
	 (List.map
	    (function
		StmtElem e -> e
	      | _ -> failwith "unexpected statement for DefineMulti")
	    (_1 :: _2)) )
# 6868 "parsing_c/parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'function_definition) in
    Obj.repr(
# 2033 "parsing_c/parser_c.mly"
                       ( DefineFunction _1 )
# 6875 "parsing_c/parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : 'initialize_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'gcc_comma_opt_struct) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'comma_opt) in
    Obj.repr(
# 2036 "parsing_c/parser_c.mly"
    ( DefineInit (InitList (List.rev _2), [_1;_4] @ _3 @ _5)  )
# 6886 "parsing_c/parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.statement) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.expression) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2040 "parsing_c/parser_c.mly"
     (
       (* TOREPUT
       if fst $5 <> "0"
       then pr2 "WEIRD: in macro and have not a while(0)";
       *)
       DefineDoWhileZero ((_2,_5),   [_1;_3;_4;_6])
     )
# 6904 "parsing_c/parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'asmbody) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2048 "parsing_c/parser_c.mly"
                                         ( DefineTodo )
# 6914 "parsing_c/parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'asmbody) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2049 "parsing_c/parser_c.mly"
                                         ( DefineTodo )
# 6925 "parsing_c/parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    Obj.repr(
# 2053 "parsing_c/parser_c.mly"
                   ( DefineEmpty )
# 6931 "parsing_c/parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 2059 "parsing_c/parser_c.mly"
                        ( mk_string_wrap _1 )
# 6938 "parsing_c/parser_c.ml"
               : 'param_define))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 2060 "parsing_c/parser_c.mly"
                        ( mk_string_wrap _1 )
# 6945 "parsing_c/parser_c.ml"
               : 'param_define))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 2061 "parsing_c/parser_c.mly"
                        ( mk_string_wrap _1 )
# 6952 "parsing_c/parser_c.ml"
               : 'param_define))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2062 "parsing_c/parser_c.mly"
                        ( "...", [_1] )
# 6959 "parsing_c/parser_c.ml"
               : 'param_define))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2064 "parsing_c/parser_c.mly"
                        ( "register", [_1] )
# 6966 "parsing_c/parser_c.ml"
               : 'param_define))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'ifdef) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'cpp_ifdef_statement) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_ifdef_statement_tail) in
    Obj.repr(
# 2071 "parsing_c/parser_c.mly"
     ( IfdefStmt1 ((_1::fst _3), (_2::snd _3)), [] )
# 6975 "parsing_c/parser_c.ml"
               : 'cpp_ifdef_statement))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 2072 "parsing_c/parser_c.mly"
             (_1)
# 6982 "parsing_c/parser_c.ml"
               : 'cpp_ifdef_statement))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'ifdefelse) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'cpp_ifdef_statement) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'endif) in
    Obj.repr(
# 2075 "parsing_c/parser_c.mly"
                                       ( [_1;_3], [_2] )
# 6991 "parsing_c/parser_c.ml"
               : 'cpp_ifdef_statement_tail))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'ifdefelif) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'cpp_ifdef_statement) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_ifdef_statement_tail) in
    Obj.repr(
# 2077 "parsing_c/parser_c.mly"
   ( (_1::fst _3), (_2::snd _3) )
# 7000 "parsing_c/parser_c.ml"
               : 'cpp_ifdef_statement_tail))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (Ast_c.ifdef_guard * (int * int) option ref * Ast_c.info)) in
    Obj.repr(
# 2081 "parsing_c/parser_c.mly"
     ( let (cond,tag,ii) = _1 in
       IfdefDirective ((Ifdef cond, IfdefTag (Common.some !tag)),  [ii]) )
# 7008 "parsing_c/parser_c.ml"
               : 'ifdef))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : ((int * int) option ref * Ast_c.info)) in
    Obj.repr(
# 2086 "parsing_c/parser_c.mly"
     ( let (tag,ii) = _1 in
       IfdefDirective ((IfdefElse, IfdefTag (Common.some !tag)), [ii]) )
# 7016 "parsing_c/parser_c.ml"
               : 'ifdefelse))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (Ast_c.ifdef_guard * (int * int) option ref * Ast_c.info)) in
    Obj.repr(
# 2091 "parsing_c/parser_c.mly"
     ( let (cond,tag,ii) = _1 in
       IfdefDirective ((IfdefElseif cond, IfdefTag (Common.some !tag)), [ii]) )
# 7024 "parsing_c/parser_c.ml"
               : 'ifdefelif))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : ((int * int) option ref * Ast_c.info)) in
    Obj.repr(
# 2096 "parsing_c/parser_c.mly"
     ( let (tag,ii) = _1 in
       IfdefDirective ((IfdefEndif, IfdefTag (Common.some !tag)), [ii]) )
# 7032 "parsing_c/parser_c.ml"
               : 'endif))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'ifdef) in
    Obj.repr(
# 2100 "parsing_c/parser_c.mly"
         ( _1 )
# 7039 "parsing_c/parser_c.ml"
               : 'cpp_ifdef_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'ifdefelse) in
    Obj.repr(
# 2101 "parsing_c/parser_c.mly"
             ( _1 )
# 7046 "parsing_c/parser_c.ml"
               : 'cpp_ifdef_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'ifdefelif) in
    Obj.repr(
# 2102 "parsing_c/parser_c.mly"
             ( _1 )
# 7053 "parsing_c/parser_c.ml"
               : 'cpp_ifdef_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'endif) in
    Obj.repr(
# 2103 "parsing_c/parser_c.mly"
         ( _1 )
# 7060 "parsing_c/parser_c.ml"
               : 'cpp_ifdef_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (bool * (int * int) option ref * Ast_c.info)) in
    Obj.repr(
# 2106 "parsing_c/parser_c.mly"
     ( let (_b, tag,ii) = _1 in
       IfdefDirective ((Ifdef Gnone, IfdefTag (Common.some !tag)), [ii]) )
# 7068 "parsing_c/parser_c.ml"
               : 'cpp_ifdef_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (bool * (int * int) option ref * Ast_c.info)) in
    Obj.repr(
# 2109 "parsing_c/parser_c.mly"
     ( let (_b, tag,ii) = _1 in
       IfdefDirective ((Ifdef Gnone, IfdefTag (Common.some !tag)), [ii]) )
# 7076 "parsing_c/parser_c.ml"
               : 'cpp_ifdef_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (bool * (int * int) option ref * Ast_c.info)) in
    Obj.repr(
# 2112 "parsing_c/parser_c.mly"
     ( let (_b, tag,ii) = _1 in
       IfdefDirective ((Ifdef Gnone, IfdefTag (Common.some !tag)), [ii]) )
# 7084 "parsing_c/parser_c.ml"
               : 'cpp_ifdef_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : 'identifier) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2123 "parsing_c/parser_c.mly"
     (
       if args_are_params _3
       then
	 (* if all args are params, assume it is a prototype of a function
	    with no return type *)
	 let parameters = args_to_params _3 None in
	 let paramlist = (parameters, (false, [])) in (* no varargs *)
	 let id = RegularName (mk_string_wrap _1) in
	 let ret =
	   warning "type defaults to 'int'"
	     (mk_ty defaultInt [fakeInfo fake_pi]) in
	 let ty =
	   fixOldCDecl (mk_ty (FunctionType (ret, paramlist)) [_2;_4]) in
	 let attrs = Ast_c.noattr in
	 let sto = (NoSto, false), [] in
	 let iistart = Ast_c.fakeInfo () in
	 Declaration(
	 DeclList ([{v_namei = Some (id,NoInit); v_type = ty;
                      v_storage = unwrap sto; v_local = NotLocalDecl;
                      v_attr = attrs; v_endattr = Ast_c.noattr;
		      v_type_bis = ref None;
                    },[]],
                   (_5::iistart::snd sto)))
       else
	 Declaration
	   (MacroDecl((NoSto, fst _1, _3, true), [snd _1;_2;_4;_5;fakeInfo()]))
           (* old: MacroTop (fst $1, $3,    [snd $1;$2;$4;$5])  *)
     )
# 7122 "parsing_c/parser_c.ml"
               : 'cpp_other))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : 'identifier) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'compound) in
    Obj.repr(
# 2154 "parsing_c/parser_c.mly"
                                                 (
   let parameters = args_to_params _3 (Some (snd _1)) in
   let paramlist = (parameters, (false, [])) in (* no varargs *)
   let fninfo =
     let id = RegularName (mk_string_wrap _1) in
     let ret =
       warning "type defaults to 'int'"
	 (mk_ty defaultInt [fakeInfo fake_pi]) in
     let ty = mk_ty (FunctionType (ret, paramlist)) [_2;_4] in
     let attrs = Ast_c.noattr in
     let sto = (NoSto, false), [] in
     (id, fixOldCDecl ty, sto, attrs) in
   let fundef = fixFunc (fninfo, _5, None) in
   Definition fundef
 )
# 7147 "parsing_c/parser_c.ml"
               : 'cpp_other))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'identifier) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'argument_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2172 "parsing_c/parser_c.mly"
     ( Declaration
	 (MacroDecl ((NoSto, fst _1, _3, false), [snd _1;_2;_4;fakeInfo()])) )
# 7158 "parsing_c/parser_c.ml"
               : 'cpp_other))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'identifier) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2176 "parsing_c/parser_c.mly"
                      ( EmptyDef [snd _1;_2] )
# 7166 "parsing_c/parser_c.ml"
               : 'cpp_other))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'function_definition) in
    Obj.repr(
# 2185 "parsing_c/parser_c.mly"
                                     ( Definition _1 )
# 7173 "parsing_c/parser_c.ml"
               : 'external_declaration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl) in
    Obj.repr(
# 2186 "parsing_c/parser_c.mly"
                                     ( Declaration (_1 Ast_c.NotLocalDecl) )
# 7180 "parsing_c/parser_c.ml"
               : 'external_declaration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : string * Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'translation_unit) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2191 "parsing_c/parser_c.mly"
     ( !LP._lexer_hint.context_stack <- [LP.InTopLevel];
       Namespace (_4, [_1; snd _2; _3; _5]) )
# 7192 "parsing_c/parser_c.ml"
               : Ast_c.toplevel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'external_declaration) in
    Obj.repr(
# 2194 "parsing_c/parser_c.mly"
                                                ( _1 )
# 7199 "parsing_c/parser_c.ml"
               : Ast_c.toplevel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_directive) in
    Obj.repr(
# 2198 "parsing_c/parser_c.mly"
     ( CppTop _1 )
# 7206 "parsing_c/parser_c.ml"
               : Ast_c.toplevel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_other) in
    Obj.repr(
# 2200 "parsing_c/parser_c.mly"
     ( _1 )
# 7213 "parsing_c/parser_c.ml"
               : Ast_c.toplevel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_ifdef_directive) in
    Obj.repr(
# 2202 "parsing_c/parser_c.mly"
     ( IfdefTop _1 )
# 7220 "parsing_c/parser_c.ml"
               : Ast_c.toplevel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'asmbody) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2205 "parsing_c/parser_c.mly"
                                                ( EmptyDef [_1;_2;_4;_5] )
# 7231 "parsing_c/parser_c.ml"
               : Ast_c.toplevel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2212 "parsing_c/parser_c.mly"
              ( EmptyDef [_1] )
# 7238 "parsing_c/parser_c.ml"
               : Ast_c.toplevel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2215 "parsing_c/parser_c.mly"
              ( FinalDef _1 )
# 7245 "parsing_c/parser_c.ml"
               : Ast_c.toplevel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2224 "parsing_c/parser_c.mly"
                  ( LP.push_context LP.InFunction; LP.new_scope (); _1 )
# 7252 "parsing_c/parser_c.ml"
               : 'tobrace))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2225 "parsing_c/parser_c.mly"
                  ( LP.pop_context();              LP.del_scope (); _1 )
# 7259 "parsing_c/parser_c.ml"
               : 'tcbrace))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2227 "parsing_c/parser_c.mly"
                      ( LP.push_context LP.InEnum; _1 )
# 7266 "parsing_c/parser_c.ml"
               : 'tobrace_enum))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2228 "parsing_c/parser_c.mly"
                      ( LP.pop_context (); _1 )
# 7273 "parsing_c/parser_c.ml"
               : 'tcbrace_enum))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2230 "parsing_c/parser_c.mly"
                     ( LP.push_context LP.InInitializer; _1 )
# 7280 "parsing_c/parser_c.ml"
               : 'tobrace_ini))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2231 "parsing_c/parser_c.mly"
                     ( LP.pop_context (); _1 )
# 7287 "parsing_c/parser_c.ml"
               : 'tcbrace_ini))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2233 "parsing_c/parser_c.mly"
                        ( LP.push_context LP.InStruct; _1)
# 7294 "parsing_c/parser_c.ml"
               : 'tobrace_struct))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2234 "parsing_c/parser_c.mly"
                        ( LP.pop_context (); _1 )
# 7301 "parsing_c/parser_c.ml"
               : 'tcbrace_struct))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2240 "parsing_c/parser_c.mly"
     ( LP.new_scope ();et "topar" ();
       LP.push_context LP.InParameter;
       _1
     )
# 7311 "parsing_c/parser_c.ml"
               : 'topar))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2245 "parsing_c/parser_c.mly"
     ( LP.del_scope ();dt "tcpar" ();
       LP.pop_context ();
       _1
     )
# 7321 "parsing_c/parser_c.ml"
               : 'tcpar))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'string_elem) in
    Obj.repr(
# 2284 "parsing_c/parser_c.mly"
               ( _1 )
# 7328 "parsing_c/parser_c.ml"
               : 'string_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'string_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'string_elem) in
    Obj.repr(
# 2285 "parsing_c/parser_c.mly"
                           ( _1 @ _2 )
# 7336 "parsing_c/parser_c.ml"
               : 'string_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'colon_asm) in
    Obj.repr(
# 2288 "parsing_c/parser_c.mly"
             ( [_1] )
# 7343 "parsing_c/parser_c.ml"
               : 'colon_asm_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'colon_asm_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'colon_asm) in
    Obj.repr(
# 2289 "parsing_c/parser_c.mly"
                             ( _1 @ [_2] )
# 7351 "parsing_c/parser_c.ml"
               : 'colon_asm_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'colon_option) in
    Obj.repr(
# 2292 "parsing_c/parser_c.mly"
                ( [_1, []] )
# 7358 "parsing_c/parser_c.ml"
               : 'colon_option_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'colon_option_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'colon_option) in
    Obj.repr(
# 2293 "parsing_c/parser_c.mly"
                                         ( _1 @ [_3, [_2]] )
# 7367 "parsing_c/parser_c.ml"
               : 'colon_option_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'argument_ne) in
    Obj.repr(
# 2297 "parsing_c/parser_c.mly"
                                         ( [_1, []] )
# 7374 "parsing_c/parser_c.ml"
               : 'argument_list_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list_ne) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'argument) in
    Obj.repr(
# 2298 "parsing_c/parser_c.mly"
                                    ( _1 @ [_3,    [_2]] )
# 7383 "parsing_c/parser_c.ml"
               : 'argument_list_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'argument) in
    Obj.repr(
# 2301 "parsing_c/parser_c.mly"
                                      ( [_1, []] )
# 7390 "parsing_c/parser_c.ml"
               : 'argument_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'argument) in
    Obj.repr(
# 2302 "parsing_c/parser_c.mly"
                                 ( _1 @ [_3,    [_2]] )
# 7399 "parsing_c/parser_c.ml"
               : 'argument_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'struct_decl) in
    Obj.repr(
# 2312 "parsing_c/parser_c.mly"
                                 ( [_1] )
# 7406 "parsing_c/parser_c.ml"
               : 'struct_decl_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'struct_decl_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'struct_decl) in
    Obj.repr(
# 2313 "parsing_c/parser_c.mly"
                                 ( _1 @ [_2] )
# 7414 "parsing_c/parser_c.ml"
               : 'struct_decl_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'struct_declarator) in
    Obj.repr(
# 2317 "parsing_c/parser_c.mly"
                                                   ( [_1,           []] )
# 7421 "parsing_c/parser_c.ml"
               : 'struct_declarator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'struct_declarator_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'cpp_directive_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'struct_declarator) in
    Obj.repr(
# 2319 "parsing_c/parser_c.mly"
     ( _1 @ [_4, [_2]] )
# 7431 "parsing_c/parser_c.ml"
               : 'struct_declarator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'struct_declarator_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'struct_declarator) in
    Obj.repr(
# 2320 "parsing_c/parser_c.mly"
                                                   ( _1 @ [_3,     [_2]] )
# 7440 "parsing_c/parser_c.ml"
               : 'struct_declarator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'enumerator) in
    Obj.repr(
# 2324 "parsing_c/parser_c.mly"
                                     ( [_1,          []]   )
# 7447 "parsing_c/parser_c.ml"
               : 'enumerator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'enumerator_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'cpp_directive_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'enumerator) in
    Obj.repr(
# 2326 "parsing_c/parser_c.mly"
     ( _1 @ [_4, [_2]] )
# 7457 "parsing_c/parser_c.ml"
               : 'enumerator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'enumerator_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'enumerator) in
    Obj.repr(
# 2327 "parsing_c/parser_c.mly"
                                     ( _1 @ [_3,    [_2]] )
# 7466 "parsing_c/parser_c.ml"
               : 'enumerator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'init_declarator) in
    Obj.repr(
# 2331 "parsing_c/parser_c.mly"
                                               ( [_1,   []] )
# 7473 "parsing_c/parser_c.ml"
               : 'init_declarator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'init_declarator_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'cpp_directive_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'init_declarator) in
    Obj.repr(
# 2333 "parsing_c/parser_c.mly"
     ( _1 @ [_4, [_2]] )
# 7483 "parsing_c/parser_c.ml"
               : 'init_declarator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'init_declarator_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'init_declarator) in
    Obj.repr(
# 2334 "parsing_c/parser_c.mly"
                                               ( _1 @ [_3,     [_2]] )
# 7492 "parsing_c/parser_c.ml"
               : 'init_declarator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'parameter_decl) in
    Obj.repr(
# 2338 "parsing_c/parser_c.mly"
                                        ( [_1, []] )
# 7499 "parsing_c/parser_c.ml"
               : 'parameter_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'parameter_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'parameter_decl) in
    Obj.repr(
# 2339 "parsing_c/parser_c.mly"
                                        ( _1 @ [_3,  [_2]] )
# 7508 "parsing_c/parser_c.ml"
               : 'parameter_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2342 "parsing_c/parser_c.mly"
                           ( [_1] )
# 7515 "parsing_c/parser_c.ml"
               : 'taction_list_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'taction_list_ne) in
    Obj.repr(
# 2343 "parsing_c/parser_c.mly"
                           ( _1 :: _2 )
# 7523 "parsing_c/parser_c.ml"
               : 'taction_list_ne))
; (fun __caml_parser_env ->
    Obj.repr(
# 2351 "parsing_c/parser_c.mly"
                        ( [] )
# 7529 "parsing_c/parser_c.ml"
               : 'taction_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'taction_list) in
    Obj.repr(
# 2352 "parsing_c/parser_c.mly"
                        ( _1 :: _2 )
# 7537 "parsing_c/parser_c.ml"
               : 'taction_list))
; (fun __caml_parser_env ->
    Obj.repr(
# 2355 "parsing_c/parser_c.mly"
                   ( [] )
# 7543 "parsing_c/parser_c.ml"
               : 'param_define_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'param_define) in
    Obj.repr(
# 2356 "parsing_c/parser_c.mly"
                                          ( [_1, []] )
# 7550 "parsing_c/parser_c.ml"
               : 'param_define_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'param_define_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'param_define) in
    Obj.repr(
# 2357 "parsing_c/parser_c.mly"
                                          ( _1 @ [_3, [_2]] )
# 7559 "parsing_c/parser_c.ml"
               : 'param_define_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'designator) in
    Obj.repr(
# 2360 "parsing_c/parser_c.mly"
              ( [_1] )
# 7566 "parsing_c/parser_c.ml"
               : 'designator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'designator_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'designator) in
    Obj.repr(
# 2361 "parsing_c/parser_c.mly"
                              ( _1 @ [_2] )
# 7574 "parsing_c/parser_c.ml"
               : 'designator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'attribute) in
    Obj.repr(
# 2364 "parsing_c/parser_c.mly"
             ( [_1] )
# 7581 "parsing_c/parser_c.ml"
               : 'attribute_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'attribute_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'attribute) in
    Obj.repr(
# 2365 "parsing_c/parser_c.mly"
                            ( _1 @ [_2] )
# 7589 "parsing_c/parser_c.ml"
               : 'attribute_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'attribute_list) in
    Obj.repr(
# 2367 "parsing_c/parser_c.mly"
                           ( _1 )
# 7596 "parsing_c/parser_c.ml"
               : 'attributes))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 2370 "parsing_c/parser_c.mly"
                 ( [Attribute (fst _1), [snd _1]] )
# 7603 "parsing_c/parser_c.ml"
               : 'end_attributes))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2373 "parsing_c/parser_c.mly"
          (  [_1] )
# 7610 "parsing_c/parser_c.ml"
               : 'comma_opt))
; (fun __caml_parser_env ->
    Obj.repr(
# 2374 "parsing_c/parser_c.mly"
                    (  []  )
# 7616 "parsing_c/parser_c.ml"
               : 'comma_opt))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.expression) in
    Obj.repr(
# 2383 "parsing_c/parser_c.mly"
               ( Some _1 )
# 7623 "parsing_c/parser_c.ml"
               : 'gcc_opt_expr))
; (fun __caml_parser_env ->
    Obj.repr(
# 2384 "parsing_c/parser_c.mly"
                   ( None  )
# 7629 "parsing_c/parser_c.ml"
               : 'gcc_opt_expr))
(* Entry main *)
; (fun __caml_parser_env -> raise (Parsing.YYexit (Parsing.peek_val __caml_parser_env 0)))
(* Entry celem *)
; (fun __caml_parser_env -> raise (Parsing.YYexit (Parsing.peek_val __caml_parser_env 0)))
(* Entry statement *)
; (fun __caml_parser_env -> raise (Parsing.YYexit (Parsing.peek_val __caml_parser_env 0)))
(* Entry expr *)
; (fun __caml_parser_env -> raise (Parsing.YYexit (Parsing.peek_val __caml_parser_env 0)))
(* Entry type_name *)
; (fun __caml_parser_env -> raise (Parsing.YYexit (Parsing.peek_val __caml_parser_env 0)))
|]
let yytables =
  { Parsing.actions=yyact;
    Parsing.transl_const=yytransl_const;
    Parsing.transl_block=yytransl_block;
    Parsing.lhs=yylhs;
    Parsing.len=yylen;
    Parsing.defred=yydefred;
    Parsing.dgoto=yydgoto;
    Parsing.sindex=yysindex;
    Parsing.rindex=yyrindex;
    Parsing.gindex=yygindex;
    Parsing.tablesize=yytablesize;
    Parsing.table=yytable;
    Parsing.check=yycheck;
    Parsing.error_function=parse_error;
    Parsing.names_const=yynames_const;
    Parsing.names_block=yynames_block }
let main (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (Parsing.yyparse yytables 1 lexfun lexbuf : Ast_c.program)
let celem (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (Parsing.yyparse yytables 2 lexfun lexbuf : Ast_c.toplevel)
let statement (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (Parsing.yyparse yytables 3 lexfun lexbuf : Ast_c.statement)
let expr (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (Parsing.yyparse yytables 4 lexfun lexbuf : Ast_c.expression)
let type_name (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (Parsing.yyparse yytables 5 lexfun lexbuf : Ast_c.fullType)
